* SUBROUTINE EAGU36             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU36(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),GA(N)
      IF (NEXT.LE.32) THEN
      CALL EAGU16(N,KA,X,GA,NEXT)
      ELSE IF (NEXT.LE.62) THEN
      CALL EAGU17(N,KA,X,GA,NEXT-32)
      ELSE IF (NEXT.LE.94) THEN
      CALL UXVSET(N,0.0D 0,GA)
      CALL EAGU18(N,KA,X,GA,NEXT-62)
      ENDIF
      RETURN
      END
