* SUBROUTINE EEFU31             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR PARAMETER ESTIMATION OF DYNAMICAL
*  SYSTEMS. UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RI  YA(NE)  SOLUTION VECTOR.
*  RO  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EEFU31(NE,KE,YA,FE,NEXT)
      INTEGER NE,KE,NEXT
      $FLOAT YA(NE),FE
      $FLOAT Y(6)
      COMMON /EMPR23/ Y
      GOTO (10,10,10,10,10,10),NEXT
   10 GOTO (11,12,13),KE
   11 FE=Y(4)*YA(1)+YA(2)+0.5$P 0*Y(4)*(ABS(YA(1)-1.0$P 0)-
     & ABS(YA(1)+1.0$P 0))
      RETURN
   12 FE=Y(5)*YA(1)+YA(3)+0.5$P 0*Y(5)*(ABS(YA(1)-1.0$P 0)-
     & ABS(YA(1)+1.0$P 0))
      RETURN
   13 FE=(Y(6)+Y(3))*YA(1)+Y(2)*YA(2)+Y(1)*YA(3)+0.5$P 0*Y(6)*
     & (ABS(YA(1)-1.0$P 0)-ABS(YA(1)+1.0$P 0))
      RETURN
      END

