* SUBROUTINE EFFU13                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR CONSTRAINED MINIMIZATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU13(N,X,F,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),F,A
      $FLOAT ONE,TWO
      INTEGER I,J
      $FLOAT PI
      PARAMETER(PI=3.14159265358979323846264338$P 0)
      PARAMETER(ONE=1.0$P 0,TWO=2.0$P 0)
      F=0.0$P 0
      GOTO (10,20,30,40,50,60) NEXT
   10 CONTINUE
      I=2*(N/3)
      DO 11 J=1,I
        A=SIN(X(J))+COS(X(J))
        F=F+A
   11 CONTINUE
      RETURN
   20 CONTINUE
      F=SIN(PI*X(1)/12)*COS(PI*X(2)/16)
      RETURN
   30 CONTINUE
      I=2*(N/3)
      DO 31 J=1,I
        A=SIN(X(J))+COS(X(J))
        F=F+A
   31 CONTINUE
      RETURN
   40 CONTINUE
      I=2*(N/3)
      DO 41 J=1,I
        A=SIN(X(J))+COS(X(J))
        F=F+A
   41 CONTINUE
      RETURN
   50 CONTINUE
      I=2*(N/3)
      DO 51 J=1,I
        A=SIN(X(J))+COS(X(J))
        F=F+A
   51 CONTINUE
      RETURN
   60 CONTINUE
      F=-X(1)*X(2)*X(3)
      RETURN
      END
