* SUBROUTINE EAFU42             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU42(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),FA
      REAL*8 C
      REAL*8 Y(65)
      COMMON /EMPR42/ Y
      GOTO (10,20,30,40,50,60),NEXT
   10 FA=X(1)+X(2)*EXP(X(3)*Y(KA+10))-Y(KA)
      RETURN
   20 FA=2.0D 0+2.0D 0*KA-(EXP(KA*X(1))+EXP(KA*X(2)))
      RETURN
   30 FA=X(1)*EXP(X(2)/(DBLE(45+5*KA)+X(3)))-Y(KA)
      RETURN
   40 C=-DBLE(KA)
      FA=X(1)*EXP(C*X(3))+X(2)*EXP(C*X(4))-Y(KA)
      RETURN
   50 C=Y(KA+16)
      FA=X(1)*EXP(C*X(3))+X(2)*EXP(C*X(4))-Y(KA)
      RETURN
   60 C=LOG(DBLE(KA+11))
      FA=X(1)*EXP(C*X(3))+X(2)*EXP(C*X(4))-Y(KA)
      RETURN
      END
