* SUBROUTINE UCIDOS             ALL SYSTEMS                 03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF VECTORS DEFINED BY ACTIVE CONSTRAINTS.
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  IO  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  XS(NCA)  ACTIVE CONSTRAINT VECTOR.
*  RI  GS(NCA)  ACTIVE CONSTRAINT VECTOR.
*
      FUNCTION UCIDOS(NX,NC,NCA,IX,IC,ICA,XS,GS)
      INTEGER NX,NC,NCA,IX(NX),IC(NC),ICA(NCA)
      REAL*8 XS(NCA),GS(NCA),UCIDOS
      REAL*8 TEMP
      INTEGER I,K
      TEMP=0.0D 0
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      IF (IX(K).EQ.-1.OR.IX(K).EQ.-3) THEN
      TEMP=TEMP+XS(I)*GS(I)
      ELSE IF (IX(K).EQ.-2.OR.IX(K).EQ.-4) THEN
      TEMP=TEMP+XS(I)*GS(I)
      ENDIF
      ELSE
      IF (IC(K).EQ.-1.OR.IC(K).EQ.-3) THEN
      TEMP=TEMP+XS(I)*GS(I)
      ELSE IF (IC(K).EQ.-2.OR.IC(K).EQ.-4) THEN
      TEMP=TEMP+XS(I)*GS(I)
      ENDIF
      ENDIF
    1 CONTINUE
      UCIDOS=TEMP
      RETURN
      END
