* SUBROUTINE UKQGLL                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* FILL THE VECTOR LAM WITH THE COST FUNCTION COEFFICIENTS
* OF THE BASIC COLUMNS.
*
* PARAMETERS :
*  II  M NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  BCOL(MCOLS) NUMBERS OF THE BASIC COLUMNS.
*  RO  LAM(MCOLS) FILLED VECTOR
*  RI  C(MCOLS) COST FUNCTION
*
      SUBROUTINE UKQGLL(M,MCOLS,BCOL,LAM,C)
      INTEGER M,MCOLS,BCOL(MCOLS)
      REAL*8 LAM(MCOLS),C(MCOLS)
      INTEGER I,J
C
C     FILL VECTOR WITH COST FUNCTION
C
      DO 100 I=1,M
      J=BCOL(I)
      LAM(I)=C(J)
100   CONTINUE
      RETURN
      END
