* SUBROUTINE UKSGLK                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* FILL THE VECTOR FCIN WITH THE COLUMN COL.
*
* PARAMETERS :
*  II  M NUMBER OF ROWS.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  NZA  SIZE OF ARRAYS A/RNR.
*  II  COL FILLING COLUMN.
*  II  RNR(NZA) COLUMN INDICES OF THE CONSTRAINT MATRIX.
*  II  PRNR(MCOLS+1) POINTER VECTOR TO RNR.
*  RI  A(NZA) NUMERICAL VALUES OF THE CONSTRAINT MATRIX.
*  RO  FCIN(MCOLS) FILLED VECTOR.
*
      SUBROUTINE UKSGLK(M,MROWS,MCOLS,NZA,COL,RNR,PRNR,A,FCIN)
      INTEGER M,MROWS,MCOLS,NZA,COL,RNR(NZA),PRNR(MCOLS+1)
      REAL*8 A(NZA),FCIN(MROWS)
      INTEGER I,K
C
C     FILL VECTOR WITH COLUMN COL.
C
      DO 100 I=1,M
      FCIN(I)=0
100   CONTINUE
      DO 200 I=PRNR(COL),PRNR(COL+1)-1
      K=RNR(I)
      FCIN(K)=A(I)
200   CONTINUE
      RETURN
      END
