* FUNCTION UNRAN3                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  RANDOM NUMBER GENERATOR. RETURNS A UNIFORM DEVIATE BETWEEN 0.0
*  AND 1.0.
*
* PARAMETERS :
*  IU  IDUM  SET IDUM TO ANY NEGATIVE VALUE TO INITIALIZE OR
*            REINITIALIZE THE SEQUANCE.
*
* METHOD :
*  NUMERICAL RECEPIES (P.197-198).
*
      FUNCTION UNRAN3(IDUM)
      INTEGER IDUM
      REAL*4 UNRAN3
      INTEGER M,IA,IC
      REAL*4 RM
      PARAMETER (M=714025,IA=1366,IC=150889,RM=1.4005112E-6)
      INTEGER IR(97),IFF,IY,J
      SAVE IR,IFF,IY
      DATA IFF /0/
C
C INITIALIZE ON FIRST CALL
C
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
        IFF=1
        IDUM=MOD(IC-IDUM,M)
        DO 10 J=1,97
          IDUM=MOD(IA*IDUM+IC,M)
          IR(J)=IDUM
   10   CONTINUE
        IDUM=MOD(IA*IDUM+IC,M)
        IY=IDUM
      ENDIF
C
C START (EXCEPT ON INITIALIZATION)
C
      J=1+(97*IY)/M
      IF(J.GT.97.OR.J.LT.1) STOP
      IY=IR(J)
      UNRAN3=IY*RM
      IDUM=MOD(IA*IDUM+IC,M)
      IR(J)=IDUM
      RETURN
      END
