* SUBROUTINE UOERR1               ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PREPARATION OF ERROR PRINT.
*
* PARAMETERS
*  CI  TEXT  NAME OF THE SUBROUTINE IN WHICH THE ILLEGAL TERMINATION
*        APPEARED.
*  II  NUMBER  CAUSE OF THE ILLEGAL TERMINATION.
*
* COMMON DATA :
*  CO  TER  ERROR MESSAGE.
*
      SUBROUTINE UOERR1(TEXT,NUMBER)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      CHARACTER*6 TEXT
      INTEGER NUMBER
      TER(2:7)=TEXT
      TER(8:8)=':'
      TER( 9:44)='                                    '
      TER(45:80)='                                    '
      IF (NUMBER.LT.0) THEN
      GO TO (901,902,903,904) ABS(NUMBER)
  901 TER( 9:44)=' (-1) MAXIMUM NUMBER OF ITERATIONS :'
      TER(45:80)=' MIT TOO SMALL                      '
      RETURN
  902 TER( 9:44)=' (-2) MAXIMUM NUMBER OF FUNCTION EVA'
      TER(45:80)='LUATIONS : MFV TOO SMALL            '
      RETURN
  903 TER( 9:44)=' (-3) MAXIMUM NUMBER OF GRADIENT EVA'
      TER(45:80)='LUATIONS : MFG TOO SMALL            '
      RETURN
  904 TER( 9:44)=' (-4) MAXIMUM NUMBER OF CYCLES : MIC'
      TER(45:80)=' TOO SMALL                          '
      RETURN
      ELSE IF (NUMBER.LE.10) THEN
      GO TO (1,2,3,4,5,6,7,8,9,10) NUMBER
    1 TER(25:52)=' ( 1) BAD DECOMPOSITION             '
      RETURN
    2 TER( 9:44)=' ( 2) BAD INTERVAL IN THE OLC DIRECT'
      TER(45:80)='ION DETERMINATION                   '
      RETURN
    3 TER( 9:44)=' ( 3) MAXIMUM NUMBER OF STEPS IN THE'
      TER(45:80)=' OLC DIRECTION DETERMINATION        '
      RETURN
    4 TER( 9:44)=' ( 4) BREAKDOWN IN THE ITERATIVE MET'
      TER(45:80)='HOD                                 '
      RETURN
    5 TER( 9:44)=' ( 5) BREAKDOWN IN THE ITERATIVE MET'
      TER(45:80)='HOD                                 '
      RETURN
    6 TER( 9:44)=' ( 6) MAXIMUM NUMBER OF REDUCTIONS :'
      TER(45:80)=' MRED TOO SMALL                     '
      RETURN
    7 TER( 9:44)=' ( 7) NEGATIVE DIRECTIONAL DERIVATIV'
      TER(45:80)='E                                   '
      RETURN
    8 TER( 9:44)=' ( 8) BAD INTERVAL FOR INTERPOLATION'
      RETURN
    9 TER( 9:44)=' ( 9) BAD PREDICTION IN THE TRUST RE'
      TER(45:80)='GION METHOD                         '
      RETURN
   10 TER( 9:44)=' (10) RESTART                       '
      RETURN
      ELSE IF (NUMBER.LE.20) THEN
      GO TO (11,12,13,14,15,16,17,18,19,20) NUMBER-10
   11 TER( 9:44)=' (11) FEASIBLE SOLUTION DOES NOT EXI'
      TER(45:80)='ST                                  '
      RETURN
   12 TER( 9:44)=' (12) BOUNDED SOLUTION DOES NOT EXIS'
      TER(45:80)='T                                   '
      RETURN
   13 TER( 9:44)=' (13) FEASIBLE SOLUTION DOES NOT EXI'
      TER(45:80)='ST                                  '
      RETURN
   14 TER( 9:44)=' (14) FEASIBLE TRUST REGION DOES NOT'
      TER(45:80)=' EXIST                              '
      RETURN
   15 TER( 9:44)=' (15) INVALID SITUATION IN CONSTRAIN'
      TER(45:80)='T HANDLING                          '
      RETURN
   16 TER( 9:44)=' (16) INVALID SITUATION IN CONSTRAIN'
      TER(45:80)='T HANDLING                          '
      RETURN
   17 TER( 9:44)=' (17) LACK OF SPACE IN CONSTRAINT HA'
      TER(45:80)='NDLING : MMAX TOO SMALL             '
      RETURN
   18 TER( 9:44)=' (18) LACK OF SPACE IN CONSTRAINT HA'
      TER(45:80)='NDLING : MMAX TOO SMALL             '
      RETURN
   19 TER( 9:44)=' (19) BAD INPUT DATA                '
      RETURN
   20 TER( 9:44)=' (20) BAD INPUT DATA                '
      RETURN
      ELSE IF (NUMBER.LE.30) THEN
      GO TO (21,22,23,24,25,26,27,28,29,30) NUMBER-20
   21 TER( 9:44)=' (21) UXSGFD: NAU IS DECLARED TOO SM'
      TER(45:80)='ALL                                 '
      RETURN
   22 TER( 9:44)=' (22) UXSGFD: NZ IS DECLARED TOO SMA'
      TER(45:80)='LL                                  '
      RETURN
   23 TER( 9:44)=' (23) UXSGFD: JACOBIAN MATRIX IS TOO'
      TER(45:80)=' UNSTABLE                            '
      RETURN
   24 TER( 9:44)=' (24) UXSGFD: JACOBIAN MATRIX IS SIN'
      TER(45:80)='GULAR                               '
      RETURN
   25 TER( 9:44)=' (25) UXSGFD: NZ IS TOO SMALL FOR TH'
      TER(45:80)='E FACTOR                            '
      RETURN
   26 TER( 9:44)=' (26) UXSGFD: NAU IS TOO SMALL FOR T'
      TER(45:80)='HE FACTOR                           '
      RETURN
   27 TER( 9:44)=' (27) UXSGFD: NZ IS TOO SMALL FOR DA'
      TER(45:80)='TA MANIPULATIONS AFTER FACTORIZATION'
      RETURN
   28 TER( 9:44)=' (28) UXSGFD: COLUMN SCHEME FOR THE '
      TER(45:80)='FACTOR IS NOT CREATED: LACK OF SPACE'
      RETURN
   29 TER( 9:44)=' (29) BAD INPUT DATA                '
      RETURN
   30 TER( 9:44)=' (30) BAD INPUT DATA                '
      RETURN
      ELSE IF (NUMBER.LE.40) THEN
      GO TO (31,32,33,34,35,36,37,38,39,40) NUMBER-30
   31 TER( 9:44)=' (31) UXSGUM: NAU IS DECLARED TOO SM'
      TER(45:80)='ALL                                 '
      RETURN
   32 TER( 9:44)=' (32) UXSGUM: JACOBIAN MATRIX IS SIN'
      TER(45:80)='GULAR                               '
      RETURN
   33 TER( 9:44)=' (33) UXSGUM: FACTOR IS BADLY CONDIT'
      TER(45:80)='IONED                               '
      RETURN
   34 TER( 9:44)=' (34) UXSGUM: LITTLE SPACE FOR L-UPD'
      TER(45:80)='ATES                                '
      RETURN
   35 TER( 9:44)=' (35) UXSGUM: JACOBIAN MATRIX SINGUL'
      TER(45:80)='ARITY IS FACED                      '
      RETURN
   36 TER( 9:44)=' (36) UNBOUNDENESS IS FACED         '
      RETURN
   37 TER( 9:44)=' (37) UKLTS3: ROWS ARE NOT SPECIFIED'
      RETURN
   38 TER( 9:44)=' (38) UKLTS3: COLUMNS ARE NOT SPECIF'
      TER(45:80)='IED                                 '
      RETURN
   39 TER( 9:44)=' (39) UKLTS3: TYPE IS NOT SPECIFIED '
      RETURN
   40 TER( 9:44)=' (40) UKLTS3: TYPC IS NOT DEFINED   '
      RETURN
      ELSE IF (NUMBER.LT.50) THEN
      GO TO (41,42,43,44,45,46,47,48,49) NUMBER-40
   41 TER( 9:44)=' (41) LACK OF SPACE FOR THE CHOLESKI'
      TER(45:80)=' FACTOR : MMAX TOO SMALL            '
      RETURN
   42 TER( 9:44)=' (42) LACK OF SPACE FOR A SYMBOLIC F'
      TER(45:80)='ACTORIZATION : MMAX TOO SMALL       '
      RETURN
   43 TER( 9:44)=' (43) LACK OF SPACE FOR THE FILL-IN '
      RETURN
   44 TER( 9:44)=' (44) LACK OF SPACE FOR NUMERICAL DI'
      TER(45:80)='FFERENTIATION : M TOO SMALL         '
      RETURN
   45 TER( 9:44)=' (45) STRUCTURAL SINGULARITY DURING '
      TER(45:80)='INCOMPLETE LU FACTORIZATION         '
      RETURN
   46 TER( 9:44)=' (46) INVALID STRUCTURE FOR INCOMPLE'
      TER(45:80)='TE LU FACTORIZATION                 '
      RETURN
   47 TER( 9:44)=' (47) LACK OF SPACE IN NUMERICAL DIF'
      TER(45:80)='FERENTIATION : NVAR TOO SMALL       '
      RETURN
   48 TER( 9:44)=' (48) LACK OF SPACE IN THE INCOMPLET'
      TER(45:80)='E DECOMPOSITION : MMAX TOO SMALL    '
      RETURN
   49 TER( 9:44)=' (49) LACK OF SPACE IN THE SCHUR COM'
      TER(45:80)='PLEMENT : MMAX TOO SMALL            '
      RETURN
      ELSE IF (NUMBER.LE.60) THEN
      GO TO (50,51,52,53,54,55,56,57,58,59,60) NUMBER-49
   50 TER( 9:44)=' (50) LACK OF SPACE FOR THE FACTOR  '
      RETURN
   51 TER( 9:44)=' (51) INSUFFICIENT STORAGE FOR NONZE'
      TER(45:80)='RO SUBSCRIPTS                       '
      RETURN
   52 TER( 9:44)=' (52) LACK OF SPACE IN THE FRONTAL S'
      TER(45:80)='CHEME                               '
      RETURN
   53 TER( 9:44)=' (53) ERROR IN THE FRONTAL SCHEME   '
      RETURN
   54 TER( 9:44)=' (54) LACK OF SPACE IN THE FRONTAL S'
      TER(45:80)='CHEME                               '
      RETURN
   55 TER( 9:44)=' (55) ERROR IN THE FRONTAL SCHEME   '
      RETURN
   56 TER( 9:44)=' (56) LACK OF SPACE IN THE INTEGER F'
      TER(45:80)='IELD                                '
      RETURN
   57 TER( 9:44)=' (57) LACK OF SPACE IN THE REAL FIEL'
      TER(45:80)='D                                   '
      RETURN
   58 TER( 9:44)=' (58) ZERO INDEX                    '
      RETURN
   59 TER( 9:44)=' (59) DIMENSION ERROR               '
      RETURN
   60 TER( 9:44)=' (60) LACK OF SPACE IN THE WORKING F'
      TER(45:80)='IELD                                '
      RETURN
      ELSE IF (NUMBER.LE.70) THEN
      GO TO (61,62,63,64,65,66,67,68,69,70) NUMBER-60
   61 TER( 9:44)=' (61) INVALID MATRIX ORDER          '
      RETURN
   62 TER( 9:44)=' (62) NUMBER OF NONZEROS LESS THAN Z'
      TER(45:80)='ERO                                 '
      RETURN
   63 TER( 9:44)=' (63) INVALID ENTRIES IN THE INPUT M'
      TER(45:80)='ATRIX                               '
      RETURN
   64 TER( 9:44)=' (64) INCONSISTENT MEMORY           '
      RETURN
   65 TER( 9:44)=' (65) LACK OF SPACE IN THE INTEGER F'
      TER(45:80)='IELD : MMAX TOO SMALL               '
      RETURN
   66 TER( 9:44)=' (66) LACK OF SPACE IN THE REAL FIEL'
      TER(45:80)='D : MMAX TOO SMALL                  '
      RETURN
   67 TER( 9:44)=' (67) INVALID LU FACTORS            '
      RETURN
   68 TER( 9:44)=' (68) MAXIMUM INTEGER TOO SMALL     '
      RETURN
   69 TER( 9:44)=' (69) INVALID INPUTS                '
      RETURN
   70 TER( 9:44)=' (70) ZERO PIVOT WHEN DEFINITENESS I'
      TER(45:80)='S DECLARED                          '
      RETURN
      ELSE IF (NUMBER.LE.80) THEN
      GO TO (71,72,73,74,75,76,77,78,79,80) NUMBER-70
   71 TER( 9:44)=' (71) CHANGE IN SIGN OF PIVOT ENCOUN'
      TER(45:80)='TERED                               '
      RETURN
   72 TER( 9:44)=' (72) SINGULARITY DETECTED          '
      RETURN
   73 TER( 9:44)=' (73) NONZERO ELEMENT IGNORED       '
      RETURN
   74 TER( 9:44)=' (74) PIVOT HAS DIFFERENT SIGN FROM '
      TER(45:80)='THE PREVIOUS ONE                    '
      RETURN
   75 TER( 9:44)=' (75) LACK OF SPACE : M TOO SMALL   '
      RETURN
   76 TER( 9:44)=' (76) LACK OF SPACE : MAH TOO SMALL '
      RETURN
   77 TER( 9:44)=' (77) LACK OF SPACE : MCH TOO SMALL '
      RETURN
   78 TER( 9:44)=' (78) LACK OF SPACE : MA TOO SMALL  '
      RETURN
   79 TER( 9:44)=' (79) LACK OF SPACE : MC TOO SMALL  '
      RETURN
   80 TER( 9:44)=' (80) LACK OF SPACE : NF TOO SMALL  '
      RETURN
      ELSE IF (NUMBER.LE.90) THEN
      GO TO (81,82,83,84,85,86,87,88,89,90) NUMBER-80
   81 TER( 9:44)=' (81) LACK OF SPACE : NA TOO SMALL  '
      RETURN
   82 TER( 9:44)=' (82) LACK OF SPACE : NC TOO SMALL  '
      RETURN
   83 TER( 9:44)=' (83) SIMPLE BOUNDS ARE NOT PERMITT'
      TER(45:80)='ED                                  '
      RETURN
   84 TER( 9:44)=' (84) INEQUALITY CONSTRAINTS ARE NOT'
      TER(45:80)=' PERMITTED                          '
      RETURN
   85 TER( 9:44)=' (85) TOO MANY DENSE ROWS : MD TOO S'
      TER(45:80)='MALL                                '
      RETURN
   86 TER( 9:44)=' (86) LACK OF SPACE : MHA TOO SMALL '
      RETURN
   87 TER( 9:44)=' (87) LACK OF SPACE : MHC TOO SMALL '
      RETURN
   88 TER( 9:44)=' (88) LINEAR DEPENDENCE OF ACTIVE CO'
      TER(45:80)='NSTRAINTS                           '
      RETURN
   89 TER( 9:44)=' (89) INFEASIBLE SOLUTION           '
      RETURN
   90 TER( 9:44)=' (90) MAXIMUM NUMBER OF SIMPLEX ITER'
      TER(45:80)='ATIONS : MIS TOO SMALL              '
      RETURN
      ELSE IF (NUMBER.LE.100) THEN
      GO TO (91,92,93,94,95,96,97,98,99,100) NUMBER-90
   91 TER( 9:44)=' (91) DIFFERENTIAL EQUATION IS UNSTA'
      TER(45:80)='BLE                                 '
      RETURN
   92 TER( 9:44)=' (92) MAXIMUM NUMBER OF INTEGRATION '
      TER(45:80)='STEPS EXCEEDED                      '
      RETURN
   93 TER( 9:44)=' (93) TOO SMALL INTEGRATION STEP    '
      RETURN
   94 TER( 9:44)=' (94) DIFFERENTIAL EQUATION IS STIFF'
      RETURN
   95 TER( 9:44)=' (95) SINGULAR JACOBIAN IN IMPLICIT '
      TER(45:80)='INTEGRATION METHOD                  '
      RETURN
   96 TER( 9:44)=' (96) LACK OF SPACE IN DIFFERENTIAL '
      TER(45:80)='EQUATION SOLVER                     '
      RETURN
   97 TER( 9:44)=' (97) LACK OF SPACE : MMAX TOO SMALL'
      RETURN
   98 TER( 9:44)=' (98) MAXIMUM NUMBER OF MINOR CYCLES'
      TER(45:80)=' : MIQ TOO SMALL                    '
      RETURN
   99 TER( 9:44)=' (99) MAXIMUM NUMBER OF MAJOR CYCLES'
      TER(45:80)=' : MAQ TOO SMALL                    '
      RETURN
  100 TER( 9:44)='(100) LACK OF SPACE : MF TOO SMALL  '
      RETURN
      ELSE IF (NUMBER.LE.110) THEN
      GO TO (101,102,103,104,105,106,107,108,109,101) NUMBER-100
  101 TER( 9:44)='(101) LARGE LAGRANGIAN FUNCTION     '
      RETURN
  102 TER( 9:44)='(102) INVALID TERMINATION: EPS9 TOO '
      TER(45:80)='SMALL                               '
      RETURN
  103 TER( 9:44)='(103) FEASIBILITY RESTORATION PHASE '
      TER(45:80)='IS EXPECTED                         '
      RETURN
  104 TER( 9:44)='(104) LACK OF SPACE FOR THE HESSIAN '
      TER(45:80)='MATRIX : MMAX TOO SMALL             '
      RETURN
  105 TER( 9:44)='(105) LACK OF SPACE FOR THE PRECONDI'
      TER(45:80)='TIONER : MMAX TOO SMALL             '
      RETURN
  106 TER( 9:44)='(106) EQUATION SOLVER FAILS         '
      RETURN
  107 TER( 9:44)='(107) EIGENPROBLEM WAS NOT SOLVED   '
      RETURN
  108 TER( 9:44)='(108) ARPACK: INPUT ERROR           '
      RETURN
  109 TER( 9:44)='(109) ARPACK: NO EIGENVALUE CONVERGE'
      TER(45:80)='D                                   '
      RETURN
  110 TER( 9:44)=' (110) LACK OF SPACE : NCC TOO SMALL'
      RETURN
      ELSE IF (NUMBER.LE.120) THEN
      GO TO (111,112,113,114,115,116,117,118,119,119) NUMBER-110
  111 TER( 9:44)='(111) TWO-SIDE BOX CONSTRAINT OCCURE'
      TER(45:80)='D                                   '
      RETURN
  112 TER( 9:44)='(112) TWO-SIDE GENERAL CONSTRAINT OC'
      TER(45:80)='CURED                               '
      RETURN
  113 TER( 9:44)='(113) EQUALITY IN COMPLEMENTARITY CO'
      TER(45:80)='NSTRAINT OCCURED                    '
      RETURN
  114 TER( 9:44)='(114) COUPLED COMPLEMENTARITY CONSTR'
      TER(45:80)='AINT IS MISSING                     '
      RETURN
  115 TER( 9:44)='(115) WRONG INDEX IN COMPLEMENTARITY'
      TER(45:80)=' BOX CONSTRAINT                     '
      RETURN
  116 TER( 9:44)='(116) WRONG INDEX IN COMPLEMENTARITY'
      TER(45:80)=' GENERAL CONSTRAINT                 '
      RETURN
  117 TER( 9:44)='(117) DUPLICATE INDEX IN COMPLEMENTA'
      TER(45:80)='RITY BOX CONSTRAINT                 '
      RETURN
  118 TER( 9:44)='(118) DUPLICATE INDEX IN COMPLEMENTA'
      TER(45:80)='RITY GENERAL CONSTRAINT             '
      RETURN
  119 TER( 9:44)='(119) EQUALITY CONSTRAINTS ARE NOT P'
      TER(45:80)='ERMITTED                            '
      RETURN
      ENDIF
      END
