* LOGICAL FUNCTION UQINTM          ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  IS IT AN INTEGER CONSTANT ?
*
* PARAMETERS :
*  TI  STRARR(MLEN) - A STRING ARRAY
*  II  MLEN - MAX. LENGTH OF STRARR
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF A NUMBER IN STRARR
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF A NUMBER IN STRARR
*  LO  LSIGN - NUMBER WITH A SIGN ?
*
* SUBPROGRAMS USED :
*  LF  UQCHFG   IS CHARACTER A FIGURE ?
*
* REMARK:
*  PARAMETER 'LENINT' IS MAX. LENGTH OF AN INTEGER NUMBER
*
      LOGICAL FUNCTION UQINTM(STRARR,MLEN,IPOS1,IPOS2,LSIGN,LNUM)
      INTEGER MLEN,IPOS1,IPOS2
      LOGICAL LSIGN,LNUM
      CHARACTER*1 STRARR(MLEN)
      INTEGER I,J,K,LENINT
      LOGICAL UQCHFG
      PARAMETER(LENINT=20)
      UQINTM=.FALSE.
      LNUM=.FALSE.
      LSIGN=.FALSE.
      IF(IPOS1.GT.IPOS2) RETURN
      K=0
      DO 2 I=IPOS2,IPOS1,-1
        IF(STRARR(I).EQ.' ') THEN
          K=K+1
        ELSEIF(STRARR(I).EQ.'+'.OR.STRARR(I).EQ.'-') THEN
          DO 1 J=IPOS1,I-1
            IF(STRARR(J).NE.' ') RETURN
    1     CONTINUE
          LSIGN=.TRUE.
          GOTO 3
        ELSEIF(UQCHFG(STRARR(I))) THEN
          LNUM=.TRUE.
        ELSE
          RETURN
        ENDIF
    2 CONTINUE
    3 IF(.NOT.LNUM) RETURN
      IF(IPOS2-IPOS1-K.GT.LENINT) RETURN
      UQINTM=.TRUE.
      RETURN
      END
