* SUBROUTINE UQRDLN                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*   READ A LINE FROM THE INPUT FILE
*
* PARAMETERS :
*  TU  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  IU  LENB - ACTUAL LENGTH OF THE BUFFER
*  IU  NLINES - NUMBER OF LINES
*  II  ILNLEN - THE NUMBER OF CHARACTERS PER LINE OF INPUT
*  II  IUNIT - THE INPUT UNIT NUMBER
*  TI  CHCON - THE CONTINUATION MARKER
*  TI  CHEOL - THE END OF LINE MARKER
*  IO  IER - ERROR INDICATOR
*
      SUBROUTINE UQRDLN(BUFFER,MLENB,LENB,NLINES,ILNLEN,IUNIT,
     *                  CHCON,CHEOL,IER)
      INTEGER MLENB,LENB,NLINES,ILNLEN,IUNIT,IER
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      CHARACTER*1 BUFFER(MLENB),CHCON,CHEOL
      CHARACTER*250 LINE
      INTEGER I
    1 IF(LENB+ILNLEN.GT.MLENB) GOTO 4
      LINE = ' '
      READ(IUNIT,'(A250)',ERR=5,END=6) LINE
      DO 7 I=1,ILNLEN
        BUFFER(LENB+I)=LINE(I:I)
    7 CONTINUE
      LENB=LENB+ILNLEN
      NLINES=NLINES+1
C
C CORRECTION FROM JYVASKYLA
C
C    2 IF(BUFFER(LENB).EQ.' ') THEN
    2 IF(BUFFER(LENB).EQ.' '.OR.ICHAR(BUFFER(LENB)).LT.32.OR.
     &  ICHAR(BUFFER(LENB)).GT.127) THEN
        LENB=LENB-1
        IF(LENB.LE.0) THEN
          LENB=0
          GOTO 3
        ENDIF
        GOTO 2
      ENDIF
      IF(LENB.GE.1.AND.BUFFER(LENB).EQ.CHCON) THEN
        LENB=LENB-1
        GOTO 1
      ENDIF
    3 LENB=LENB+1
      BUFFER(LENB)=CHEOL
      RETURN
C
C ERROR: MAX. LENGTH OF THE BUFFER EXCEEDED
C
    4 IER=2
      RETURN
C
C ERROR: INPUT HARDWARE ERROR
C
    5 IER=1
      RETURN
C
C END OF FILE
C
    6 IER=3
      END
