* SUBROUTINE UXDCMI               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ROWWISE STORED DENSE RECTANGULAR MATRIX A IS SET TO BE A PART OF THE
* UNIT MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RO  A(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*          ONE-DIMENSIONAL  ARRAY. THIS MATRIX IS SET TO TRANS([I,0]).
*
      SUBROUTINE UXDCMI(N,M,A)
      INTEGER N,M
      REAL*8 A(M*N)
      INTEGER I,J,K
      REAL*8 ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      K=0
      DO 2 J=1,M
      DO 1 I=1,N
      A(I+K)=ZERO
      IF (I.EQ.J) A(I+K)=ONE
    1 CONTINUE
      K=K+N
    2 CONTINUE
      RETURN
      END
