* SUBROUTINE UXDSDA                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* A DENSE SYMMETRIC MATRIX A IS AUGMENTED BY THE SCALED UNIT MATRIX
* SUCH THAT A:=A+ALF*I (I IS THE UNIT MATRIX OF ORDER N).
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  ALF  SCALING FACTOR.
*
      SUBROUTINE UXDSDA(N,A,ALF)
      INTEGER N
      REAL*8  A(N*(N+1)/2), ALF
      INTEGER I,J
      J = 0
      DO  1  I = 1, N
      J = J + I
      A(J)=A(J)+ALF
    1 CONTINUE
      RETURN
      END
