* SUBROUTINE UXSGS2                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDS FROM UMFPACK.
*
      SUBROUTINE UXSGS2(ERROR,TAIL1,II,ABLKP,AROWP,ACOLP,
     & ACOLI,WM,LUTIP,LUTXP,LUBLP,AHIHED,AHIPRV,AHINXT,
     & ALOHED,ALOPRV,ALONXT,FP,FSONL,FLEFTR,FLEFTC,
     & PERMR,PERMC,PERM2,PERM2R,PERM2C,AHIR,AHIC,ALOR,
     & ALOC,ALEFTR,ALEFTC,AFLP,AFLPR,AFLPC,WJR,WJC,WIR,
     & WIC,XX,WX,ACOLX,MMEM,MAXINT,NHISRC,NB,
     & AFLEXT,NLOSRC,NPIV,AN,ABLKS,LUNS,ABSTOL,RELTOL,
     & GROW,PMIN,IGAR,XGAR,SYMSRC)
      INTEGER AN,ABLKS
      INTEGER MMEM(7,2),II(*),ABLKP(ABLKS+1),AROWP(AN+1),
     & ACOLP(AN+1),ACOLI(*),LUTIP(AN),LUTXP(AN),
     & LUBLP(ABLKS+1),AHIHED(AN),AHIPRV(AN),AHINXT(AN),
     & ALOHED(AN),ALOPRV(AN),ALONXT(AN),FP(AN),
     & WM(AN+1),FSONL(AN),FLEFTR(AN),FLEFTC(AN),
     & PERMR(AN),PERMC(AN),PERM2(AN,2),PERM2R(AN),
     & PERM2C(AN),AHIR(AN),AHIC(AN),ALOR(AN),ALOC(AN),
     & ALEFTR(AN),ALEFTC(AN),AFLP(AN,2),AFLPR(AN),
     & AFLPC(AN),WJR(AN),WJC(AN),WIR(AN),WIC(AN),
     & TAIL1(2,2),GARBAG(2,2)
      INTEGER COLS(20),FFIP(2),SAVE3(2,2),SAVE2(2,2),
     & P,I,J,RC,DEG,LO,HI,DEGIN,DEGOUT,FFCOL,PIVROW,
     & PIVCOL,CR,PREVP,FRDEGR,FRDEGC,FRXP,PA,NEXTP,H,
     & FRIPR,FRIPC,IP,FRLEFR,FRLEFC,NEXT,FFLEFR,FFLEFC,
     & OUTSD,P1,FEDEGR,FEDEGC,KP,K2,K,LUAXP,XUDP,XLDP,
     & XDP,XSP,BESTCO,COL,ECOL,ROW,COST,SRCHED,AFP,
     & AFP2,KK,LEFT,K1,COLUPD,IINEED,JJ,SUMOUT,MAXOUT,
     & K0,FFDEGR,FFDEGC,FFP,FFIPR,FFIPC,KLEFT1,KLAST,
     & FFXP,AMNOUT,AMXOUT,AMININ,AMAXIN,WJZERO,IMINHI,
     & MINHI,FFDIMR,FFDIMC,KLEFT,CANCOL,CANDEG,CANOFF
      INTEGER WJFLAG,TRUDEG,PH,PT,OFFSET,PH2,PT2,IIADD,IIHAVE,
     & EP,SCAN1,SCAN2,SCAN3,SCAN4,SONLST,NSONS,DEGMIN,
     & DEGMAX,AHIMAX,AHIMIN,AHICNT,ALOMAX,ALOMIN,ALOCNT,
     & ABLKNZ,MAXINT,ERROR,BIG,NHISRC,
     & NB,AFLEXT,NLOSRC,NPIV,LUPP,LUNS,KLU,SLU,
     & KBLOCK,KFIRST,AROWIP,AROWXP,KSIZE,NIL,R,C,
     & F2,S,UIP,NODE,LIP,SON,FFSONP,
     & XGAR,IGAR
      LOGICAL SGLTON,RANOUT,SYMSRC
      REAL*8 XX(*),WX(AN),ACOLX(*),UXVMX1,
     & TOLER,MAXVAL,VALUE,ABSTOL,RELTOL,
     & GROW,PMIN,ZERO,ONE
      PARAMETER (NIL = 0,R = 1,C = 2,ZERO = 0.0D 0,ONE = 1.0D 0)
        BIG = MAXINT - 3*AN - 5
        IF (BIG .LE. 0) GOTO 9996
C
C     MARK THE CURRENT LOCATION FOR LATER GARBAGE COLLECTION
C
        CALL UXIMRK(MMEM,ERROR,GARBAG)
        IF (ERROR .NE. 0) GOTO 9998
        PMIN = ZERO
        NPIV = 0
        LUNS = 0
        KBLOCK = 0
        KLU = 0
        SLU = 0
        DO 340 I = 1, AN
           WX (I) = ZERO
340        CONTINUE
C
C     FACTOR EACH BLOCK
C
9000    IF (.NOT. (KBLOCK .LT. ABLKS)) GOTO 9010
        KBLOCK = KBLOCK + 1
        KFIRST = ABLKP (KBLOCK)
        KLAST  = ABLKP (KBLOCK+1) - 1
        IF (KFIRST .EQ. KLAST) THEN
C
C     SINGLETON BLOCK
C
           LUBLP (KBLOCK) = SLU + 1
           ROW = KFIRST
           COL = KFIRST
           FFCOL = COL
C
C     ALLOCATE SPACE FOR PIVOT ROW AND COLUMN PATTERN IN II
C
           CALL UXIGET(MMEM,ERROR,1,5,1,P)
           IF (ERROR .NE. 0) GOTO 9998
           IF (P .EQ. NIL) THEN
              IGAR = IGAR + 1
              CALL UXIIGR(II,MMEM,PERM2,AFLP,FLEFTC,AN,
     &                  ERROR,GARBAG)
              IF (ERROR .NE. 0) GOTO 9998
              CALL UXIGET(MMEM,ERROR,1,5,1,P)
              IF (ERROR .NE. 0) GOTO 9998
              IF (P .EQ. NIL) GOTO 9999
              ENDIF
C
C     SAVE THE INFORMATION ABOUT THE NEW LU ARROWHEAD
C
           FP (FFCOL)  = P
           II(P) = NIL
           II((P)+1) = 1
           II((P)+2) = 0
           II((P)+3) = 0
           II((P)+4) = 0
           FLEFTR (FFCOL) = 0
           FLEFTC (FFCOL) = 0
C
C     ALLOCATE PERMANENT SPACE FOR THE NUMERICAL LU ARROWHEAD
C
           CALL UXIGET(MMEM,ERROR,2,1,1,LUAXP)
           IF (ERROR .NE. 0) GOTO 9998
           IF (LUAXP .EQ. NIL) THEN
              XGAR = XGAR + 1
              CALL UXIXGR(XX,II,MMEM,LUTIP,FP,SLU,AN,
     &                  ERROR,GARBAG)
              IF (ERROR .NE. 0) GOTO 9998
              CALL UXIGET(MMEM,ERROR,2,1,1,LUAXP)
              IF (ERROR .NE. 0) GOTO 9998
              IF (LUAXP .EQ. NIL) GOTO 9997
              ENDIF
C
C     STORE THE PIVOT ELEMENT
C
           IF (ACOLP (COL) .LT. ACOLP (COL+1)) THEN
              XX (LUAXP) = ACOLX (ACOLP (COL))
           ELSE
              XX (LUAXP) = ZERO
              ENDIF
           IF (ABS (XX (LUAXP)) .GT. ABSTOL) THEN
C
C     THIS IS A GOOD PIVOT
C
              NPIV = NPIV + 1
C
C     SAVE THE PIVOT INFORMATION
C
              PERM2R (ROW) = -KFIRST
              PERM2C (COL) = -KFIRST
           ELSE
C
C     THIS BLOCK IS SINGULAR
C
              PERM2R (ROW) = KFIRST
              PERM2C (COL) = KFIRST
              ENDIF
C
C     INCREMENT COUNT OF NUMBER OF STAGES OF
C     GAUSSIAN ELIMINATION COMPLETED
C
           KLU = KLU + 1
C
C     INCREMENT COUNT OF NUMBER OF FRONTAL MATRICES CREATED
C
           SLU = SLU + 1
C
C     SAVE POINTERS TO LU ARROWHEAD (PIVOT COLLUMN)
C
           LUTIP (AN - SLU + 1) = COL
           LUTXP (COL) = LUAXP
        ELSE
C
C     OTHERWISE - BLOCK IS LARGER THAN ONE-BY-ONE
C
        KSIZE  = KLAST - KFIRST + 1
        KLEFT  = KSIZE
        LUBLP (KBLOCK) = SLU + 1
C
C     INITIALIZE THE DEGREE LISTS, AND THE ROW-ORIENTED DATA STRUCTURE
C
        DEGMIN = KLAST + 1
        DEGMAX = 0
        K = 0
        AROWP (KFIRST) = 1
        WM (KFIRST) = 1
        WJFLAG = AN+2
        DO 9125 I = KFIRST, KLAST
           AROWP (I+1) = AROWP (I) + ALEFTR (I)
9125       CONTINUE
        DO 9020 I = KFIRST, KLAST
           DEG = ALEFTR (I)
           ALOR (I) = DEG
           AHIR (I) = DEG
           AFLPR (I) = NIL
           DEG = ALEFTC (I)
           ALOC (I) = DEG
           AHIC (I) = DEG
           AFLPC (I) = NIL
           IF (DEG .NE. 0) THEN
              DEGMIN = MIN (DEGMIN, DEG)
              DEGMAX = MAX (DEGMAX, DEG)
              K = K + 1
              AHINXT (I) = NIL
           ELSE
C
C     FLAG THIS COLUMN AS PERMANENTLY REMOVED PIVOT SEARCH
C
              AHINXT (I) = - 1
              ENDIF
           WM (I+1) = AROWP (I+1)
           WIR (I) = -1
           WIC (I) = -1
           WJR (I) = 0
           WJC (I) = 0
9020       CONTINUE
        IF (NHISRC .NE. 0) THEN
           AHIMIN = DEGMIN
           AHIMAX = DEGMAX
           AHICNT = K
           DO 345 I = 1, KSIZE
              AHIHED (I) = NIL
345           CONTINUE
           DO 347 I = KFIRST, KLAST
              AHIPRV (I) = NIL
347           CONTINUE
           DO 9025 I = KLAST, KFIRST, -1
              IF (AHINXT (I) .GE. 0) THEN
                 HI = ALEFTC (I)
                 H = AHIHED (HI)
                 AHINXT (I) = H
                 IF (H .NE. NIL) AHIPRV (H) = I
                 AHIHED (HI) = I
                 ENDIF
9025          CONTINUE
        ELSE
           AHIMIN = 0
           AHIMAX = 0
           AHICNT = 0
           ENDIF
        IF (NLOSRC .NE. 0) THEN
           ALOMIN = DEGMIN
           ALOMAX = DEGMAX
           ALOCNT = K
           DO 346 I = 1, KSIZE
              ALOHED (I) = NIL
346           CONTINUE
           DO 348 I = KFIRST, KLAST
              ALOPRV (I) = NIL
348           CONTINUE
           DO 9225 I = KLAST, KFIRST, -1
              IF (AHINXT (I) .GE. 0) THEN
                 LO = ALEFTC (I)
                 H = ALOHED (LO)
                 ALONXT (I) = H
                 IF (H .NE. NIL) ALOPRV (H) = I
                 ALOHED (LO) = I
              ENDIF
9225          CONTINUE
        ELSE
           ALOMIN = 0
           ALOMAX = 0
           ALOCNT = 0
           ENDIF
C
C     NUMBER OF NONZEROS IN ORIGINAL BLOCK
C
        ABLKNZ = AROWP (KLAST+1) - 1
        CALL UXIMRK(MMEM,ERROR,SAVE3)
        IF (ERROR .NE. 0) GOTO 9998
C
C     ALLOCATE NEW ROW-ORIENTED BLOCK ON TAIL OF MEMORY
C
        CALL UXIGET(MMEM,ERROR,1,ABLKNZ,2,AROWIP)
        IF (ERROR .NE. 0) GOTO 9998
        CALL UXIGET(MMEM,ERROR,2,ABLKNZ,2,AROWXP)
        IF (ERROR .NE. 0) GOTO 9998
        IF (AROWIP .EQ. NIL .OR. AROWXP .EQ. NIL) GOTO 9999
C
C     SET POINTERS FOR GARBAGE COLLECTION
C
        CALL UXIMRK(MMEM,ERROR,GARBAG)
        IF (ERROR .NE. 0) GOTO 9998
C
C     COPY THE COLUMN-ORIENTED DIAGONAL BLOCK INTO ROW-ORIENTED STRUCTURE
C
        DO 9040 COL = KFIRST, KLAST
           DO 9050 P = ACOLP (COL), ACOLP (COL+1) - 1
              ROW = ACOLI (P)
              II(AROWIP-1+(WM (ROW))) = COL
              XX(AROWXP-1+(WM (ROW))) = ACOLX (P)
              WM (ROW) = WM (ROW) + 1
9050          CONTINUE
9040       CONTINUE
C
C     WM NO LONGER NEEDED
C
C
C     FACTOR A SINGLE BLOCK
C
        KLU = KFIRST-1
1000    IF (.NOT. (KLU .LT. KLAST)) GOTO 1010
        WJFLAG = WJFLAG + 1
        IF (WJFLAG .GE. BIG) THEN
           DO 1770 KK = KFIRST, KLAST
              WJR (KK) = 0
              WJC (KK) = 0
1770          CONTINUE
           WJFLAG = AN+2
           ENDIF
C
C     PIVOT SEARCH:
C       FIND A SINGLE LOW COST PIVOT IN THE NHISRC COLUMNS WITH
C       LOWEST UPPER BOUND DEGREE OR IN THE NLOSRC COLUMNS WITH
C       LOWEST LOWER BOUND DEGREE.
C
        NSONS = 0
        PIVCOL = NIL
        PIVROW = NIL
        SRCHED = 0
        CALL UXIMRK(MMEM,ERROR,SAVE2)
        IF (ERROR .NE. 0) GOTO 9998
        BESTCO = MAXINT
        RANOUT = .FALSE.
710        CONTINUE
           IF (AHICNT.NE.0 .AND. SRCHED .LT. NHISRC) THEN
C
C     GET COL FROM UPPER-BOUND DEGREE LIST
C
              AHICNT = AHICNT - 1
              COL = AHIHED (AHIMIN)
              NEXTP = AHINXT (COL)
              IF (NEXTP .NE. NIL) AHIPRV (NEXTP) = NIL
              AHIHED (AHIMIN) = NEXTP
C
C     RECOMPUTE AHIMIN
C
              IF (AHICNT .NE. 0) THEN
785                 IF (AHIHED (AHIMIN) .NE. NIL) GOTO 795
                    AHIMIN = AHIMIN + 1
                    GOTO 785
795                 CONTINUE
                 ENDIF
              IF (ALOCNT .NE. 0 .AND. NLOSRC .NE. 0) THEN
C
C     ALSO REMOVE IT FROM THE LOWER BOUND DEGREE LIST
C
                 LO = ALOC (COL)
                 IF (LO .EQ. 0) GOTO 610
                 ALOCNT = ALOCNT - 1
                 NEXTP = ALONXT (COL)
                 PREVP = ALOPRV (COL)
                 IF (NEXTP .NE. NIL) ALOPRV (NEXTP) = PREVP
                 IF (PREVP .NE. NIL) THEN
                    ALONXT (PREVP) = NEXTP
                 ELSE
C
C     COLUMN IS AT THE HEAD OF THE LIST
C
                    ALOHED (LO) = NEXTP
                    IF (NEXTP .NE. NIL .OR. ALOCNT .EQ. 0) GOTO 610
C
C     REMOVED THE LAST ENTRY IN A LIST, UPDATE MIN/MAX
C
                    IF (LO .EQ. ALOMIN) THEN
600                     ALOMIN = ALOMIN + 1
                        IF (ALOHED (ALOMIN) .EQ. NIL) GOTO 600
                    ELSE IF (LO .EQ. ALOMAX) THEN
620                     ALOMAX = ALOMAX - 1
                        IF (ALOHED (ALOMAX) .EQ. NIL) GOTO 620
                        ENDIF
                    ENDIF
610              CONTINUE
                 ENDIF
           ELSE IF (ALOCNT .NE. 0 .AND.
     &          SRCHED .LT. NHISRC + NLOSRC) THEN
C
C     GET COLUMN LOWER-BOUND DEGREE LIST
C
              ALOCNT = ALOCNT - 1
              COL = ALOHED (ALOMIN)
              NEXTP = ALONXT (COL)
              IF (NEXTP .NE. NIL) ALOPRV (NEXTP) = NIL
              ALOHED (ALOMIN) = NEXTP
C
C     RECOMPUTE ALOMIN
C
              IF (ALOCNT .NE. 0) THEN
1785                IF (ALOHED (ALOMIN) .NE. NIL) GOTO 1795
                    ALOMIN = ALOMIN + 1
                    GOTO 1785
1795                CONTINUE
                 ENDIF
              IF (AHICNT .NE. 0 .AND. NHISRC .NE. 0) THEN
C
C     ALSO REMOVE IT FROM THE LOWER BOUND DEGREE LIST
C
                 HI = AHIC (COL)
                 IF (HI .EQ. 0) GOTO 611
                 AHICNT = AHICNT - 1
                 NEXTP = AHINXT (COL)
                 PREVP = AHIPRV (COL)
                 IF (NEXTP .NE. NIL) AHIPRV (NEXTP) = PREVP
                 IF (PREVP .NE. NIL) THEN
                    AHINXT (PREVP) = NEXTP
                 ELSE
C
C     COLUMN IS AT THE HEAD OF THE LIST
C
                    AHIHED (HI) = NEXTP
                    IF (NEXTP .NE. NIL .OR. AHICNT .EQ. 0) GOTO 611
C
C     REMOVED THE LAST ENTRY IN A LIST, UPDATE MIN/MAX
C
                    IF (HI .EQ. AHIMIN) THEN
601                     AHIMIN = AHIMIN + 1
                        IF (AHIHED (AHIMIN) .EQ. NIL) GOTO 601
                    ELSE IF (HI .EQ. AHIMAX) THEN
621                     AHIMAX = AHIMAX - 1
                        IF (AHIHED (AHIMAX) .EQ. NIL) GOTO 621
                        ENDIF
                    ENDIF
611              CONTINUE
                 ENDIF
           ELSE
C
C     SEARCH IS OVER
C
              GOTO 700
              ENDIF
C
C     SCATER AND ADD UP ALL CONTRIBUTIONS TO COLUMN
C
           WJFLAG = WJFLAG + 1
           DEG = 0
           AFP = AFLPC (COL)
           IF (AFP .NE. NIL) THEN
              PA = II(AFP-1)
              PT = (AFP-2)
              P = PA
C
C     SCAN TUPLES
C
725              IF (P .GE. PT) GOTO 730
                 ECOL = II(P)
                 IF (FLEFTC (ECOL) .EQ. 0) THEN
C
C     DELETE TUPLE
C
                    II(P) = II(PA)
                    II(P+1) = II(PA+1)
                    PA = PA + 2
                    P = P + 2
                    GOTO 725
                    ENDIF
                 EP = FP (ECOL)
                 OFFSET = II(P+1)
                 FRXP = II(EP)
                 FRDEGC = II((EP)+3)
                 FRIPC = ((EP)+5)
                 XSP = FRXP + (OFFSET - 1) * FRDEGC
                 DO 740 J = 1, FRDEGC
                    ROW = II(FRIPC+(J)-1)
                    IF (ROW .GT. 0) THEN
                       WX (ROW) = WX (ROW) + XX (XSP)
                       IF (WJR (ROW) .NE. WJFLAG) THEN
                          WJR (ROW) = WJFLAG
                          DEG = DEG + 1
                          WM (DEG) = ROW
                          ENDIF
                       ENDIF
                    XSP = XSP + 1
740                 CONTINUE
                 P = P + 2
                 GOTO 725
730              CONTINUE
              II(AFP-1) = PA
              ENDIF
           IF (ALEFTC (COL) .GT. 0) THEN
C
C     SCATTER THE ORIGINAL COLUMN, EXCLUDING ASSEMBLED ENTRIES
C
              DO 735 PA = ACOLP (COL), ACOLP (COL+1) - 1
                 ROW = ACOLI (PA)
                 IF (ALEFTR (ROW) .GT. 0) THEN
                    WX (ROW) = WX (ROW) + ACOLX (PA)
                    IF (WJR (ROW) .NE. WJFLAG) THEN
                       WJR (ROW) = WJFLAG
                       DEG = DEG + 1
                       WM (DEG) = ROW
                       ENDIF
                    ENDIF
735              CONTINUE
              ENDIF
C
C     DONE ASSEMBLING THE COLUMN
C
C
C     UPDATE THE DEGREE OF THIS COLUMN
C
           ALOC (COL) = DEG
           AHIC (COL) = DEG
C
C     FIND THE MAXIMUM ABSOLUTE VALUE IN THE COLUMN
C
           MAXVAL = ZERO
           DO 750 I = 1, DEG
              MAXVAL = MAX (MAXVAL, ABS (WX (WM (I))))
750           CONTINUE
           TOLER = RELTOL * MAXVAL
           IF (DEG .EQ. 0 .OR. MAXVAL .LE. ABSTOL) THEN
C
C     SINGULAR MATRIX - DON'T INCLUDE THIS IN THE COUNT OF COLUMNS
C     SEARCHED. DON'T PLACE THIS COLUMN BACK IN THE COLUMN DEGREE LIST
C
              DO 780 I = 1, DEG
                 WX (WM (I)) = ZERO
780              CONTINUE
C
C     FLAG THIS COLUMN AS PERMANENTLY REMOVED FROM PIVOT SEARCH
C
              AHINXT (COL) = -1
              GOTO 710
              ENDIF
C
C     SAVE A LIST OF THE COLUMNS SEARCHED (WITH NONZERO DEGREES)
C
           SRCHED = SRCHED + 1
           COLS (SRCHED) = COL
C
C     LOOK FOR THE BEST POSSIBLE PIVOT ROW IN THIS COLUMN:
C       LOWEST UPPER BOUND DEGREE OF THOSE THAT ARE NUMERICALLY
C       ACCEPTABLE
C
           MINHI = MAXINT
           IF (SYMSRC) THEN
C
C     ALWAYS PREFER SYMMETRIC PIVOTS, IF NUMERICALLY ACCEPTABLE
C
              TRUDEG = MAXINT
              DO 861 I = 1, DEG
                 ROW = WM (I)
                 VALUE = ABS (WX (ROW))
                 IF (VALUE .GE. TOLER .AND. VALUE .GT. ABSTOL) THEN
                    IF (ROW .EQ. COL) THEN
                       MINHI = 0
                       IMINHI = I
                       TRUDEG = AHIR (ROW)
                    ELSE IF (AHIR (ROW) .LT. MINHI) THEN
                       MINHI = AHIR (ROW)
                       IMINHI = I
                       TRUDEG = AHIR (ROW)
                       ENDIF
                    ENDIF
                 WX (ROW) = ZERO
861              CONTINUE
              MINHI = TRUDEG
           ELSE
C
C     DO NOT CONSIDER WHETHER A PIVOT IS SYMMETRIS OR NOT
C
              DO 761 I = 1, DEG
                 ROW = WM (I)
                 VALUE = ABS (WX (ROW))
                 IF (VALUE .GE. TOLER .AND. VALUE .GT. ABSTOL .AND.
     &               AHIR (ROW) .LT. MINHI) THEN
                    MINHI = AHIR (ROW)
                    IMINHI = I
                    ENDIF
                 WX (ROW) = ZERO
761              CONTINUE
              ENDIF
           ROW = WM (IMINHI)
C
C     CHECK TO SEE IF A PIVOT WAS FOUND
C
           IF (MINHI .EQ. MAXINT) GOTO 710
C
C     COMPUTE THE TRUE MARKOWITZ COST WITHOUT SCANNING THE ROW
C
           COST = (DEG - 1) * (MINHI - 1)
           IF (COST .LT. BESTCO) THEN
C
C     THROW AWAY PREVIOUS BEST CANDIDATE, IF ANY
C
              IF (MMEM (1,1) .NE. SAVE2 (1,1)) THEN
                 CALL UXIFRE(MMEM,ERROR,1,
     &                  MMEM(1,1)-SAVE2(1,1),SAVE2(1,1))
                 IF (ERROR .NE. 0) GOTO 9998
                 ENDIF
              FFDEGC = DEG
              FFDIMC = MIN (KLEFT, INT (GROW * FFDEGC))
              CALL UXIGET(MMEM,ERROR,
     &                  1,FFDIMC+5,1,FFP)
              IF (ERROR .NE. 0) GOTO 9998
              IF (FFP .EQ. NIL) THEN
                 IGAR = IGAR + 1
                 CALL UXIIGR(II,MMEM,PERM2,AFLP,FLEFTC,AN,
     &                  ERROR,GARBAG)
                 IF (ERROR .NE. 0) GOTO 9998
                 CALL UXIGET(MMEM,ERROR,
     &                  1,FFDIMC+5,1,FFP)
                 IF (ERROR .NE. 0) GOTO 9998
                 IF (FFP .EQ. NIL) THEN
                    RANOUT = .TRUE.
                    GOTO 710
                    ENDIF
                 ENDIF
              FFIPC = FFP + 5
C
C     ALLOCATE A STUB FOR THE STACK-BASED PIVOT ROW PATTERN
C
              CALL UXIGET(MMEM,ERROR,1,0,1,FFIPR)
              IF (ERROR .NE. 0) GOTO 9998
              IF (FFIPR .EQ. NIL) THEN
                 RANOUT = .TRUE.
                 GOTO 710
                 ENDIF
              FFIP (C) = FFIPC
              FFIP (R) = FFIPR
              DO 773 I = 1, FFDEGC
                 II(FFIPC+(I)-1) = WM (I)
773              CONTINUE
C
C     PUT THE PIVOT ELEMENT FIRST IN THE PATTERN
C
              II(FFIPC+(IMINHI)-1) = II(FFIPC+(1)-1)
              II(FFIPC+(1)-1) = ROW
C
C     IT IS THE BEST SO FAR, SAVE THE RESULTS
C
              PIVCOL = COL
              PIVROW = ROW
              BESTCO = COST
              ENDIF
C
C     WJR, WJC, WM NO LONGER NEEDED
C
           GOTO 710
700        CONTINUE
C
C     SEARCH IS FINISHED. IF NO PIVOT FOUND, EITHER RECOVER OR QUIT.
C
        IF (PIVCOL .EQ. NIL) THEN
           IF (RANOUT) THEN
C
C     RAN OUT SPACE FOR PIVOT ROW/COL PATTERN
C
              GOTO 9999
           ELSE
C
C     SINGULAR MATRIX: NO NONZEROS LEFT IN ACTIVE SUBMATRIX
C     DEALLOCATE THE ROW-ORIENTED DATA STRUCTURE ALL AFLISTS
C     AND ALL FRONTAL MATRICES
C
              SAVE3 (1,1) = MMEM (1,1)
              SAVE3 (1,2) = MMEM (1,2)
              CALL UXIRST(MMEM,ERROR,SAVE3,1)
              IF (ERROR .NE. 0) GOTO 9998
              CALL UXIRST(MMEM,ERROR,SAVE3,2)
              IF (ERROR .NE. 0) GOTO 9998
C
C     COMPLETE THE PERMUTATION VECTORS
C
              K = KLU
              DO 940 I = KFIRST, KLAST
                 IF (PERM2R (I) .GE. 0) THEN
                    K = K + 1
                    PERM2R (I) = K
                    ENDIF
940              CONTINUE
              K = KLU
C
C     PLACE EXPLICIT ZEROS ON THE DIAGONAL OF U
C
              DO 945 I = KFIRST, KLAST
                 IF (PERM2C (I) .GE. 0) THEN
                    K = K + 1
                    PERM2C (I) = K
                    CALL UXIGET(MMEM,ERROR,
     &                  1,5,1,P)
                    IF (ERROR .NE. 0) GOTO 9998
                    IF (P .EQ. NIL) GOTO 9999
                    FP (I) = P
                    II(P) = NIL
                    II((P)+1) = 1
                    II((P)+2) = 0
                    II((P)+3) = 0
                    II((P)+4) = 0
                    FLEFTR (I) = 0
                    FLEFTC (I) = 0
                    CALL UXIGET(MMEM,ERROR,
     &                  2,1,1,LUAXP)
                    IF (ERROR .NE. 0) GOTO 9998
                    IF (LUAXP .EQ. NIL) GOTO 9997
                    XX (LUAXP) = ZERO
                    SLU = SLU + 1
                    LUTIP (AN-SLU+1) = I
                    LUTXP (I) = LUAXP
                    ENDIF
945              CONTINUE
              GOTO 9000
              ENDIF
           ENDIF
C
C     PLACE THE COLUMNS SEARCHED BACK IN THE DEGREE LIST
C     (EXCEPT PIVOT COLUMN)
C
        IF (NHISRC .NE. 0) THEN
           DO 790 I = SRCHED, 1, -1
              COL = COLS (I)
              IF (COL .NE. PIVCOL) THEN
                 AHICNT = AHICNT + 1
                 HI = AHIC (COL)
                 H = AHIHED (HI)
                 AHINXT (COL) = H
                 AHIPRV (COL) = NIL
                 IF (H .NE. NIL) AHIPRV (H) = COL
                 AHIHED (HI) = COL
                 IF (AHICNT .EQ. 1) THEN
                    AHIMIN = HI
                    AHIMAX = HI
                 ELSE
                    AHIMIN = MIN (AHIMIN, HI)
                    AHIMAX = MAX (AHIMAX, HI)
                    ENDIF
                 ENDIF
790           CONTINUE
           ENDIF
        IF (NLOSRC .NE. 0) THEN
           DO 791 I = SRCHED, 1, -1
              COL = COLS (I)
              IF (COL .NE. PIVCOL) THEN
                 ALOCNT = ALOCNT + 1
                 LO = ALOC (COL)
                 H = ALOHED (LO)
                 ALONXT (COL) = H
                 ALOPRV (COL) = NIL
                 IF (H .NE. NIL) ALOPRV (H) = COL
                 ALOHED (LO) = COL
                 IF (ALOCNT .EQ. 1) THEN
                    ALOMIN = LO
                    ALOMAX = LO
                 ELSE
                    ALOMIN = MIN (ALOMIN, LO)
                    ALOMAX = MAX (ALOMAX, LO)
                    ENDIF
                 ENDIF
791           CONTINUE
           ENDIF
C
C     FORM THE PIVOT ROW PATTERN. USE II AS A STACK FOR THE ROW PATTERN.
C     FLAG THE WJR, WJC VECTORS ACCORDINGLY.
C
        FFDIMR = MIN (KLEFT, INT (GROW * AHIR (PIVROW)))
C
C     ALLOCATE SPACE FOR STACK FOR PIVOT ROW PATTERN
C
        CALL UXIGET(MMEM,ERROR,1,FFDIMR,1,IP)
        IF (ERROR .NE. 0) GOTO 9998
        IF (IP .EQ. NIL) THEN
           IGAR = IGAR + 1
           CALL UXIIGR(II,MMEM,PERM2,AFLP,FLEFTC,AN,
     &                  ERROR,GARBAG)
           IF (ERROR .NE. 0) GOTO 9998
           FFDIMR = MIN (FFDIMR, MMEM (2,1) - MMEM (1,1))
           CALL UXIGET(MMEM,ERROR,1,FFDIMR,1,IP)
           IF (ERROR .NE. 0) GOTO 9998
           IF (IP .EQ. NIL) GOTO 9999
           ENDIF
C
C     ALLOWED ROW PATTERN, ON STACK
C
C
C     SCAN TUPLES
C
        FFDEGR = 0
        AFP = AFLPR (PIVROW)
        IF (AFP .NE. NIL) THEN
           DO 831 P = II(AFP-1), (AFP-2)-2, 2
              ECOL = II(P)
              IF (FLEFTC (ECOL) .EQ. 0) GOTO 831
              EP = FP (ECOL)
              FRIPR = ((EP)+5+II((EP)+3))
C
C     SCATTER THE ELEMENT INTO SCATTERED FORM OF THE PIVOT ROW
C
              DO 140 J = 1, II((EP)+2)
                 COL = II(FRIPR+(J)-1)
                 IF (COL .GT. 0) THEN
                    IF (WJC (COL) .NE. WJFLAG) THEN
                       FFDEGR = FFDEGR + 1
                       IF (FFDEGR .GT. FFDIMR) GOTO 9999
                       WJC (COL) = WJFLAG
                       II(FFIPR+(FFDEGR)-1) = COL
                       ENDIF
                    ENDIF
140              CONTINUE
831           CONTINUE
           ENDIF
C
C     SCAN THE ORIGINAL ROW
C
        IF (ALEFTR (PIVROW) .GT. 0) THEN
           DO 135 PA = AROWP (PIVROW), AROWP (PIVROW+1) - 1
              COL = II(AROWIP-1+(PA))
              IF (ALEFTC (COL) .GT. 0) THEN
                 IF (WJC (COL) .NE. WJFLAG) THEN
                    FFDEGR = FFDEGR + 1
                    IF (FFDEGR .GT. FFDIMR) GOTO 9999
                    WJC (COL) = WJFLAG
                    II(FFIPR+(FFDEGR)-1) = COL
                    ENDIF
                 ENDIF
135           CONTINUE
           ENDIF
C
C     NAME OF CURRENT FRONTAL MATRIX
C
        FFCOL = PIVCOL
        K = 1
        K0 = 0
        FFLEFC = FFDEGC - K
        FFLEFR = FFDEGR - K
        F2 = FFDIMR
C
C     ALLOCATE SPACE FOR THE FRONTAL MATRIX
C
        FFDIMR = MIN (FFDIMR, INT (GROW * FFDEGR))
        CALL UXIGET(MMEM,ERROR,
     &          2,FFDIMC*FFDIMR,1,FFXP)
        IF (ERROR .NE. 0) GOTO 9998
        IF (FFXP .EQ. NIL) THEN
           XGAR = XGAR + 1
           CALL UXIXGR(XX,II,MMEM,LUTIP,FP,SLU,AN,
     &                  ERROR,GARBAG)
           IF (ERROR .NE. 0) GOTO 9998
           CALL UXIGET(MMEM,ERROR,
     &          2,FFDIMC*FFDIMR,1,FFXP)
           IF (ERROR .NE. 0) GOTO 9998
           IF (FFXP .EQ. NIL) THEN
              FFDIMR = FFDEGR
              FFDIMC = FFDEGC
              CALL UXIGET(MMEM,ERROR,
     &          2,FFDIMC*FFDIMR,1,FFXP)
              IF (ERROR .NE. 0) GOTO 9998
              IF (FFXP .EQ. NIL) GOTO 9997
              ENDIF
           ENDIF
C
C     DEALLOCATE UNUSED SPACE ON STACK, IF ANY
C
        IF (F2 .NE. FFDIMR) THEN
           CALL UXIFRE(MMEM,ERROR,1,
     &          F2-FFDIMR,FFIPR+FFDIMR)
           IF (ERROR .NE. 0) GOTO 9998
           ENDIF
C
C     OFF STACK
C
        DO 500 J = 1, FFDEGR
           DO 500 I = 1, FFDEGC
500           XX(FFXP+((I)-1)+((J)-1)*FFDIMC) = ZERO
C
C     COMPUTE PIVOT ROW AND COLUMN OFFSETS AT THIS POINT
C
        DO 774 I = 1, FFDEGC
           WIR (II(FFIPC+(I)-1)) = I - 1
774        CONTINUE
        DO 775 I = 1, FFDEGR
           WIC (II(FFIPR+(I)-1)) = (I - 1) * FFDIMC
775        CONTINUE
C
C     PLACE PIVOT COLUMN INDEX IN FIRST POSITION OF PIVOT ROW PATTERN
C
        COL = II(FFIPR+(1)-1)
        OFFSET = (WIC (PIVCOL)/FFDIMC)+1
        II(FFIPR+(OFFSET)-1) = COL
        II(FFIPR+(1)-1) = PIVCOL
        WIC (COL) = WIC (PIVCOL)
        WIC (PIVCOL) = 0
C
C     REMOVE THE COLUMN AFFECTED BY THIS ELEMENT FROM THE DEGREE LIST
C
C
C     DON'T REMOVE COLUMNS THAT ARE ALREADY PERMANENTLY REMOVED
C     (THOSE WITH AHINXT (COL) < 0)
C
        IF (NLOSRC .NE. 0) THEN
           DO 612 J = 2, FFDEGR
              COL = II(FFIPR+(J)-1)
              LO = ALOC (COL)
              IF (LO .GT. 0 .AND. AHINXT (COL) .GE. 0) THEN
                 ALOCNT = ALOCNT - 1
                 NEXTP = ALONXT (COL)
                 PREVP = ALOPRV (COL)
                 IF (NEXTP .NE. NIL) ALOPRV (NEXTP) = PREVP
                 IF (PREVP .NE. NIL) THEN
                    ALONXT (PREVP) = NEXTP
                 ELSE
C
C     COLUMN IS AT THE HEAD OF THE LIST
C
                    ALOHED (LO) = NEXTP
                    IF (NEXTP .NE. NIL .OR. ALOCNT .EQ. 0) GOTO 612
C
C     REMOVED THE LAST ENTRY IN A LIST, UPDATE MIN/MAX
C
                    IF (LO .EQ. ALOMIN) THEN
602                     ALOMIN = ALOMIN + 1
                        IF (ALOHED (ALOMIN) .EQ. NIL) GOTO 602
                    ELSE IF (LO .EQ. ALOMAX) THEN
622                     ALOMAX = ALOMAX - 1
                        IF (ALOHED (ALOMAX) .EQ. NIL) GOTO 622
                        ENDIF
                    ENDIF
                 ENDIF
612           CONTINUE
           ENDIF
        IF (NHISRC .NE. 0) THEN
           DO 613 J = 2, FFDEGR
              COL = II(FFIPR+(J)-1)
              HI = AHIC (COL)
              IF (HI .GT. 0 .AND. AHINXT (COL) .GE. 0) THEN
                 AHICNT = AHICNT - 1
                 NEXTP = AHINXT (COL)
                 PREVP = AHIPRV (COL)
                 IF (NEXTP .NE. NIL) AHIPRV (NEXTP) = PREVP
                 IF (PREVP .NE. NIL) THEN
                    AHINXT (PREVP) = NEXTP
                 ELSE
C
C     COLUMN IS AT THE HEAD OF THE LIST
C
                    AHIHED (HI) = NEXTP
                    IF (NEXTP .NE. NIL .OR. AHICNT .EQ. 0) GOTO 613
C
C     REMOVED THE LAST ENTRY IN A LIST, UPDATE MIN/MAX
C
                    IF (HI .EQ. AHIMIN) THEN
603                     AHIMIN = AHIMIN + 1
                        IF (AHIHED (AHIMIN) .EQ. NIL) GOTO 603
                    ELSE IF (HI .EQ. AHIMAX) THEN
623                     AHIMAX = AHIMAX - 1
                        IF (AHIHED (AHIMAX) .EQ. NIL) GOTO 623
                        ENDIF
                    ENDIF
                 ENDIF
613           CONTINUE
           ENDIF
C
C     INITIALLY, DO ALL SCANS
C
        SCAN1 = 1
        SCAN2 = 1
        SCAN3 = 1
        SCAN4 = 1
C
C     WHILE (EXTENDING FRONTAL MATRIX)
C
800        CONTINUE
C
C     DEGREE UPDATE AND NUMERICAL ASSEMBLY
C
           FEDEGC = FFDEGC
           FEDEGR = FFDEGR
           KLEFT1 = KLEFT - 1
           WJZERO = WJFLAG + 1
C
C     SCAN1: SCAN THE AFLISTS OF EACH ROW IN THE PIVOT COLUMN
C            AND COMPUTE THE OUTSIDE COLUMN DEGREE FOR EACH FRONTAL
C
           DO 3410 JJ = SCAN1, FFDEGC
              ROW = II(FFIPC+(JJ)-1)
              AFP = AFLPR (ROW)
              IF (AFP .NE. NIL) THEN
C
C     SCAN TUPLES
C
                 DO 3440 P=II(AFP-1),(AFP-2)-2,2
                    ECOL = II(P)
                    IF (FLEFTC (ECOL) .EQ. 0) GOTO 3440
                    IF (WJC (ECOL) .LT. WJZERO) THEN
                       WJC (ECOL) = FLEFTC (ECOL) + WJZERO
                       ENDIF
                    WJC (ECOL) = WJC (ECOL) - 1
3440                CONTINUE
                 ENDIF
3410          CONTINUE
C
C     SCAN2: SCAN THE AFLISTS OF EACH COLUMN IN THE PIVOT ROW
C            AND COMPUTE THE OUTSIDE ROW DEGREE FOR EACH FRONTAL
C
           DO 3310 JJ = SCAN2, FFDEGR
              COL = II(FFIPR+(JJ)-1)
              AFP = AFLPC (COL)
              IF (AFP .NE. NIL) THEN
C
C     SCAN TUPLES
C
                 DO 3340 P=II(AFP-1),(AFP-2)-2,2
                    ECOL = II(P)
                    IF (FLEFTR (ECOL) .EQ. 0) GOTO 3340
                    IF (WJR (ECOL) .LT. WJZERO) THEN
                       WJR (ECOL) = FLEFTR (ECOL) + WJZERO
                       ENDIF
                    WJR (ECOL) = WJR (ECOL) - 1
3340                CONTINUE
                 ENDIF
3310          CONTINUE
C
C     SCAN3: SCAN THE AFLISTS OF EACH COLUMN IN THE PIVOT ROW,
C            DO DEGREE UPDATE FOR THE COLUMNS,
C            ASSEMBLE EFFECTIVE U-SONS AND LU-SONS
C
           CANDEG = MAXINT
           DO 3411 JJ = SCAN3, FFDEGR
              COL = II(FFIPR+(JJ)-1)
              SUMOUT = 0
              MAXOUT = 0
C
C     FOR ASSEMBLY OF U-SONS AND ORIGINAL ENTRIES
C
              XUDP = FFXP + WIC (COL)
              AFP = AFLPC (COL)
              IF (AFP .NE. NIL) THEN
                 PA = II(AFP-1)
                 PT = (AFP-2)
                 P = PA
C
C     SCAN TUPLES
C
3441                IF (P .GE. PT) GOTO 3442
                    ECOL = II(P)
                    FRLEFC = FLEFTC (ECOL)
                    IF (FRLEFC .EQ. 0) THEN
C
C     DELETE TUPLE
C
                       II(P) = II(PA)
                       II(P+1) = II(PA+1)
                       PA = PA + 2
                       P = P + 2
                       GOTO 3441
                       ENDIF
                    OUTSD = WJC (ECOL) - WJZERO
                    IF (OUTSD .NE. 0) THEN
C
C     THIS IS NOT A U-SON OR LU-SON
C
                       IF (OUTSD .LT. 0) OUTSD = FRLEFC
                       SUMOUT = SUMOUT + OUTSD
                       MAXOUT = MAX (MAXOUT, OUTSD)
                       P = P + 2
                       GOTO 3441
                       ENDIF
C
C     THIS IS A U-SON OR LU-SON, ASSEMBLE IT
C
                    EP = FP (ECOL)
                    FRXP = II(EP)
                    FRDEGR = II((EP)+2)
                    FRDEGC = II((EP)+3)
                    FRIPC = ((EP)+5)
                    FRIPR = ((EP)+5+II((EP)+3))
                    FRLEFR = FLEFTR (ECOL)
C
C     ADD TO FSONL LIST IF NOT ALREADY THERE
C
                    IF (FSONL (ECOL) .GE. 0) THEN
                       IF (NSONS .EQ. 0) THEN
                          FSONL (ECOL) = -ECOL
                       ELSE
                          FSONL (ECOL) = -SONLST
                          ENDIF
                       SONLST = ECOL
                       NSONS = NSONS + 1
                       ENDIF
                    IF (WJR (ECOL) .EQ. WJZERO) THEN
C
C     THIS IS AN LU-SON, ASSEMBLE AN ENTIRE FRONTAL MATRIX
C
                       IF (FRDEGC .EQ. FRLEFC) THEN
C
C     NO ROW ASSEMBLED OUT OF THIS FRONTAL YET
C
C
C     COMPUTE THE COMPRESSED COLUMN OFFSET VECTOR
C
                          DO 905 I = 1, FRDEGC
                             WM (I) = WIR (II(FRIPC+(I)-1))
905                          CONTINUE
                          IF (FRDEGR .EQ. FRLEFR) THEN
C
C     NO ROWS OR COLUMNS ASSEMBLED OUT OF FRONTAL YET
C
                             DO 924 J = 1, FRDEGR
                                XSP = FRXP
                                XDP = FFXP + WIC (II(FRIPR+(J)-1))
                                DO 944 I = 1, FRDEGC
                                   XX (XDP+WM(I)) =
     &                             XX (XDP+WM(I)) + XX (XSP)
                                   XSP = XSP + 1
944                                CONTINUE
                                FRXP = FRXP + FRDEGC
924                             CONTINUE
                          ELSE
C
C     ONLY COLUMNS HAVE BEEN ASSEMBLED OUT OF FRONTAL
C
                             DO 923 J = 1, FRDEGR
                                IF (II(FRIPR+(J)-1) .GT. 0) THEN
                                   XSP = FRXP
                                   XDP = FFXP + WIC (II(FRIPR+(J)-1))
                                   DO 943 I = 1, FRDEGC
                                      XX (XDP+WM(I)) =
     &                                XX (XDP+WM(I)) + XX (XSP)
                                      XSP = XSP + 1
943                                   CONTINUE
                                   ENDIF
                                FRXP = FRXP + FRDEGC
923                             CONTINUE
                             ENDIF
                       ELSE
C
C     SOME ROWS HAVE BEEN ASSEMBLED OUT OF THIS FRONTAL
C
C
C     COMPUTE THE COMPRESSED COLUMN OFFSET VECTOR
C
                          DO 915 I = 1, FRDEGC
                             IF (II(FRIPC+(I)-1) .GT. 0) THEN
                                WM (I) = WIR (II(FRIPC+(I)-1))
                             ELSE
                                WM (I) = -1
                                ENDIF
915                          CONTINUE
                          IF (FRDEGR .EQ. FRLEFR) THEN
C
C     ONLY ROWS ASSEMBLED OUT OF THIS FRONTAL
C
                             DO 922 J = 1, FRDEGR
                                XSP = FRXP
                                XDP = FFXP + WIC (II(FRIPR+(J)-1))
                                DO 942 I = 1, FRDEGC
                                   IF (WM (I) .GE. 0)
     &                                XX (XDP+WM(I)) =
     &                                XX (XDP+WM(I)) + XX (XSP)
                                   XSP = XSP + 1
942                                CONTINUE
                                FRXP = FRXP + FRDEGC
922                          CONTINUE
                          ELSE
C
C     BOTH ROWS AND COLUMNS ASSEMBLED OUT OF FRONTAL
C
                             DO 921 J = 1, FRDEGR
                                IF (II(FRIPR+(J)-1) .GT. 0) THEN
                                   XSP = FRXP
                                   XDP = FFXP + WIC (II(FRIPR+(J)-1))
                                   DO 941 I = 1, FRDEGC
                                      IF (WM (I) .GE. 0)
     &                                   XX (XDP+WM(I)) =
     &                                   XX (XDP+WM(I)) + XX (XSP)
                                      XSP = XSP + 1
941                                   CONTINUE
                                   ENDIF
                                FRXP = FRXP + FRDEGC
921                             CONTINUE
                             ENDIF
                          ENDIF
C
C     DEALLOCATE COMPLETELY ASSEMBLED FRONTAL MATRIX
C
                       FLEFTR (ECOL) = 0
                       FLEFTC (ECOL) = 0
                       CALL UXIFRE(MMEM,ERROR,2,
     &                          FRDEGR*FRDEGC,II(EP))
                       IF (ERROR .NE. 0) GOTO 9998
                       II(EP) = NIL
                    ELSE
C
C     THIS IS ONLY A U-SON, ASSEMBLE A SINGLE COLUMN
C
                       OFFSET = II(P+1)
                       XSP = FRXP + (OFFSET - 1) * FRDEGC
                       IF (FRDEGC .EQ. FRLEFC) THEN
C
C     NO ROWS NUMERICALLY ASSEMBLED OUT OF FRONTAL YET
C
                          DO 244 IP = FRIPC, FRIPC+FRDEGC-1
                             XX (XUDP + WIR (II(IP))) =
     &                       XX (XUDP + WIR (II(IP))) + XX (XSP)
                             XSP = XSP + 1
244                          CONTINUE
                       ELSE
C
C     SOME ROWS NUMERICALLY ASSEMBLED OUT OF FRONTAL
C
                          DO 243 IP = FRIPC, FRIPC+FRDEGC-1
                             IF (II(IP) .GT. 0)
     &                          XX (XUDP + WIR (II(IP))) =
     &                          XX (XUDP + WIR (II(IP))) + XX(XSP)
                             XSP = XSP + 1
243                          CONTINUE
                          ENDIF
C
C     DECREMENT COUNT OF UNASSEMBLED COLUMNS IN FRONTAL
C
                       FLEFTR (ECOL) = FRLEFR - 1
C                      flag the element col as assembled
                       II(FRIPR+(OFFSET)-1) = -COL
                       ENDIF
C
C     DELETE TUPLE
C
                    II(P) = II(PA)
                    II(P+1) = II(PA+1)
                    PA = PA + 2
                    P = P + 2
                    GOTO 3441
3442                CONTINUE
                 II(AFP-1) = PA
                 ENDIF
C
C     SCAN THE ORIGINAL COLUMN TO SEE IF IT CAN BE ASSEMBLED
C
              LEFT = ALEFTC (COL)
              IF (LEFT .GT. FFLEFC+1) THEN
                 SUMOUT = SUMOUT + LEFT
              ELSE IF (LEFT .GT. 0) THEN
                 DEGIN = 0
                 DEGOUT = 0
                 IF (PIVCOL .NE. COL) THEN
C
C     CHECK TO SEE IF ORIGINAL COLUMN CAN BE ASSEMBLED
C
                    DO 3850 PA = ACOLP (COL), ACOLP (COL+1) - 1
                       ROW = ACOLI (PA)
                       IF (ALEFTR (ROW) .GT. 0) THEN
                          IF (WIR (ROW) .LT. 0) THEN
                             DEGOUT = DEGOUT + 1
                             GOTO 3851
                          ELSE
                             DEGIN = DEGIN + 1
                             ENDIF
                          ENDIF
3850                   CONTINUE
3851                CONTINUE
                    ENDIF
                 IF (DEGOUT .EQ. 0) THEN
C
C     THIS COLUMN CAN BE ASSEMBLED
C
                    DO 270 PA = ACOLP (COL), ACOLP (COL+1) - 1
                       ROW = ACOLI (PA)
                       IF (ALEFTR (ROW) .GT. 0) THEN
                          ALEFTR (ROW) = ALEFTR (ROW) - 1
                          XX (XUDP + WIR (ROW)) =
     &                    XX (XUDP + WIR (ROW)) + ACOLX (PA)
                          ENDIF
270                    CONTINUE
                    ALEFTC (COL) = 0
                 ELSE
                    AMININ  = DEGIN
                    AMAXIN  = MIN (FFLEFC, LEFT - DEGOUT)
                    AMNOUT = LEFT - AMAXIN
                    AMXOUT = LEFT - AMININ
                    SUMOUT = SUMOUT + AMXOUT
                    MAXOUT = MAX (MAXOUT, AMNOUT)
                    ENDIF
                 ENDIF
              IF (SUMOUT .EQ. 0) THEN
                 LO = FFLEFC
                 HI = FFLEFC
              ELSE
C
C     THIS IS NOT A SUPERCOLUMN OF CURENT FRONTAL
C     COMPUTE APPROXIMATE DEGREE UPDATE
C
                 HI = MIN (KLEFT1, FFLEFC+AHIC(COL), FFLEFC+SUMOUT)
                 LO = MIN (HI, MAX (ALOC(COL)-1, FFLEFC+MAXOUT))
                 ENDIF
C
C     FIND THE BEST CANDIDATE PIVOT COLUMN
C
              IF (PIVCOL .NE. COL .AND. LO .GT. 0 .AND.
     &            LO .LE. FFDIMC-K .AND. HI .LT. CANDEG .AND.
     &            AHINXT (COL) .GE. 0) THEN
                 CANDEG = HI
                 CANCOL = COL
                 CANOFF = JJ
                 ENDIF
              ALOC (COL) = LO
              AHIC (COL) = HI
3411          CONTINUE
C
C     SCAN4: SCAN THE AFLISTS OF EACH ROW IN THE PIVOT COLUMN,
C            DO DEGREE UPDATE FOR THE ROWS, ASSEMBLE EFFECTIVE L-SONS
C
           DO 3412 JJ = SCAN4, FFDEGC
              ROW = II(FFIPC+(JJ)-1)
              SUMOUT = 0
              MAXOUT = 0
              XLDP = FFXP + WIR (ROW)
              AFP = AFLPR (ROW)
              IF (AFP .NE. NIL) THEN
                 PA = II(AFP-1)
                 PT = (AFP-2)
                 P = PA
C
C     SCAN TUPLES
C
3443                IF (P .GE. PT) GOTO 3444
                    ECOL = II(P)
                    FRLEFC = FLEFTC (ECOL)
                    IF (FRLEFC .EQ. 0) THEN
C
C     DELETE TUPLE
C
                       II(P) = II(PA)
                       II(P+1) = II(PA+1)
                       PA = PA + 2
                       P = P + 2
                       GOTO 3443
                       ENDIF
                    FRLEFR = FLEFTR (ECOL)
                    OUTSD = WJR (ECOL) - WJZERO
                    IF (OUTSD .NE. 0) THEN
                       IF (OUTSD .LT. 0) OUTSD = FRLEFR
                       SUMOUT = SUMOUT + OUTSD
                       MAXOUT = MAX (MAXOUT, OUTSD)
                       P = P + 2
                       GOTO 3443
                       ENDIF
C
C     THIS IS AN L-SON, ASSEMBLE IT
C
                    EP = FP (ECOL)
                    FRXP = II(EP)
                    FRDEGR = II((EP)+2)
                    FRDEGC = II((EP)+3)
                    FRIPC = ((EP)+5)
                    FRIPR = ((EP)+5+II((EP)+3))
C
C     ADD TO FSONL LIST IF NOT ALREADY THERE
C
                    IF (FSONL (ECOL) .GE. 0) THEN
                       IF (SONLST .EQ. NIL) THEN
                          FSONL (ECOL) = -ECOL
                       ELSE
                          FSONL (ECOL) = -SONLST
                          ENDIF
                       SONLST = ECOL
                       NSONS = NSONS + 1
                       ENDIF
                    OFFSET = II(P+1)
                    XSP = FRXP + (OFFSET - 1)
                    IF (FRDEGR .EQ. FRLEFR) THEN
C
C     NO COLUMNS ASSEMBLED OUT OF THIS FRONTAL YET
C
                       DO 242 IP = FRIPR, FRIPR+FRDEGR-1
                          XX (XLDP + WIC (II(IP))) =
     &                    XX (XLDP + WIC (II(IP))) + XX (XSP)
                          XSP = XSP + FRDEGC
242                       CONTINUE
                    ELSE
C
C     SOME ROWS NUMERICALLY ASSEMBLED OUT OF FRONTAL
C
                       DO 241 IP = FRIPR, FRIPR+FRDEGR-1
                          IF (II(IP) .GT. 0)
     &                       XX (XLDP + WIC (II(IP))) =
     &                       XX (XLDP + WIC (II(IP))) + XX (XSP)
                          XSP = XSP + FRDEGC
241                       CONTINUE
                       ENDIF
C
C     DECREMENT COUNT OF UNASSEMBLED ROWS IN FRONTAL
C
                    FLEFTC (ECOL) = FRLEFC - 1
C
C     FLAG THE ELEMENT ROW AS ASSEMBLED
C
                    II(FRIPC+(OFFSET)-1) = -ROW
C
C     DELETE TUPLE
C
                    II(P) = II(PA)
                    II(P+1) = II(PA+1)
                    PA = PA + 2
                    P = P + 2
                    GOTO 3443
3444                CONTINUE
                 II(AFP-1) = PA
                 ENDIF
C
C     SCAN THE ORIGINAL ROW TO SEE IF IT CAN BE ASSEMBLED
C
              LEFT = ALEFTR (ROW)
              IF (LEFT .GT. FFLEFR+1) THEN
                 SUMOUT = SUMOUT + LEFT
              ELSE IF (LEFT .GT. 0) THEN
                 DEGIN = 0
                 DEGOUT = 0
                 IF (PIVROW .NE. ROW) THEN
C
C     CHECK TO SEE IF ORIGINAL ROW CAN BE ASSEMBLED
C
                    DO 3840 PA = AROWP (ROW), AROWP (ROW+1) - 1
                       COL = II(AROWIP-1+(PA))
                       IF (ALEFTC (COL) .GT. 0) THEN
                          IF (WIC (COL) .LT. 0) THEN
                             DEGOUT = DEGOUT + 1
                             GOTO 3841
                          ELSE
                             DEGIN = DEGIN + 1
                             ENDIF
                          ENDIF
3840                   CONTINUE
3841                CONTINUE
                    ENDIF
                 IF (DEGOUT .EQ. 0) THEN
C
C     THIS ROW CAN BE ASSEMBLED
C
                    DO 271 PA = AROWP (ROW), AROWP (ROW+1) - 1
                       COL = II(AROWIP-1+(PA))
                       IF (ALEFTC (COL) .GT. 0) THEN
                          ALEFTC (COL) = ALEFTC (COL) - 1
                          XX (XLDP + WIC (COL)) =
     &                    XX (XLDP + WIC (COL)) + XX(AROWXP-1+(PA))
                          ENDIF
271                    CONTINUE
                    ALEFTR (ROW) = 0
                 ELSE
                    AMININ  = DEGIN
                    AMAXIN  = MIN (FFLEFR, LEFT - DEGOUT)
                    AMNOUT = LEFT - AMAXIN
                    AMXOUT = LEFT - AMININ
                    SUMOUT = SUMOUT + AMXOUT
                    MAXOUT = MAX (MAXOUT, AMNOUT)
                    ENDIF
                 ENDIF
              IF (SUMOUT .EQ. 0) THEN
                 AHIR (ROW) = FFLEFR
                 ALOR (ROW) = FFLEFR
              ELSE
C
C     THIS IS NOT A SUPERROW OF CURRENT FRONTAL
C     COMPUTE APPROXIMATE DEGREE UPDATE
C
                 AHIR (ROW) = MIN (KLEFT1,
     &                  FFLEFR + AHIR (ROW), FFLEFR + SUMOUT)
                 ALOR (ROW) = MIN (AHIR (ROW),
     &                  MAX (ALOR (ROW) - 1, FFLEFR + MAXOUT))
                 ENDIF
3412          CONTINUE
C
C     DEGREE UPDATE AND ASSEBBLY IS COMPLETE
C
C
C     SKIP THE DEGREE UPDATE (SCANS 1-4) IF THE FRONTAL MATRIX
C     WAS NOT EXTENDED
C
810     CONTINUE
C
C     SCALE CURRENT PIVOT COLUMN
C
C
C     KEEP TRACK OF THE SMALLEST PIVOT ENTRY
C
        IF (PMIN .EQ. ZERO) THEN
           PMIN = ABS (XX(FFXP+((K)-1)+((K)-1)*FFDIMC))
        ELSE
           PMIN = MIN (PMIN, ABS (XX(FFXP+((K)-1)+((K)-1)*FFDIMC)))
           ENDIF
        K1 = K + 1
        CALL UXVSCL
     &          (FFLEFC, ONE/XX(FFXP+((K)-1)+((K)-1)*FFDIMC),
     &          XX(FFXP+((K1)-1)+((K)-1)*FFDIMC),
     &          XX(FFXP+((K1)-1)+((K)-1)*FFDIMC))
C
C     ONE MORE PIVOT STEP HAS BEEN COMPLETED
C
        KLEFT = KLEFT - 1
        KLU = KLU + 1
        NPIV = NPIV + 1
        PERM2R (PIVROW) = -KLU
        PERM2C (PIVCOL) = -KLU
C
C     IF THE NUMBER OF PIVOTS IS GETTING LARGE,
C     UPDATE CONTRIBUTION BLOCK
C
        IF (MOD (K, NB) .EQ. 0) THEN
C
C     PERFORM BLOCK UPDATE TO CONTRIBUTION BLOCK
C
           CALL UXEGMM
     &          (FFLEFC, FFLEFR, K-K0, -ONE,
     &          XX(FFXP+((K1)-1)+((   K0+1)-1)*FFDIMC), FFDIMC,
     &          XX(FFXP+((K0+1)-1)+((   K1)-1)*FFDIMC), FFDIMC,
     &          ONE,
     &          XX(FFXP+((K1)-1)+((     K1)-1)*FFDIMC), FFDIMC)
           K0 = K
           ENDIF
C
C     EXAMINE BEST COLUMN CANDIDATE SEEN SO FAR
C     (NEXT PIVOT COLUMN, K+1, OF THE CURRENT FRONTAL MATRIX)
C
C
C     QUIT IF NO COLUMN CANDIDATE FOUND
C
        COLUPD = K1
        IF (CANDEG .EQ. MAXINT) GOTO 8000
        PIVCOL = CANCOL
C
C     FACTOR THE CANDIDATE COLUMN
C
C
C     SWAP WITH LEADING COLUMN
C
        IF (CANOFF .NE. K1) THEN
           CALL UXVSWP
     &          (FFDEGC, XX(FFXP+((1)-1)+((K1)-1)*FFDIMC),
     &          XX(FFXP+((1)-1)+((CANOFF)-1)*FFDIMC), 1)
           WIC (II(FFIPR+(K1)-1)) = (CANOFF - 1) * FFDIMC
           WIC (PIVCOL) = K * FFDIMC
           II(FFIPR+(CANOFF)-1) = II(FFIPR+(K1)-1)
           II(FFIPR+(K1)-1) = PIVCOL
           ENDIF
C
C     UPDATE THE CANDIDATE COLUMN WITH PREVIOUS PIVOTS
C
        CALL UXEGMV
     &          (FFLEFC, K-K0, -ONE,
     &          XX(FFXP+((K1)-1)+((   K0+1)-1)*FFDIMC), FFDIMC,
     &          XX(FFXP+((K0+1)-1)+((   K1)-1)*FFDIMC), 1,
     &          ONE,
     &          XX(FFXP+((K1)-1)+((     K1)-1)*FFDIMC), 1, 0)
        COLUPD = K + 2
C
C     COMPUTE EXTENDED PIVOT COLUMN (UNLESS IT IS A SUPERCOLUMN)
C     FIND A CANDIDATE PIVOT ROW, PERFORMING NUMERICAL TEST
C
        MINHI = MAXINT
        IF (CANDEG .NE. FFLEFC) THEN
C
C     COPY THE CANDIDATE COLUMN INTO A DENSE WORK VECTOR
C
           CALL UXVCOP
     &          (FFLEFC, XX(FFXP+((K1)-1)+((K1)-1)*FFDIMC), WX (K1))
C
C     SCAN THE LIST OF ELEMENTS SFFECTING THIS COLUMN, AND ADD EACH
C     CONTRIBUTION
C
           AFP = AFLPC (PIVCOL)
           IF (AFP .NE. NIL) THEN
              PA = II(AFP-1)
              PT = (AFP-2)
              P = PA
C
C     SCAN TUPLES
C
1725             IF (P .GE. PT) GOTO 1730
                 ECOL = II(P)
                 IF (FLEFTC (ECOL) .EQ. 0) THEN
C
C     DELETE TUPLE
C
                    II(P) = II(PA)
                    II(P+1) = II(PA+1)
                    PA = PA + 2
                    P = P + 2
                    GOTO 1725
                    ENDIF
                 EP = FP (ECOL)
                 OFFSET = II(P+1)
                 FRDEGC = II((EP)+3)
                 FRIPC = ((EP)+5)
                 XSP = II(EP) + (OFFSET - 1) * FRDEGC
                 DO 1740 J = 1, FRDEGC
                    ROW = II(FRIPC+(J)-1)
                    IF (ROW .GT. 0) THEN
                       IF (WIR (ROW) .LT. 0) THEN
                          IF (FEDEGC .GE. FFDIMC) THEN
                             ALOC (PIVCOL) = FEDEGC - K + 1
                             GOTO 1707
                             ENDIF
                          WIR (ROW) = FEDEGC
                          FEDEGC = FEDEGC + 1
                          II(FFIPC+(FEDEGC)-1) = ROW
                          ENDIF
                       WX (WIR(ROW)+1) = WX (WIR(ROW)+1) + XX (XSP)
                       ENDIF
                    XSP = XSP + 1
1740                CONTINUE
                 P = P + 2
                 GOTO 1725
1730             CONTINUE
              II(AFP-1) = PA
              ENDIF
           IF (ALEFTC (PIVCOL) .GT. 0) THEN
C
C     SCAN THE ORIGINAL COLUMN, EXCLUDING ASSEMBLED ENTRIES
C
              DO 1735 PA = ACOLP (PIVCOL), ACOLP (PIVCOL+1) - 1
                 ROW = ACOLI (PA)
                 IF (ALEFTR (ROW) .GT. 0) THEN
                    IF (WIR (ROW) .LT. 0) THEN
                       IF (FEDEGC .GE. FFDIMC) THEN
                          ALOC (PIVCOL) = FEDEGC - K + 1
                          GOTO 1707
                          ENDIF
                       WIR (ROW) = FEDEGC
                       FEDEGC = FEDEGC + 1
                       II(FFIPC+(FEDEGC)-1) = ROW
                       ENDIF
                    WX (WIR(ROW)+1) = WX (WIR(ROW)+1) + ACOLX (PA)
                    ENDIF
1735             CONTINUE
              ENDIF
           VALUE = UXVMX1 (FEDEGC-K, WX (K1), JJ)
           KP = K + JJ
           MAXVAL = ABS (WX (KP))
           TOLER = RELTOL * MAXVAL
           IF (MAXVAL .LE. ABSTOL) THEN
C
C     SINGULAR MATRIX
C
              DO 1780 I = 1, FEDEGC
                 WX (I) = ZERO
1780             CONTINUE
C
C     FLAG THIS COLUMN AS PERMANENTLY REMOVED FROM PIVOT SEARCH
C
              AHINXT (PIVCOL) = -1
              GOTO 8000
              ENDIF
C
C     LOOK FOR BEST PIVOT ROW, ONLY LOOK FOR PIVOT ENTRIES
C     RESIDING IN CURRENT FRONTAL MATRIX
C
           IF (SYMSRC) THEN
C
C     ALWAYS PREFER SYMMETRIC PIVOTS, IF NUMERICALLY ACCEPTABLE
C
              TRUDEG = MAXINT
              DO 1861 I = K1, FFDEGC
                 VALUE = ABS (WX (I))
                 IF (VALUE .GE. TOLER .AND. VALUE .GT. ABSTOL) THEN
                    ROW = II(FFIPC+(I)-1)
                    IF (ALOR (ROW) .LE. FFDIMR-K) THEN
                       IF (ROW .EQ. PIVCOL) THEN
                          MINHI = 0
                          IMINHI = I
                          TRUDEG = AHIR (ROW)
                       ELSE IF (AHIR (ROW) .LT. MINHI) THEN
                          MINHI = AHIR (ROW)
                          IMINHI = I
                          TRUDEG = AHIR (ROW)
                          ENDIF
                       ENDIF
                    ENDIF
1861             CONTINUE
              MINHI = TRUDEG
           ELSE
C
C     DO NOT CONSIDER WHETHER A PIVOT IS SYMMETRIC OR NOT
C
              DO 1761 I = K1, FFDEGC
                 VALUE = ABS (WX (I))
                 IF (VALUE .GE. TOLER .AND. VALUE .GT. ABSTOL) THEN
                    ROW = II(FFIPC+(I)-1)
                    IF (ALOR (ROW) .LE. FFDIMR-K .AND.
     &                  AHIR (ROW) .LT. MINHI) THEN
                       MINHI = AHIR (ROW)
                       IMINHI = I
                       ENDIF
                    ENDIF
1761             CONTINUE
              ENDIF
           AHIC (PIVCOL) = FEDEGC - K
           ALOC (PIVCOL) = FEDEGC - K
1707       CONTINUE
           DO 1763 I = 1, FEDEGC
              WX (I) = ZERO
1763          CONTINUE
C
C     WX IS NOW ZERO
C
        ELSE
           VALUE = UXVMX1
     &             (FFDEGC-K, XX(FFXP+((K1)-1)+((K1)-1)*FFDIMC), JJ)
           KP = K + JJ
           MAXVAL = ABS (XX(FFXP+((KP)-1)+((K1)-1)*FFDIMC))
           TOLER = RELTOL * MAXVAL
           IF (MAXVAL .LE. ABSTOL) THEN
C
C     SINGULAR MATRIX
C     FLAG THIS COLUMN AS PERMANENTLY REMOVED FROM PIVOT SERCH
C
              AHINXT (PIVCOL) = -1
              GOTO 8000
              ENDIF
C
C     LOOK FOR BEST PIVOT, ONLY LOOK FOR PIVOT ENTRIES
C     RESIDING IN CURRENT FRONTAL MATRIX
C
           IF (SYMSRC) THEN
C
C     ALWAYS PREFER SYMMETRIC PIVOTS, IF NUMERICALLY ACCEPTABLE
C
              TRUDEG = MAXINT
              DO 1862 I = K1, FFDEGC
                 VALUE = ABS (XX(FFXP+((I)-1)+((K1)-1)*FFDIMC))
                 IF (VALUE .GE. TOLER .AND. VALUE .GT. ABSTOL) THEN
                    ROW = II(FFIPC+(I)-1)
                    IF (ALOR (ROW) .LE. FFDIMR-K) THEN
                       IF (ROW .EQ. PIVCOL) THEN
C
C     ALWAYS PREFER SYMMETRIC PIVOTS, IS POSSIBLE
C
                          MINHI = 0
                          IMINHI = I
                          TRUDEG = AHIR (ROW)
                       ELSE IF (AHIR (ROW) .LT. MINHI) THEN
                          MINHI = AHIR (ROW)
                          IMINHI = I
                          TRUDEG = AHIR (ROW)
                          ENDIF
                       ENDIF
                    ENDIF
1862             CONTINUE
              MINHI = TRUDEG
           ELSE
C
C     DO NOT CONSIDER WHETHER A PIVOT IS SYMMETRIC OR NOT
C
              DO 1762 I = K1, FFDEGC
                 VALUE = ABS (XX(FFXP+((I)-1)+((K1)-1)*FFDIMC))
                 IF (VALUE .GE. TOLER .AND. VALUE .GT. ABSTOL) THEN
                    ROW = II(FFIPC+(I)-1)
                    IF (ALOR (ROW) .LE. FFDIMR-K .AND.
     &                  AHIR (ROW) .LT. MINHI) THEN
                       MINHI = AHIR (ROW)
                       IMINHI = I
                       ENDIF
                    ENDIF
1762             CONTINUE
              ENDIF
           ENDIF
C
C     COMPUTE EXTENDED CANDIDATE PIVOT ROW
C
        IF (MINHI .EQ. MAXINT) THEN
C
C     NO CANDIDATE PIVOT ROW FOUND
C
           GOTO 8000
           ENDIF
        PIVROW = II(FFIPC+(IMINHI)-1)
        IF (AHIR (PIVROW) .EQ. FFLEFR) THEN
C
C     THIS ROW IS SUPERROW. NO NEED TO COMPUTE TRUE DEGREE
C
        ELSE
C
C     COMPUTE TRUE DEGREE OF THE PIVOT ROW. PLACE PATTERN IN FFIR.
C     SCAN TUPLES
C
           AFP = AFLPR (PIVROW)
           IF (AFP .NE. NIL) THEN
              DO 1831 P = II(AFP-1),(AFP-2)-2,2
                 ECOL = II(P)
                 IF (FLEFTC (ECOL) .EQ. 0) GOTO 1831
                 EP = FP (ECOL)
                 FRIPR = ((EP)+5+II((EP)+3))
C
C     SCATTER THE ELEMENT INTO SCATTERED FORM OF PIVOT ROW
C
                 DO 1140 J = 1, II((EP)+2)
                    COL = II(FRIPR+(J)-1)
                    IF (COL .GT. 0) THEN
                       IF (WIC (COL) .LT. 0) THEN
                          IF (FEDEGR .GE. FFDIMR) THEN
                             ALOR (PIVROW) = FEDEGR - K + 1
                             GOTO 8000
                             ENDIF
                          WIC (COL) = FEDEGR * FFDIMC
                          FEDEGR = FEDEGR + 1
                          II(FFIPR+(FEDEGR)-1) = COL
                          ENDIF
                       ENDIF
1140                CONTINUE
1831             CONTINUE
              ENDIF
C
C     SCAN THE ORIGINAL ROW
C
           IF (ALEFTR (PIVROW) .GT. 0) THEN
              DO 1135 PA = AROWP (PIVROW), AROWP (PIVROW+1) - 1
                 COL = II(AROWIP-1+(PA))
                 IF (ALEFTC (COL) .GT. 0) THEN
                    IF (WIC (COL) .LT. 0) THEN
                       IF (FEDEGR .GE. FFDIMR) THEN
                          ALOR (PIVROW) = FEDEGR - K + 1
                          GOTO 8000
                          ENDIF
                       WIC (COL) = FEDEGR * FFDIMC
                       FEDEGR = FEDEGR + 1
                       II(FFIPR+(FEDEGR)-1) = COL
                       ENDIF
                    ENDIF
1135             CONTINUE
              ENDIF
           ALOR (PIVROW) = FEDEGR - K
           AHIR (PIVROW) = FEDEGR - K
           ENDIF
C
C      PIVOT FOUND, FACTOR THE PIVOT ROW
C
C
C     SWAP WITH LEADING ROW
C
        IF (IMINHI .NE. K1) THEN
           CALL UXVSWP
     &          (FFDEGR,
     &          XX(FFXP+((K1)-1)+((    1)-1)*FFDIMC),
     &          XX(FFXP+((IMINHI)-1)+((1)-1)*FFDIMC), FFDIMC)
           WIR (II(FFIPC+(K1)-1)) = IMINHI - 1
           WIR (PIVROW) = K
           II(FFIPC+(IMINHI)-1) = II(FFIPC+(K1)-1)
           II(FFIPC+(K1)-1) = PIVROW
           ENDIF
C
C     UPDATE THE PIVOT ROW WITH PREVIOUS PIVOTS
C
        K2 = K + 2
        CALL UXEGMV
     &          (K-K0, FFLEFR-1, -ONE,
     &          XX(FFXP+((K0+1)-1)+((   K2)-1)*FFDIMC), FFDIMC,
     &          XX(FFXP+((K1)-1)+((   K0+1)-1)*FFDIMC), FFDIMC,
     &          ONE,
     &          XX(FFXP+((K1)-1)+((     K2)-1)*FFDIMC), FFDIMC, 1)
C
C     PREPARE FOR DEGREE UPDATE AND NEXT PIVOT SEARCH
C
        SCAN1 = FFDEGC + 1
        SCAN2 = FFDEGR + 1
        IF (FEDEGC .EQ. FFDEGC) THEN
C
C     COLUMN PATTERN HAS NOT BEEN EXTENDED
C
           SCAN3 = FFDEGR + 1
C
C     SCAN 3A: LOOK FOR BEST CANDIDATE COLUMN IN OLD COLUMNS,
C              UPDATE COLUMN DEGREES IF SUPERROW IS SELECTED AS PIVOT
C              (COLUMN PATTERN IS NOT EXTENDED)
C
           CANDEG = MAXINT
           DO 530 JJ = K1, FFDEGR
              COL = II(FFIPR+(JJ)-1)
              LO = ALOC (COL) - 1
              HI = AHIC (COL) - 1
C
C     FIND THE BEST CANDIDATE PIVOT COLUMN
C
              IF (PIVCOL .NE. COL .AND. LO .GT. 0 .AND.
     &            LO .LE. FFDIMC-K .AND. HI .LT. CANDEG .AND.
     &            AHINXT (COL) .GE. 0) THEN
                 CANDEG = HI
                 CANCOL = COL
                 CANOFF = JJ
                 ENDIF
              ALOC (COL) = LO
              AHIC (COL) = HI
530           CONTINUE
        ELSE
C
C     COLUMN PATTERN HAS BEEN EXTENDED
C
           SCAN3 = K1
           ENDIF
        IF (FEDEGR .EQ. FFDEGR) THEN
C
C     ROW PATTERN HAS NOT BEEN EXTENDED
C
           SCAN4 = FFDEGC + 1
C
C     SCAN 4A: UPDATE ROW DEGREES IF SUPERCOLUMN IS SELECTED AS PIVOT
C              (ROW PATTERN IS NOT EXTENDED)
C
           DO 535 JJ = K1, FFDEGC
              ROW = II(FFIPC+(JJ)-1)
              ALOR (ROW) = ALOR (ROW) - 1
              AHIR (ROW) = AHIR (ROW) - 1
535           CONTINUE
       ELSE
C
C     ROW PATTERN HAS BEEN EXTENDED
C
           SCAN4 = K1
           ENDIF
C
C     EXTEND THE FRONTAL MATRIX
C
        K = K + 1
        FFLEFC = FEDEGC - K
        FFLEFR = FEDEGR - K
C
C     SKIP THE DEGREE UPDATE PHASE IF THE FRONTAL MATRIX
C     WAS NOT EXTENDED
C
        IF (FEDEGR .EQ. FFDEGR .AND. FEDEGC .EQ. FFDEGC) GOTO 810
C
C     ZERO THE NEWLY EXTENDED FRONTAL MATRIX
C
        DO 510 J = FFDEGR+1, FEDEGR
           DO 510 I = 1, FEDEGC
510           XX(FFXP+((I)-1)+((J)-1)*FFDIMC) = ZERO
        DO 551 I = FFDEGC+1, FEDEGC
           DO 551 J = 1, FFDEGR
551           XX(FFXP+((I)-1)+((J)-1)*FFDIMC) = ZERO
C
C     REMOVE THE NEW COLUMNS FROM THE DEGREE LISTS
C
        IF (NLOSRC .NE. 0) THEN
           DO 614 J = FFDEGR+1, FEDEGR
              COL = II(FFIPR+(J)-1)
              LO = ALOC (COL)
              IF (LO .GT. 0 .AND. AHINXT (COL) .GE. 0) THEN
                 ALOCNT = ALOCNT - 1
                 NEXTP = ALONXT (COL)
                 PREVP = ALOPRV (COL)
                 IF (NEXTP .NE. NIL) ALOPRV (NEXTP) = PREVP
                 IF (PREVP .NE. NIL) THEN
                    ALONXT (PREVP) = NEXTP
                 ELSE
C
C     COLUMN IS AT THE HEAD OF THE LIST
C
                    ALOHED (LO) = NEXTP
                    IF (NEXTP .NE. NIL .OR. ALOCNT .EQ. 0) GOTO 614
C
C     REMOVED THE LAST ENTRY IN A LIST, UPDATE MIN/MAX
C
                    IF (LO .EQ. ALOMIN) THEN
604                     ALOMIN = ALOMIN + 1
                        IF (ALOHED (ALOMIN) .EQ. NIL) GOTO 604
                    ELSE IF (LO .EQ. ALOMAX) THEN
624                     ALOMAX = ALOMAX - 1
                        IF (ALOHED (ALOMAX) .EQ. NIL) GOTO 624
                        ENDIF
                    ENDIF
                 ENDIF
614           CONTINUE
           ENDIF
        IF (NHISRC .NE. 0) THEN
           DO 615 J = FFDEGR+1, FEDEGR
              COL = II(FFIPR+(J)-1)
              HI = AHIC (COL)
              IF (HI .GT. 0 .AND. AHINXT (COL) .GE. 0) THEN
                 AHICNT = AHICNT - 1
                 NEXTP = AHINXT (COL)
                 PREVP = AHIPRV (COL)
                 IF (NEXTP .NE. NIL) AHIPRV (NEXTP) = PREVP
                 IF (PREVP .NE. NIL) THEN
                    AHINXT (PREVP) = NEXTP
                 ELSE
C
C     COLUMN IS AT THE HEAD OF THE LIST
C
                    AHIHED (HI) = NEXTP
                    IF (NEXTP .NE. NIL .OR. AHICNT .EQ. 0) GOTO 615
C
C     REMOVED THE LAST ENTRY ON A LIST, UPDATE MIN/MAX
C
                    IF (HI .EQ. AHIMIN) THEN
605                     AHIMIN = AHIMIN + 1
                        IF (AHIHED (AHIMIN) .EQ. NIL) GOTO 605
                    ELSE IF (HI .EQ. AHIMAX) THEN
625                     AHIMAX = AHIMAX - 1
                        IF (AHIHED (AHIMAX) .EQ. NIL) GOTO 625
                        ENDIF
                    ENDIF
                 ENDIF
615           CONTINUE
           ENDIF
C
C     FINALIZE THE EXTENDED ROW AND COLUMN PATTERN OF THE FRONTAL MATRIX
C
        FFDEGC = FEDEGC
        FFDEGR = FEDEGR
        GOTO 800
8000    CONTINUE
C
C     DONE EXTENDING THE CURRENT FRONTAL MATRIX
C
        SGLTON = FFLEFR .LE. 0 .OR. FFLEFC .LE. 0
C
C     CLEAR THE PIVOT ROW AND COLUMN OFFSETS
C
        DO 784 I = 1, FEDEGC
           WIR (II(FFIPC+(I)-1)) = -1
784        CONTINUE
        DO 787 I = 1, FEDEGR
           WIC (II(FFIPR+(I)-1)) = -1
787        CONTINUE
        FRDEGC = FFLEFC
        IF (.NOT. SGLTON) THEN
           CALL UXEGMM
     &          (FFLEFC, FFDEGR-COLUPD+1, K-K0, -ONE,
     &          XX(FFXP+((K+1)-1)+((       K0+1)-1)*FFDIMC), FFDIMC,
     &          XX(FFXP+((K0+1)-1)+(( COLUPD)-1)*FFDIMC), FFDIMC,
     &          ONE,
     &          XX(FFXP+((K+1)-1)+((  COLUPD)-1)*FFDIMC), FFDIMC)
           ENDIF
C
C     ALLOCATE SPACE FOR THE NEW FRONTAL MATRIX AND LU ARROWHEAD. CAN
C     BE DONE IN PLACE IF NECESSARY.
C
        IF (.NOT. SGLTON) THEN
C
C     MOVE THE CONTRIBUTION BLOCK TO THE TAIL OF XX
C
           CALL UXIGET(MMEM,ERROR,
     &          2,FFLEFC*FFLEFR,2,FRXP)
           IF (ERROR .NE. 0) GOTO 9998
           IF (FRXP .EQ. NIL) THEN
              XGAR = XGAR + 1
              CALL UXIXGR(XX,II,MMEM,LUTIP,FP,SLU,AN,
     &                  ERROR,GARBAG)
              IF (ERROR .NE. 0) GOTO 9998
              P = FFXP + FFDEGR * FFDIMC
              IF (P .NE. MMEM (1,2)) THEN
                 CALL UXIFRE(MMEM,ERROR,2,MMEM(1,2)-P,P)
                 ENDIF
              IF (ERROR .NE. 0) GOTO 9998
              CALL UXIGET(MMEM,ERROR,
     &          2,FFLEFC*FFLEFR,2,FRXP)
              IF (ERROR .NE. 0) GOTO 9998
              IF (FRXP .EQ. NIL) GOTO 9997
              ENDIF
           DO 460 J = 1, FFLEFR
              DO 460 I = 1, FFLEFC
                 XX(FRXP+((I)-1)+((J)-1)* FRDEGC) =
     &           XX(FFXP+((I+K)-1)+(( J+K)-1)*FFDIMC)
460              CONTINUE
          ENDIF
C
C     MOVE THE (L1\U1 AND L2) MATRIX IN PLACE, COMPRESSING THE
C     DIMENSION FROM FFDIMC TO FFDEGC. THE LU ARROWHEAD GROWS ON TOP
C     OF THE STACK.
C
        LUAXP = FFXP
        IF (.NOT. SGLTON) FFXP = FRXP
        IF (FFDEGC .NE. FFDIMC) THEN
           XDP = LUAXP + FFDEGC
           XSP = LUAXP + FFDIMC
           DO 440 J = 2, K
              DO 450 I = 1, FFDEGC
                 XX (XDP) = XX (XSP)
                 XDP = XDP + 1
                 XSP = XSP + 1
450              CONTINUE
              XSP = XSP + (FFDIMC - FFDEGC)
440           CONTINUE
        ELSE
           XDP = LUAXP + K*FFDEGC
           XSP = XDP
           ENDIF
C
C     MOVE THE U2 BLOCK
C
        IF (FFLEFR .NE. 0) THEN
           DO 470 J = K+1, FFDEGR
              DO 480 I = 1, K
                 XX (XDP) = XX (XSP)
                 XDP = XDP + 1
                 XSP = XSP + 1
480              CONTINUE
              XSP = XSP + (FFDIMC - K)
470           CONTINUE
           ENDIF
C
C     DEALLOCATE STACK
C
        P = LUAXP + K*FFDEGC + K*FFDEGR - K*K
           CALL UXIFRE(MMEM,ERROR,2,MMEM(1,2)-P,P)
           IF (ERROR .NE. 0) GOTO 9998
C
C     FINALIZE THE SCALAR DATA FOR THE CURRENT FRONTAL MATRIX
C
        IF (SGLTON) THEN
C
C     FLAG THE NEW FRONTAL MATRIX AS ALREADY ASSEMBLED
C
           II(FFP) = NIL
           FLEFTR (FFCOL) = 0
           FLEFTC (FFCOL) = 0
        ELSE
           II(FFP) = FFXP
           FLEFTR (FFCOL) = FFLEFR
           FLEFTC (FFCOL) = FFLEFC
           ENDIF
        FP (FFCOL) = FFP
        II((FFP)+1) = K
        II((FFP)+2) = FFLEFR
        II((FFP)+3) = FFLEFC
        II((FFP)+4) = NSONS
C
C     COMPRESS THE SPACE OUT OF THE CURRENT FRONTAL MATRIX PATTERN
C
        DO 485 I = 1, FFLEFC
485        II(FFIPC+(I)-1) = II(FFIPC+(I + K)-1)
        DO 490 I = 1, FFLEFR
490        II(FFIPC+(I + FFLEFC)-1) = II(FFIPR+(I + K)-1)
        FFIPR = FFIPC + FFLEFC
        FFIP (R) = FFIPR
C
C     ADD LIST OF SONS AFTER THE END OF THE FRONTAL MATRIX PATTERN
C
        P = FFIPR + FFLEFR
        IF (P + NSONS .GT. MMEM (2,1)) THEN
           IGAR = IGAR + 1
           CALL UXIIGR(II,MMEM,PERM2,AFLP,FLEFTC,AN,
     &                  ERROR,GARBAG)
           IF (ERROR .NE. 0) GOTO 9998
           IF (P + NSONS .GT. MMEM (2,1)) GOTO 9999
           ENDIF
        IF (P + NSONS .GT. MMEM (1,1)) THEN
C
C     NEED MORE SPACE
C
           CALL UXIGET(MMEM,ERROR,
     &                  1,P+NSONS-MMEM(1,1),1,P1)
           IF (ERROR .NE. 0) GOTO 9998
           IF (P1 .EQ. NIL) GOTO 9999
        ELSE IF (P + NSONS .LT. MMEM (1,1)) THEN
C
C     FREE UNUSED SPACE
C
           CALL UXIFRE(MMEM,ERROR,
     &                  1,MMEM(1,1)-(P+NSONS),P+NSONS)
           IF (ERROR .NE. 0) GOTO 9998
           ENDIF
        IF (NSONS .GT. 0) THEN
           ECOL = SONLST
           DO 495 I = 1, NSONS
              IF (WJC (ECOL) .EQ. WJZERO) THEN
C
C     THIS IS A U-SON OR LU-SON
C
                 IF (WJR (ECOL) .EQ. WJZERO) THEN
C
C     AN LU-SON
C
                    II(P) = ECOL
                 ELSE
C
C     A U-SON
C
                    II(P) = - (ECOL + AN)
                    ENDIF
              ELSE
C
C     THIS IS AN L-SON
C
                 II(P) = -ECOL
                 ENDIF
              NEXT = -FSONL (ECOL)
              FSONL (ECOL) = 0
              ECOL = NEXT
              P = P + 1
495           CONTINUE
           ENDIF
C
C     PLACE THE MODIFIED COLUMNS BACK IN THE DEGREE LISTS
C
        IF (NLOSRC .NE. 0 .AND. FFLEFR .GT. 0) THEN
           DO 520 J = FFLEFR, 1, -1
              COL = II(FFIPR+(J)-1)
              LO = ALOC (COL)
              IF (LO .GT. 0 .AND. AHINXT (COL) .GE. 0) THEN
                 ALOCNT = ALOCNT + 1
                 H = ALOHED (LO)
                 ALONXT (COL) = H
                 ALOPRV (COL) = NIL
                 IF (H .NE. NIL) ALOPRV (H) = COL
                 ALOHED (LO) = COL
                 IF (ALOCNT .EQ. 1) THEN
                    ALOMIN = LO
                    ALOMAX = LO
                 ELSE
                    ALOMIN = MIN (ALOMIN, LO)
                    ALOMAX = MAX (ALOMAX, LO)
                    ENDIF
                 ENDIF
520           CONTINUE
           ENDIF
        IF (NHISRC .NE. 0 .AND. FFLEFR .GT. 0) THEN
           DO 522 J = FFLEFR, 1, -1
              COL = II(FFIPR+(J)-1)
              HI = AHIC (COL)
              IF (HI .GT. 0 .AND. AHINXT (COL) .GE. 0) THEN
                 AHICNT = AHICNT + 1
                 H = AHIHED (HI)
                 AHINXT (COL) = H
                 AHIPRV (COL) = NIL
                 IF (H .NE. NIL) AHIPRV (H) = COL
                 AHIHED (HI) = COL
                 IF (AHICNT .EQ. 1) THEN
                    AHIMIN = HI
                    AHIMAX = HI
                 ELSE
                    AHIMIN = MIN (AHIMIN, HI)
                    AHIMAX = MAX (AHIMAX, HI)
                    ENDIF
                 ENDIF
522           CONTINUE
           ENDIF
C
C     UPDATE THE DEGREE OF ANY COLUMNS WITH DEGREES GREATER THAN KLEFT.
C     THESE ARE COLUMNS THAT ARE NOT AFFECTED BY THE CURENT ELEMENT.
C
        IF (NLOSRC .NE. 0 .AND. ALOMAX .GT. KLEFT) THEN
           IF (ALOCNT .GT. 0) THEN
              DO 2040 LO = KLEFT + 1, ALOMAX
                 COL = ALOHED (LO)
                 ALOHED (LO) = NIL
2050             IF (COL .NE. NIL) THEN
                    ALOC (COL) = KLEFT
                    NEXTP = ALONXT (COL)
C
C     MOVE THE COLUMN TO THE DEGREE LIST KLEFT
C
                    H = ALOHED (KLEFT)
                    ALONXT (COL) = H
                    ALOPRV (COL) = NIL
                    IF (H .NE. NIL) ALOPRV (H) = COL
                    ALOHED (KLEFT) = COL
                    COL = NEXTP
                    GOTO 2050
                    ENDIF
2040             CONTINUE
              ENDIF
           ALOMAX = KLEFT
           IF (ALOCNT .EQ. 1) THEN
              ALOMIN = KLEFT
           ELSE
              ALOMIN = MIN (ALOMIN, KLEFT)
              ENDIF
           ENDIF
        IF (NHISRC .NE. 0 .AND. AHIMAX .GT. KLEFT) THEN
           IF (AHICNT .GT. 0) THEN
              DO 2041 HI = KLEFT + 1, AHIMAX
                 COL = AHIHED (HI)
                 AHIHED (HI) = NIL
2051             IF (COL .NE. NIL) THEN
                    AHIC (COL) = KLEFT
                    NEXTP = AHINXT (COL)
C
C     MOVE THE COLUMN TO THE DEGREE LIST KLEFT
C
                    H = AHIHED (KLEFT)
                    AHINXT (COL) = H
                    AHIPRV (COL) = NIL
                    IF (H .NE. NIL) AHIPRV (H) = COL
                    AHIHED (KLEFT) = COL
                    COL = NEXTP
                    GOTO 2051
                    ENDIF
2041             CONTINUE
              ENDIF
           AHIMAX = KLEFT
           IF (AHICNT .EQ. 1) THEN
              AHIMIN = KLEFT
           ELSE
              AHIMIN = MIN (AHIMIN, KLEFT)
              ENDIF
           ENDIF
C
C     RESET WJR, WJC
C
        WJFLAG = WJFLAG + KLEFT + 1
C
C     RESET WJR, WJC IF WJFLAG GETS TOO BIG
C
        IF (WJFLAG .GE. BIG) THEN
           DO 1776 KK = KFIRST, KLAST
              WJR (KK) = 0
              WJC (KK) = 0
1776          CONTINUE
           WJFLAG = AN+2
           ENDIF
C
C     USE THE AFLIST DATA STRUCTURES TO PLACE THIS FRONTAL IN THE
C     APPROPRIATE LISTS. IF THE NEW FRONTAL MATRIX IS A SINGLETON,
C     THEN IT IS NOT PLACED IN THE LIST.
C
        IF (.NOT. SGLTON) THEN
        DO 521 RC = R, C
           CR = 3 - RC
           DO 511 J = 1, II((FFP)+1+(CR))
C
C     WORKING ROW/COLUMN I OF A MATRIX, J-TH ROW/COLUMN OF CONTRIBUTION
C
              I = II(FFIP( CR)+(J)-1)
              AFP = AFLP (I,RC)
              IF (AFP .NE. NIL) THEN
                 PH = II(AFP-2)
                 PA = II(AFP-1) - 2
                 RANOUT = PA .LT. PH
              ELSE
                 RANOUT = .TRUE.
                 ENDIF
              IF (RANOUT) THEN
C
C     RAN OUT SPACE - TRY TO DELETE TUPLES
C
                 IF (AFP .NE. NIL) THEN
                    PA = II(AFP-1)
                    PT = (AFP-2)
                    P = PA
C
C     SCAN TUPLES
C
514                    IF (P .GE. PT) GOTO 513
                       ECOL = II(P)
                       IF (FLEFTC (ECOL) .EQ. 0) THEN
C
C     DELETE TUPLE
C                         II(P) = II(PA)
                          II(P+1) = II(PA+1)
                          PA = PA + 2
                          ENDIF
                       P = P + 2
                       GOTO 514
513                    CONTINUE
                    II(AFP-1) = PA
                    PA = PA - 2
                    RANOUT = PA .LT. PH
                 ELSE
                    RANOUT = .TRUE.
                    PH = NIL
                    PA = NIL
                    PT = NIL
                    ENDIF
                 IF (RANOUT) THEN
C
C     STILL NO SPACE - REALLOCATE SOMEWHERE ELSE
C
                    IF (AFP .NE. NIL) THEN
                       IIHAVE = PT - PH + 3
                       IIADD = (AFLEXT + 1) * 2
                    ELSE
                       IIHAVE = 0
                       IIADD = (AFLEXT + 1) * 2 + 3
                       ENDIF
                    IINEED = IIHAVE + IIADD
                    CALL UXIGET(MMEM,ERROR,
     &                  1,IINEED,2,PH2)
                    IF (ERROR .NE. 0) GOTO 9998
                    IF (PH2 .EQ. NIL) THEN
                        IGAR = IGAR + 1
                        CALL UXIIGR (II,MMEM,PERM2,AFLP,FLEFTC,AN,
     &                          ERROR,GARBAG)
                        IF (ERROR .NE. 0) GOTO 9998
                        AFP = AFLP (I,RC)
                        IF (AFP .NE. NIL) THEN
                           PH = II(AFP-2)
                           PA = II(AFP-1)
                           PT = (AFP-2)
                        ELSE
                           PH = NIL
                           PA = NIL
                           PT = NIL
                           ENDIF
                        CALL UXIGET(MMEM,ERROR,
     &                          1,IINEED,2,PH2)
                        IF (ERROR .NE. 0) GOTO 9998
                        IF (PH2 .EQ. NIL) GOTO 9999
                        ENDIF
                    AFP2 = PH2 + IINEED - 1
                    IF (RC .EQ. R) THEN
                       II(AFP2) = I
                    ELSE
                       II(AFP2) = -I
                       ENDIF
                    IF (AFP .NE. NIL) THEN
C
C     COPY THE AFLIST INTO THE NEW SPACE
C
                       P1 = PH2 + IIADD
                       DO 515 JJ = 0, PT-1-PH
                          II(P1+JJ) = II(PH+JJ)
515                       CONTINUE
                       PA = II(AFP-1)
C
C     CAN NOW DEALLOCATE OLD SPACE POINTED TO BY PH
C
                       II(AFP) = NIL
                       CALL UXIFRE(MMEM,ERROR,
     &                          1,IIHAVE,AFP)
                       IF (ERROR .NE. 0) GOTO 9998
                       ENDIF
                    AFP = AFP2
                    AFLP (I,RC) = AFP
                    PT2 = (AFP-2)
                    PH = PH2
                    PA = PT2 - (PT - PA)
                    II(AFP-2) = PH
                    II(AFP-1) = PA
                    PA = PA - 2
                    ENDIF
                 ENDIF
C
C     ADD NEW TUPLE
C
              II(PA) = FFCOL
              II(PA+1) = J
              II(AFP-1) = PA
511           CONTINUE
521        CONTINUE
        ENDIF
C
C     INCREMENT COUNT OF NUMBER OF FRONTAL MATRICES CREATED,
C     SAVE POINTERS TO LU ARROWHEAD
C
        SLU = SLU + 1
        LUTIP (AN - SLU + 1) = FFCOL
        LUTXP (FFCOL) = LUAXP
        GOTO 1000
1010    CONTINUE
C
C     SINGLE BLOCK FACTORED
C
C
C     DEALLOCATE THE ROW-ORIENTED DATA STRUCTURE, ALL AFLISTS,
C     AND ALL FRONTAL MATRICES
C
        SAVE3 (1,1) = MMEM (1,1)
        SAVE3 (1,2) = MMEM (1,2)
        CALL UXIRST(MMEM,ERROR,SAVE3,1)
        IF (ERROR .NE. 0) GOTO 9998
        CALL UXIRST(MMEM,ERROR,SAVE3,2)
        IF (ERROR .NE. 0) GOTO 9998
        ENDIF
        GOTO 9000
9010    CONTINUE
C
C     ALL BLOCKS FACTORED
C
C
C     WRAP-UP: STORE LU FACTORS IN THEIR FINAL FORM
C
C
C     DEALLOCATE FRONTAL MATRICES
C
        TAIL1 (1,1) = MMEM  (1,1)
        TAIL1 (1,2) = MMEM  (1,2)
        TAIL1 (2,2) = MMEM  (4,2)
        CALL UXIRST(MMEM,ERROR,TAIL1,1)
        IF (ERROR .NE. 0) GOTO 9998
        CALL UXIRST(MMEM,ERROR,TAIL1,2)
        IF (ERROR .NE. 0) GOTO 9998
        LUNS = SLU
        LUBLP (ABLKS+1) = SLU + 1
C
C     ALLOCATE SPACE FOR LU MATRIX INFORMATION
C
        CALL UXIGET(MMEM,ERROR,1,LUNS,1,LUPP)
        IF (ERROR .NE. 0) GOTO 9998
        IF (LUPP .EQ. NIL) GOTO 9999
        II(5) = LUNS
        II(6) = LUPP
C
C     COMBINE PERMUTATIONS TO BLOCK-UPPER-TRIANGULAR, AND THE PERMUTATIONS
C     FOUND DURING LU FACTORIZATION
C
        DO 855 I = 1, AN
           IF (PERM2C (I) .LT. 0) THEN
C
C     THIS WAS A GOOD PIVOT COLUMN
C
              PERM2C (I) = -PERM2C (I)
              WM (I) = 0
           ELSE
C
C     THIS WAS NUMERICALLY UNACCEPTABLE PIVOT COLUMN
C
              WM (I) = 1
              ENDIF
855        CONTINUE
        DO 856 I = 1, AN
           IF (WM (PERMC (I)) .EQ. 0) THEN
              PERMC (I) = PERM2C (PERMC (I))
           ELSE
              PERMC (I) = -PERM2C (PERMC (I))
              ENDIF
856        CONTINUE
        DO 857 I = 1, AN
           IF (PERM2R (I) .LT. 0) THEN
C
C     THIS WAS A GOOD PIVOT ROW
C
              PERM2R (I) = -PERM2R (I)
              WM (I) = 0
           ELSE
C
C     THIS WAS NUMERICALLY UNACCEPTABLE PIVOT ROW
C
              WM (I) = 1
              ENDIF
857        CONTINUE
        DO 858 I = 1, AN
           IF (WM (PERMR (I)) .EQ. 0) THEN
              PERMR (I) = PERM2R (PERMR (I))
           ELSE
              PERMR (I) = -PERM2R (PERMR (I))
              ENDIF
858        CONTINUE
C
C     UPDATE THE INDICES IN LU TO REFLECT THE FINAL ORDERING
C
        DO 840 S = 1, LUNS
           ECOL = LUTIP (AN-S+1)
           EP = FP (ECOL)
           II (LUPP-1+S) = EP
           II(EP) = LUTXP (ECOL)
           NODE = II((EP)+1)
           LIP = ((EP)+5)
           UIP = ((EP)+5+II((EP)+3))
           FFSONP = ((EP)+5+II((EP)+2)+II((EP)+3))
C
C     COMPUTE MAPPING FROM ECOL TO SLU
C
           WM (ECOL) = S
           DO 841 P = LIP, LIP+II((EP)+3)-1
              II (P) = PERM2R (ABS (II (P)))
841           CONTINUE
           DO 842 P = UIP, UIP+II((EP)+2)-1
              II (P) = PERM2C (ABS (II (P)))
842           CONTINUE
C
C     RENAME THE ELEMENTS IN DAG, FROM ECOL TO SLU
C
           DO 843 I = 1, II((EP)+4)
              SON = II(FFSONP+(I)-1)
              IF (SON .GT. 0) THEN
C
C     LU-SON
C
                 II(FFSONP+(I)-1) = WM (SON)
              ELSE IF (SON .GE. -AN) THEN
C
C     L-SON
C
                 II(FFSONP+(I)-1) = -WM (-SON)
              ELSE
C
C     U-SON
C
                 II(FFSONP+(I)-1) = -(WM (-(SON+AN))+AN)
                 ENDIF
843           CONTINUE
840        CONTINUE
        RETURN
C
C     ERROR CONDITIONS
C
9996  ERROR = 68
      CALL UOERR1('UXSGS2',ERROR)
      RETURN
9997  ERROR = 66
      CALL UOERR1('UXSGS2',ERROR)
      RETURN
9998  ERROR = 64
      CALL UOERR1('UXSGS2',ERROR)
      RETURN
9999  ERROR = 65
      CALL UOERR1('UXSGS2',ERROR)
      RETURN
      END
