* SUBROUTINE UXSGS8                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDS FROM UMFPACK.
*
      SUBROUTINE UXSGS8(TCOLP,TCOLI,ALEFTC,TP,WORKI,
     & IPERMR,IPERMC,ZPERM,TLEN,AN,ANZ2,ABLKS)
      INTEGER AN,ANZ2,TCOLP(AN+1),ALEFTC(AN),TCOLI(ANZ2),
     & WORKI(AN,4),TLEN(AN),IPERMR(AN),IPERMC(AN),
     & ZPERM(AN),ABLKS,COL,COLNEW,TP(AN+1),COLOLD,NDIAG,R,C
      PARAMETER (R = 1, C = 2)
      DO 65 COL = 1, AN+1
      TP (COL) = TCOLP (COL)
65    CONTINUE
C
C     FIND A COLUMN PERMUTATION FOR A ZERO-FREE DIAGONAL
C
      CALL UXSRSP(AN,ANZ2,TCOLP,TCOLI,ZPERM,NDIAG,WORKI(1,1),
     & WORKI(1,2),WORKI(1,3),WORKI(1,4))
C
C     PERMUTE THE COLUMNS OF THE TEMPORARY MATRIX
C
      DO 110 COLNEW = 1, AN
      COLOLD = ZPERM (COLNEW)
      TP (COLNEW) = TCOLP (COLOLD)
      TLEN (COLNEW) = ALEFTC (COLOLD)
110   CONTINUE
C
C     PERMUTE INTO UPPER BLOCK TRIANGULAR FORM
C
      CALL UXSRSB(AN,ANZ2,TP,TCOLI,TLEN,IPERMR,ABLKS,WORKI(1,1),
     & WORKI(1,2),WORKI(1,3),WORKI(1,4))
      IF (ABLKS .NE. 1) THEN
C
C     FIND THE COMPOSITE COLUMN PERMUTATION
C
      DO 140 COLNEW = 1, AN
      IPERMC (COLNEW) = ZPERM (IPERMR (COLNEW))
140   CONTINUE
      ENDIF
      RETURN
      END
