* SUBROUTINE UXSII3                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 DR : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSIIF.
*
      SUBROUTINE UXSII3(N,M,IA,JA,A,PERM,INVP,KSTEP,COLR,COLS)
      INTEGER N,M,IA(N+1),JA(M),PERM(N),INVP(N),KSTEP
      REAL*8  A(M),COLR(N),COLS(N),DETER,UXSII4
      INTEGER I,J,K,L,II,JJ,KK,LL,JSTRT,JSTOP,JJSTRT,JJSTOP,IND,IIND
      DO 100 I=KSTEP+2,N
C
C     NUMBER OF COLUMN WHICH IS NOW IN I-TH COLUMN
C
      IND=PERM(I)
      JSTRT=IA(IND)
      JSTOP=IA(IND+1)-1
C
C     VALUE OF DETERMINANT OF 2x2 PIVOT IS COMPUTED
C
      DETER=COLR(KSTEP)*COLS(KSTEP+1)-(COLR(KSTEP+1)**2)
C
C     ELEMENTS IN COLUMN IND-TH ARE CHOSEN AND CHANGED
C
      DO 200 J=JSTRT,JSTOP
      K=JA(J)
      L=INVP(K)
      IF (L.GE.I) THEN
      A(J)=A(J)-UXSII4(N,COLR,COLS,DETER,L,KSTEP,I)
      END IF
  200 CONTINUE
      IF (I.LE.IND) THEN
C
C     SHORTER COLUMN IS IN I-TH COLUMN, NEXT RELATED ELEMENTS ARE
C     FOUND AND CHANGED
C
      DO 300 II=(I+1),N
      IIND=PERM(II)
      JJSTRT=IA(IIND)+1
      JJSTOP=IA(IIND+1)-1
      DO 400 JJ=JJSTRT,JJSTOP
      KK=JA(JJ)
      LL=INVP(KK)
      IF (KK.EQ.IND) THEN
      A(JJ)=A(JJ)-UXSII4(N,COLR,COLS,DETER,II,KSTEP,I)
      END IF
  400 CONTINUE
  300 CONTINUE
      END IF
 100  CONTINUE
      RETURN
      END
