* SUBROUTINE UXUDIC                ALL SYSTEMS                11/12/01
C PORTABILITY : ALL SYSTEMS
C 11/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR AUGMENTED BY THE SCALED VECTOR IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= Y + A*X.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXUDIC(N,R,S,X,XL,XU,Z,IX)
      INTEGER N,IX(N)
      REAL*8  R,S(N),X(N),XL(N),XU(N),Z(N)
      INTEGER I,K
      DO 1 I=1,N
      K=ABS(IX(I))
      IF (K.EQ.5) THEN
      Z(I)=X(I)
      ELSE
      Z(I)=X(I)+R*S(I)
      ENDIF
      IF (K.EQ.1.OR.K.EQ.3.OR.K.EQ.4) Z(I)=MAX(Z(I),XL(I))
      IF (K.EQ.2.OR.K.EQ.3.OR.K.EQ.4) Z(I)=MIN(Z(I),XU(I))
    1 CONTINUE
      RETURN
      END
