* SUBROUTINE UXVDIG                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR AUGMENTED BY THE SCALED VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= Y + A*X.
*  II  K  INCREMENT.
*
      SUBROUTINE UXVDIG(N,A,X,Y,Z,K)
      INTEGER N, K
      REAL*8  A, X(N), Y(N), Z(N)
      INTEGER I,J
      IF (K.EQ.1) THEN
      DO 1 I=1,N
      Z(I) = Y(I) + A*X(I)
    1 CONTINUE
      ELSE IF (K.GT.0) THEN
      I=1
      DO 2 J=1,N
      Z(I) = Y(I) + A*X(I)
      I=I+K
    2 CONTINUE
      ELSE IF (K.LT.0) THEN
      I=1
      DO 3 J=1,N
      Z(J) = Y(J) + A*X(I)
      I=I-K
    3 CONTINUE
      ENDIF
      RETURN
      END
