* SUBROUTINE UXVINI             ALL SYSTEMS                   99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ELEMENTS CORRESPONDING TO FIXED VARIABLES ARE SET TO -5.
*
* PARAMETERS :
*  II  N DIMENSION OF THE INTEGER VECTOR.
*  IU  IX(N)  INTEGER VECTOR WHICH IS UPDATED SO THAT IX(I):=ABS(IX(I))
*         FOR ALL I.
*
      SUBROUTINE UXVINI(N,IX)
      INTEGER N,IX(N)
      INTEGER I
      DO 1 I=1,N
      IF (ABS(IX(I)).EQ.5) IX(I)=-5
    1 CONTINUE
      RETURN
      END
