* FUNCTION  UXVNOG               ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* EUCLIDEAN NORM OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXVNOG  EUCLIDEAN NORM OF X.
*
      FUNCTION UXVNOG(N,X,K)
      INTEGER N,K
      REAL*8 X(N),UXVNOG
      REAL*8 DEN,POM
      INTEGER I,J
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      DEN=ZERO
      POM=ZERO
      IF (K.EQ.1) THEN
      DO 1 I=1,N
      DEN=MAX(DEN,ABS(X(I)))
    1 CONTINUE
      IF (DEN.GT.ZERO) THEN
      DO 2 I=1,N
      POM=POM+(X(I)/DEN)**2
    2 CONTINUE
      ENDIF
      ELSE
      I=1
      DO 3 J=1,N
      DEN=MAX(DEN,ABS(X(I)))
      I=I+K
    3 CONTINUE
      IF (DEN.GT.ZERO) THEN
      I=1
      DO 4 J=1,N
      POM=POM+(X(I)/DEN)**2
      I=I+K
    4 CONTINUE
      ENDIF
      ENDIF
      UXVNOG=DEN*SQRT(POM)
      RETURN
      END
