* SUBROUTINE UXVSWP                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SWAP OF TWO VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  FIRST  VECTOR.
*  RO  Y(N)  SECOND VECTOR.
*  II  K  INCREMENT.
*
      SUBROUTINE UXVSWP(N,X,Y,K)
      INTEGER N,K
      REAL*8  X(*),Y(*)
      INTEGER I,J
      REAL*8 TEMP,ZERO
      PARAMETER (ZERO=0.0D 0)
      IF (N.LE.ZERO) RETURN
      IF (K.EQ.1) THEN
      DO 1 I=1,N
      TEMP=Y(I)
      Y(I)=X(I)
      X(I)=TEMP
    1 CONTINUE
      ELSE
      I=1
      DO 2 J=1,N
      TEMP=Y(I)
      Y(I)=X(I)
      X(I)=TEMP
      I=I+K
    2 CONTINUE
      ENDIF
      RETURN
      END
