* SUBROUTINE UXWCOP                ALL SYSTEMS                07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COPYING OF A PACKED OR UNPACKED VECTOR.
*
* PARAMETERS :
*  II  L  PACKED VECTOR DIMENSION.
*  II  N  UNPACKED VECTOR DIMENSION.
*  II  JBL(L)  INDICES OF PACKED VECTOR.
*  RI  X(N)  UNPACKED OR PACKED INPUT VECTOR.
*  RO  Y(N)  UNPACKED OUTPUT VECTOR.
*  II  JOB  FORM OF THE VECTOR X. JOB=1-UNPACKED FORM. JOB=2-PACKED
*         FORM.
*
      SUBROUTINE UXWCOP(L,N,JBL,X,Y,JOB)
      INTEGER L,N,JBL(L),JOB
      REAL*8  X(*), Y(N)
      INTEGER I,IP
      IF (JOB.EQ.1) THEN
      DO 1 I=1,L
      IP=JBL(I)
      IF (IP.GT.0) Y(IP)=X(IP)
    1 CONTINUE
      ELSE
      DO 2 I=1,L
      IP=JBL(I)
      IF (IP.GT.0) Y(IP)=X(I)
    2 CONTINUE
      ENDIF
      RETURN
      END
