* SUBROUTINE UYSDEG                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE DEGREES OF THE VERTICES OF THE ADJACENCY GRAPH
* OF THE HESSIAN.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  K NUMBER OF VERTICES OF THE HESSIAN.
*  II  IH(NF+1) POINTER VECTOR OF SPARSE HESSIAN MATRIX.
*  RO  DEG(NF) DEGREES OF THE VERTICES OF THE ADJACENCY GRAPH
*                 OF THE HESSIAN.
*
      SUBROUTINE UYSDEG(NF,K,IH,DEG)
      INTEGER NF,K,IH(NF+1)
      REAL*8 DEG(NF)
      INTEGER K1,L,I
      K1=1
      DO 100 I=1,K
      L=IH(I+1)
      DEG(I)=L-K1
      K1=L
100   CONTINUE
      RETURN
      END
