* PROGRAM PCHLEB                ALL SYSTEMS                 14/12/01
C PORTABILITY : ALL SYSTEMS
C 14/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  COMPUTES CONTRIBUTIONS OF INDIVIDUAL AUTHORS.
*
* AUTHORS :
*  LU  LADISLAV LUKSAN.
*  SI  MARTIN SISKA.
*  TU  MIROSLAV TUMA.
*  VL  JAN VLCEK.
*  RA  NINA RAMESOVA.
*  MA  CTIRAD MATONOHA.
*  HA  JAN HARTMAN.
*  DA  T.A.DAVIS.
*  DU  I.S.DUFF.
*
      PROGRAM PCHLEB
      INTEGER NAMDIM,NBYTES
      REAL LU(5),TU(5),SI(5),VL(5),RA(5),MA(5),HA(5),DA(5),DU(5),
     & TOTAL(5),TEMP
      CHARACTER*72 TEXT
      CHARACTER*36 BLANK
      CHARACTER*6 BYTE,NAME
      CHARACTER*2 AUTHOR
      INTEGER I
      BLANK='                                    '
      DO 100 I=1,5
      LU(I)=0.0
      TU(I)=0.0
      SI(I)=0.0
      VL(I)=0.0
      RA(I)=0.0
      MA(I)=0.0
      HA(I)=0.0
      DA(I)=0.0
      DU(I)=0.0
      TOTAL(I)=0.0
  100 CONTINUE
      NAMDIM=0
      OPEN (20,FILE='CHLEBA.POM')
      OPEN (21,STATUS='OLD',FILE='UFOI.DAT')
    1 READ (21,'(29X,A6,1X,A6)',END=10) BYTE,NAME
      IF (NAME(1:1).NE.'E'.AND.NAME(1:1).NE.'U'.AND.NAME(1:1).NE.'S'
     & .AND.NAME(1:1).NE.'P') GO TO 1
      READ (BYTE,'(I6)') NBYTES
      WRITE (6,'(1X,A6)') NAME
      OPEN (22,STATUS='OLD',FILE=NAME//'.I')
      I=1
      TEMP=0
      AUTHOR='  '
    2 READ (22,'(A72)',END=20,ERR=3) TEXT
      I=I+1
      IF (TEXT.EQ.BLANK//BLANK) GO TO 2
      TEMP=TEMP+1.0
      IF (TEXT(2:10).EQ.'INTERFACE') THEN
      READ (22,'(A72)',END=20,ERR=3) TEXT
C     TEMP=TEMP+1.0
      AUTHOR=TEXT(6:7)
      ENDIF
      IF (TEXT(8:15).EQ.'TEMPLATE') THEN
      READ (22,'(A72)',END=20,ERR=3) TEXT
C      TEMP=TEMP+1.0
      AUTHOR=TEXT(8:9)
      ENDIF
      IF (TEXT(3:13).EQ.'PORTABILITY') THEN
      READ (22,'(A72)',END=20,ERR=3) TEXT
C     TEMP=TEMP+1.0
      AUTHOR=TEXT(12:13)
      ENDIF
      GO TO 2
    3 WRITE (*,'(''+++ ERROR +++ : FILE = '',A6,''  LINE = '',I5)')
     & NAME,I
      STOP
   20 TOTAL(1)=TOTAL(1)+1.0
      TOTAL(2)=TOTAL(2)+TEMP
      TOTAL(4)=TOTAL(4)+FLOAT(NBYTES)
      IF (NAME.EQ.'UZDCLP') AUTHOR='SI'
      IF (NAME(1:2).EQ.'UM') THEN 
      AUTHOR='LU'
      ELSE IF (AUTHOR.EQ.'KO') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      AUTHOR='LU'
      ELSE IF (AUTHOR.EQ.'MC') THEN 
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      AUTHOR='LU'
      ELSE IF (AUTHOR.EQ.'DR') THEN 
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      AUTHOR='LU'
      ELSE IF (AUTHOR.EQ.'RO') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      AUTHOR='LU'
      ELSE IF (AUTHOR.EQ.'RU') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      AUTHOR='LU'
      ELSE IF (AUTHOR.EQ.'HZ') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      AUTHOR='LU'
      ENDIF
      IF (AUTHOR.EQ.'LU') THEN
      LU(1)=LU(1)+1.0
      LU(2)=LU(2)+TEMP
      LU(4)=LU(4)+FLOAT(NBYTES)
      ELSE IF (AUTHOR.EQ.'TU') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      TU(1)=TU(1)+1.0
      TU(2)=TU(2)+TEMP
      TU(4)=TU(4)+FLOAT(NBYTES)
      ELSE IF (AUTHOR.EQ.'SI') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      SI(1)=SI(1)+1.0
      SI(2)=SI(2)+TEMP
      SI(4)=SI(4)+FLOAT(NBYTES)
      ELSE IF (AUTHOR.EQ.'VL') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      VL(1)=VL(1)+1.0
      VL(2)=VL(2)+TEMP
      VL(4)=VL(4)+FLOAT(NBYTES)
      ELSE IF (AUTHOR.EQ.'RA') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      RA(1)=RA(1)+1.0
      RA(2)=RA(2)+TEMP
      RA(4)=RA(4)+FLOAT(NBYTES)
      ELSE IF (AUTHOR.EQ.'MA') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      MA(1)=MA(1)+1.0
      MA(2)=MA(2)+TEMP
      MA(4)=MA(4)+FLOAT(NBYTES)
      ELSE IF (AUTHOR.EQ.'HA') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      HA(1)=HA(1)+1.0
      HA(2)=HA(2)+TEMP
      HA(4)=HA(4)+FLOAT(NBYTES)
      ELSE IF (AUTHOR.EQ.'DA') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      DA(1)=DA(1)+1.0
      DA(2)=DA(2)+TEMP
      DA(4)=DA(4)+FLOAT(NBYTES)
      ELSE IF (AUTHOR.EQ.'DU') THEN
      WRITE(20,'(1X,A3,3X,A6)') AUTHOR,NAME
      DU(1)=DU(1)+1.0
      DU(2)=DU(2)+TEMP
      DU(4)=DU(4)+FLOAT(NBYTES)
      ELSE
      WRITE (*,'(''+++ ERROR +++ : FILE = '',A6,''  AUTHOR = '',A2)')
     & NAME,AUTHOR
      ENDIF
      GO TO 1
   10 CONTINUE
      LU(3)=100.0*LU(2)/TOTAL(2)
      LU(5)=100.0*LU(4)/TOTAL(4)
      TU(3)=100.0*TU(2)/TOTAL(2)
      TU(5)=100.0*TU(4)/TOTAL(4)
      SI(3)=100.0*SI(2)/TOTAL(2)
      SI(5)=100.0*SI(4)/TOTAL(4)
      VL(3)=100.0*VL(2)/TOTAL(2)
      VL(5)=100.0*VL(4)/TOTAL(4)
      RA(3)=100.0*RA(2)/TOTAL(2)
      RA(5)=100.0*RA(4)/TOTAL(4)
      MA(3)=100.0*MA(2)/TOTAL(2)
      MA(5)=100.0*MA(4)/TOTAL(4)
      HA(3)=100.0*HA(2)/TOTAL(2)
      HA(5)=100.0*HA(4)/TOTAL(4)
      DA(3)=100.0*DA(2)/TOTAL(2)
      DA(5)=100.0*DA(4)/TOTAL(4)
      DU(3)=100.0*DU(2)/TOTAL(2)
      DU(5)=100.0*DU(4)/TOTAL(4)
      TOTAL(3)=100.0
      TOTAL(5)=100.0
      OPEN (23,FILE='CHLEBA.OUT')
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'LU',(LU(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'TU',(TU(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'SI',(SI(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'VL',(VL(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'RA',(RA(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'MA',(MA(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'HA',(HA(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'DA',(DA(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'DU',(DU(I),I=1,5)
      WRITE (23,'(1X,A5,'' = '',5F12.2)') 'TOTAL',(TOTAL(I),I=1,5)
      CLOSE(20)
      CLOSE(21)
      CLOSE(22)
      CLOSE(23)
      STOP
      END

