$INTERFACE UA0F02                                             97/12/01

      $ADD(REAL,'\$AF($NA)')
 $00  CALL UA0F02
      GOTO ($20,$10) ISB+1
 $10  CONTINUE
      $MTYPE=FMODA
      $SUBST('UZAMOD')
      $IF(KBA>0)
        CALL UXVDIF(NA,$AF,$AM,$AF)
      $ENDIF
      GOTO $00
 $20  CONTINUE
      $ADD(INIT)
        NAXX='UA0F02'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0F02             ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SIMULTANEOUS COMPUTATION OF THE APPROXIMATED FUNCTION VALUES.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LDA  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA0F02
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,2) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 3
      IF (LDA.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      LDA=0
    3 CALL UYEPI1(-1)
      RETURN
      END
