$INTERFACE UF1FM2                                             10/12/01

  $ADD(INTEGER,'\ISNS')
  ISNS=ISNA
  $LHLP=1
  $IF(NOS2=3)
    $DU=D
    $DV=D
    $KHLP=3
    $IF(MOS3=1) $LHLP=2
    $ADD(REAL,'\$D($NF)')
  $ELSEIF(NOS2=4)
    $DV=DU
    $KHLP=4
    $IF(MOS3=1) $LHLP=2
    $ADD(REAL,'\$D($NF)\$DU($NF)')
  $ELSEIF(NOS2=5)
    $KHLP=5
    $IF(MOS3=1) $LHLP=2
    $ADD(REAL,'\$D($NF)\$DU($NF)\$DV($NF)')
  $ENDIF
      $IF(LHLP=1)
 $00    CALL UF1FM1
        GO TO ($30,$10,$20) ISB+1
 $10    CONTINUE
        $W=GF
        $GF=G
        IF (TSS(NS).NE.'UFXX') CALL UYSET2
        $KD=0
        $SUBST('UZMODL')
        $KD=1
        LD=MIN(LD,0)
        FF=F
        IF (TSS(NS).EQ.'UFXX') GOTO $00
 $20    CONTINUE
        ISNA=0
        $IF(HESF<>'NO')
          $HELP
            METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
            NUMERICAL COMPUTATION OF GRADIENT:
              0 - CONSTANT DIFFERENCE
              1 - EASY COMPARATIVE METHOD
              2 - STEWART'S METHOD.
          $CHECK(MCG,2,'0\1\2',3)
        $ELSE
          $HELP
            METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
            NUMERICAL COMPUTATION OF GRADIENT:
              0 - CONSTANT DIFFERENCE
              1 - EASY COMPARATIVE METHOD
              2 - STEWART'S METHOD.
          $CHECK(MCG,0,'0\1\2',3)
        $ENDIF
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $ADD(SINID)
            CALL UXVSET(NF,ZERO,$GF)
            CALL UXVSET(NF,ONE,$HD)
          $ENDADD
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GOTO ($00,$10) ISB+1
 $30    CONTINUE
        ISNA=ISNS
        $GF=W
      $ELSE
 $00    CALL UF1FM2
        GO TO ($30,$10,$20) ISB+1
 $10    CONTINUE
        $V=HF
        $W=GF
        $HF=H
        $GF=G
        IF(TSS(NS).NE.'UFXX') LD=0
        $KD=1
        $SUBST('UZMODL')
        $KD=2
        LD=MIN(LD,1)
        FF=F
        IF(TSS(NS).EQ.'UFXX') GOTO $00
 $20    CONTINUE
        ISNA=0
        LDA=-1
        $SUBST('UF1H$(CON)$KHLP')
        GOTO ($00,$10) ISB+1
 $30    CONTINUE
        ISNA=ISNS
        $HF=V
        $GF=W
      $ENDIF
      $ADD(INIT)
        NFXX='UF1FM2'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UF1FM2                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UF1FM2
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UFXX') CALL UYPRO1('UFXX',-1)
      GO TO (1,2,4) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 5
      IF (LD.GE.1) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
    3 IF (KD.LT.2) GO TO 5
      IF (LD.GE.2) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      IDECF=0
    5 CALL UYEPI1(-1)
      LD=KD
      RETURN
      END
