$INTERFACE UF2FM1                                             97/12/01

$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     -------------------------
*     NUMERICAL DIFFERENTIATION
*     -------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INTEGER,'\ISNS')
      ISNS=ISNA
 $00  CALL UF2FM1
      GOTO ($30,$10,$20) ISB+1
 $10  CONTINUE
      $V=HF
      $W=GF
      $HF=H
      $GF=G
$REM      IF(TSS(NS).NE.'UFXX') CALL UYSET2
      IF(TSS(NS).NE.'UFXX') LD=0
      $KD=1
      $SUBST('UZMODL')
      $KD=2
      LD=MIN(LD,1)
      FF=F
      IF(TSS(NS).EQ.'UFXX') GOTO $00
 $20  CONTINUE
      ISNA=0
      LDA=-1
      $IF(HESF='S')
        $SUBST('UF1H$(CON)2')
      $ELSE
        $SUBST('UF1H$(CON)1')
      $ENDIF
      GOTO ($00,$10) ISB+1
 $30  CONTINUE
      ISNA=ISNS
      $HF=V
      $GF=W
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     --------------------------------
*     END OF NUMERICAL DIFFERENTIATION
*     --------------------------------
*
$OPTION(CHDIR=CHPOM)
      $ADD(INIT)
        NFXX='UF2FM1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UF2FM1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UF2FM1
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UFXX') CALL UYPRO1('UFXX',-1)
      GO TO (1,2,4) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 5
      IF (LD.GE.1) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
    3 IF (KD.LT.2) GO TO 5
      IF (LD.GE.2) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      IDECF=0
    5 CALL UYEPI1(-1)
      LD=KD
      RETURN
      END
