* SUBROUTINE UKSII3                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* INPUT OF NUMERICAL VALUE OF THE ELEMENT A(I,J) INTO THE MATRIX
* OF CONSTRAINTS - IN-PLACE REPLACING.
*
* PARAMETERS :
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  NZA  SIZE OF ARRAYS RNR/A.
*  II  I  INPUT ROW INDEX.
*  II  J  INPUT COLUMN INDEX.
*  RI  AIJ  NUMERICAL VALUE.
*  IO  RNR(NZA) ROW INDICES OF CONSTRAINT MATRIX.
*  IO  PRNR(MCOLS+1) POINTER VECTOR TO RNR.
*  RO  A(NZA) NUMERICAL VALUES OF THE CONSTRAINT MATRIX
*             CORRESPONDING TO RNR.
*
      SUBROUTINE UKSII3(MCOLS,NZA,I,J,AIJ,RNR,PRNR,A)
      INTEGER MCOLS,NZA,I,J,RNR(NZA),PRNR(MCOLS+1)
      $FLOAT AIJ,A(NZA)
      INTEGER JSTRT,JSTOP,K
C
C SET START AND END OF THE COLUMN J
C
      JSTRT=PRNR(J)
      JSTOP=PRNR(J+1)-1
      DO 100 K=JSTRT,JSTOP
        IF(RNR(K).EQ.I) THEN
          A(K)=AIJ
          GO TO 200
        END IF
100   CONTINUE
200   CONTINUE
      RETURN
      END
