* SUBROUTINE ULAMAX             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE MAXIMUM DEVIATION.
*
* PARAMETERS :
*  II  NA  NUMBER OF DECLARED LINEAR APPROXIMATED FUNCTIONS.
*  II  NAD  NUMBER OF CURRENT LINEAR APPROXIMATED FUNCTIONS.
*  RI  AF(2*NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RO  XNORM  MAXIMUM APPROXIMATED FUNCTION VALUE.
*  RI  ETA9  MAXIMUM VALUE NOT EQUAL TO INFINITY.
*
      SUBROUTINE ULAMAX(NA,NAD,AF,IA,XNORM,ETA9)
      INTEGER NA,NAD,IA(2*NA)
      $FLOAT AF(2*NA),XNORM,ETA9
      INTEGER KA
      XNORM=-ETA9
      DO 1 KA=1,NAD
      IF (IA(KA).GT.0) THEN
      IF (IA(KA).EQ.1.OR.IA(KA).EQ.3) THEN
      XNORM=MAX(XNORM,-AF(KA))
      ELSE
      XNORM=MAX(XNORM, AF(KA))
      ENDIF
      ENDIF
    1 CONTINUE
      RETURN
      END


