$INTERFACE UO3FU1                                             98/12/01

  CALL UO3FU1('$TEXT',NF,NA,NAL,MAL,NC,NCL,MCL,EPS0,EPS1,EPS2,EPS3&
,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7&
,ETA8,ETA9,ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3&
,RPF1,RPF2,RPF3,RPF4,RPF5,FMIN,FMAX,XDEL,XMAX,MET,MET1,MET2,MET3,MET4&
,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,MES,MES1,MES2,MES3,MES4,MES5,MOS&
,MOS1,MOS2,MOS3,MOS4,MOS5,MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2&
,MOP3,MOP4,MOP5,MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4&
,MEX5,MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,KTERS&
,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2,MF,MA,MB,KSF,KCF,KSA&
,KCA,KSC,KCC)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UO3FU1                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO GLOBAL MINIMIZATION.
*
* PARAMETERS :
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF LOCAL MINIMIZATION.
*
* COMMON DATA :
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMIZATION. IEXT=1-MAXIMIZATION.
*
* OUTPUT VARIABLES :
*  NEXT,NXFU,NDXX,NSXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NF,KDF,KSF,KCF,
*  NORMF,NA,KDA,KSA,KCA,NAL,NAP,NORMA,NC,KDC,KSC,KCC,NCL,NCP,NORMC,
*  MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,MES,MES1,
*  MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,MEP,MEP1,MEP2,MEP3,
*  MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,MED,MED1,MED2,MED3,MED4,MED5,
*  MEX,MEX1,MEX2,MEX3,MEX4,MEX5,MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,
*  MLP2,MQP,MQP1,MQP2,KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,
*  IRES2,TOLX,TOLF,TOLG,TOLB,TOLC,TOLA,TOLR,EPS0,EPS1,EPS2,EPS3,EPS4,
*  EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,
*  ETA8,ETA9,ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,
*  DEL3,XDEL,XMAX,XMIN,FMAX,FMIN,RPF1,RPF2,RPF3,RPF4,RPF5
*
      SUBROUTINE UO3FU1(NGLX,NF,NA,NAL,MAL,NC,NCL,MCL,EPS0,EPS1,EPS2,
     & EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,
     & ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,
     & DEL1,DEL2,DEL3,RPF1,RPF2,RPF3,RPF4,RPF5,FMIN,FMAX,XDEL,XMAX,MET,
     & MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,MES,MES1,
     & MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,MEP,MEP1,MEP2,
     & MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,MED,MED1,MED2,MED3,
     & MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,MFP,MFP1,MFP2,MLC,MLC1,
     & MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,KTERS,INITD,INITS,INITH,IREM,
     & IADD,MRED,IRES1,IRES2,MF,MA,MB,KSF,KCF,KSA,KCA,KSC,KCC)
      $INCLUDE ('UMCOMM')
      CHARACTER*6 NGLX
      INTEGER NF,NA,NAL,MAL,NC,NCL,MCL,MET,MET1,MET2,MET3,MET4,MET5,
     & MOT,MOT1,MOT2, MOT3,MOT4,MOT5,MES,MES1,MES2,MES3,MES4,MES5,
     & MOS,MOS1,MOS2,MOS3,MOS4,MOS5,MEP,MEP1,MEP2,MEP3,MEP4,MEP5,
     & MOP,MOP1,MOP2,MOP3,MOP4,MOP5,MED,MED1,MED2,MED3,MED4,MED5,
     & MEX,MEX1,MEX2,MEX3,MEX4,MEX5,MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,
     & MLP1,MLP2,MQP,MQP1,MQP2,KTERS,INITD,INITS,INITH,IREM,IADD,MRED,
     & IRES1,IRES2,MF,MA,MB,KSF,KCF,KSA,KCA,KSC,KCC
      $FLOAT EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
     & ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,
     & BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,RPF1,RPF2,RPF3,
     & RPF4,RPF5,FMIN,FMAX,XMAX,XDEL
      CHARACTER*12 TEXT
      CHARACTER*15 TEXF,TEXG,TEXH,TEXP
      IOUT=0
      IF (KOUT.EQ.0) RETURN
      IF ( IEXT .GT. 0)  THEN
      TEXT = 'MAXIMIZATION'
      ELSE
      TEXT = 'MINIMIZATION'
      ENDIF
      WRITE ( IWR, 1) TEXT
    1 FORMAT ( /' ', 'GLOBAL ', A12, ' USING UFO SYSTEM'
     &         /' ', 36('-'))
      IF (NEXT .GT. 0) WRITE ( IWR, 2) NEXT
    2 FORMAT ( ' ', 'PROBLEM NO', I5)
      TEXF='               '
      TEXG='               '
      TEXH='               '
      TEXP='               '
      IF (NPXX .NE. '      ') THEN
      TEXP(1:6)=NPXX
      TEXP(10:15)=NPFX
      ELSE
      TEXP(1:6)=NPFX
      ENDIF
      IF (NFXX .NE. '      ') THEN
      TEXF(1:6)=NFXX
      TEXF(10:15)=NAXX
      ELSE
      TEXF(1:6)=NAXX
      ENDIF
      IF (NFGX .NE. '      ') THEN
      TEXG(1:6)=NFGX
      TEXG(10:15)=NAGX
      ELSE
      TEXG(1:6)=NAGX
      ENDIF
      IF (NFHX .NE. '      ') THEN
      TEXH(1:6)=NFHX
      TEXH(10:15)=NAHX
      ELSE
      TEXH(1:6)=NAHX
      ENDIF
      WRITE ( IWR, 3) NGLX,NXFU,NDXX,NSXX,TEXF,TEXG,TEXH,NUXX
    3 FORMAT ( /' ', 'GLOBAL OPTIMIZATION SUBROUTINE : ', A6/
     &          ' ', 'LOCAL  OPTIMIZATIOM SUBROUTINE : ', A6/
     &          ' ', 'DIRECTION DETERMINATION : ',A6/
     &          ' ', 'STEP SIZE DETERMINATION : ',A6/
     &          ' ', 'OBJECTIVE FUNCTION USED : ',A15/
     &          ' ', 'GRADIENT  APPROXIMATION : ',A15/
     &          ' ', 'H MATRIX  APPROXIMATION : ',A15/
     &          ' ', 'VARIABLE  METRIC UPDATE : ',A6)
      IF (NPXX .NE. '      ' .OR. NPFX .NE. '      ') THEN
      WRITE ( IWR,13) TEXP
   13 FORMAT ( ' ', 'PENALTY   FUNCTION USED : ',A15)
      ENDIF
      IF (NBFX .NE. '      ') THEN
      WRITE ( IWR,23) NBFX
   23 FORMAT ( ' ', 'BARRIER   FUNCTION USED : ',A6)
      ENDIF
      WRITE ( IWR, 4)  NF,        KDF,KSF,KCF,KBF,ISNF,NORMF,
     &                 NA,NAL,MAL,KDA,KSA,KCA,KBA,ISNA,NORMA,
     &                 NC,NCL,MCL,KDC,KSC,KCC,KBC,ISNC,NORMC
    4 FORMAT ( /' ', 'PROBLEM' / ' ', 7('-') /
     &          ' ','NF=',I5,17X,
     &          'KDF=',I3,1X,'KSF=',I3,1X,'KCF=',I3,1X,
     &          'KBF=',I3,1X,'ISNF=',I3,1X,'NORMF=',I3/
     &          ' ','NA=',I5,1X,'NAL=',I3,1X,'MAL=',I3,1X,
     &          'KDA=',I3,1X,'KSA=',I3,1X,'KCA=',I3,1X,
     &          'KBA=',I3,1X,'ISNA=',I3,1X,'NORMA=',I3/
     &          ' ','NC=',I5,1X,'NCL=',I3,1X,'MCL=',I3,1X,
     &          'KDC=',I3,1X,'KSC=',I3,1X,'KCC=',I3,1X,
     &          'KBC=',I3,1X,'ISNC=',I3,1X,'NORMC=',I3)
      IF (KOUT.GT.0) WRITE ( IWR, 9)
      IF (KOUT.LT.0) WRITE ( IWR, 5)
     &  MET,  MET1, MET2, MET3, MET4, MET5,
     &  MOT,  MOT1, MOT2, MOT3, MOT4, MOT5,
     &  MES,  MES1, MES2, MES3, MES4, MES5,
     &  MOS,  MOS1, MOS2, MOS3, MOS4, MOS5,
     &  MEP,  MEP1, MEP2, MEP3, MEP4, MEP5,
     &  MOP,  MOP1, MOP2, MOP3, MOP4, MOP5,
     &  MED,  MED1, MED2, MED3, MED4, MED5,
     &  MEX,  MEX1, MEX2, MEX3, MEX4, MEX5
      IF (KOUT.LT.0) WRITE ( IWR, 6)
     &  MFP,  MFP1, MFP2, MLC , MLC1, MLC2,
     &  MLP,  MLP1, MLP2, MQP,  MQP1, MQP2,
     &  KTERS,INITD,INITS,INITH,IREM, IADD,
     &  MTESX,MTESF,IDECF,IDECA,IDECC,IEXT,
     &  MIT,  MIC,  MRED, MF,   MFV,  MCGR,
     &  IRES1,MA,   MFG , MSTP ,IRES2,MB
    5 FORMAT (/
     &  1X,'MET   =',I3,3X,'MET1  =',I3,2X,'MET2  =',I3,3X,'MET3  =',I3,
     &  2X,'MET4  =',I3,3X,'MET5  =',I3/
     &  1X,'MOT   =',I3,3X,'MOT1  =',I3,2X,'MOT2  =',I3,3X,'MOT3  =',I3,
     &  2X,'MOT4  =',I3,3X,'MOT5  =',I3/
     &  1X,'MES   =',I3,3X,'MES1  =',I3,2X,'MES2  =',I3,3X,'MES3  =',I3,
     &  2X,'MES4  =',I3,3X,'MES5  =',I3/
     &  1X,'MOS   =',I3,3X,'MOS1  =',I3,2X,'MOS2  =',I3,3X,'MOS3  =',I3,
     &  2X,'MOS4  =',I3,3X,'MOS5  =',I3/
     &  1X,'MEP   =',I3,3X,'MEP1  =',I3,2X,'MEP2  =',I3,3X,'MEP3  =',I3,
     &  2X,'MEP4  =',I3,3X,'MEP5  =',I3/
     &  1X,'MOP   =',I3,3X,'MOP1  =',I3,2X,'MOP2  =',I3,3X,'MOP3  =',I3,
     &  2X,'MOP4  =',I3,3X,'MOP5  =',I3/
     &  1X,'MED   =',I3,3X,'MED1  =',I3,2X,'MED2  =',I3,3X,'MED3  =',I3,
     &  2X,'MED4  =',I3,3X,'MED5  =',I3/
     &  1X,'MEX   =',I3,3X,'MEX1  =',I3,2X,'MEX2  =',I3,3X,'MEX3  =',I3,
     &  2X,'MEX4  =',I3,3X,'MEX5  =',I3)
    6 FORMAT (
     &  1X,'MFP   =',I3,3X,'MFP1  =',I3,2X,'MFP2  =',I3,3X,'MLC   =',I3,
     &  2X,'MLC1  =',I3,3X,'MLC2  =',I3/
     &  1X,'MLP   =',I3,3X,'MLP1  =',I3,2X,'MLP2  =',I3,3X,'MQP   =',I3,
     &  2X,'MQP1  =',I3,3X,'MQP2  =',I3/
     &  1X,'KTERS =',I3,3X,'INITD =',I3,2X,'INITS =',I3,3X,'INITH =',I3,
     &  2X,'IREM  =',I3,3X,'IADD  =',I3/
     &  1X,'MTESX =',I3,3X,'MTESF =',I3,2X,'IDECF =',I3,3X,'IDECA =',I3,
     &  2X,'IDECC =',I3,3X,'IEXT  =',I3//
     &  1X,'MIT   =',I8,5X,'MIC   =',I8,3X,'MRED  =',I8,5X,'MF    =',I8/
     &  1X,'MFV   =',I8,5X,'MCGR  =',I8,3X,'IRES1 =',I8,5X,'MA    =',I8/
     &  1X,'MFG   =',I8,5X,'MSTP  =',I8,3X,'IRES2 =',I8,5X,'MB    =',I8)
      IF (KOUT.LT.0) WRITE ( IWR, 7)
     &  TOLX, EPS0, ETA0, ALF1,
     &  TOLF, EPS1, ETA1, ALF2,
     &  TOLG, EPS2, ETA2, ALF3,
     &  TOLB, EPS3, ETA3, BET1,
     &  TOLC, EPS4, ETA4, BET2,
     &  TOLA, EPS5, ETA5, BET3
      IF (KOUT.LT.0) WRITE ( IWR, 8)
     &  TOLR, EPS6, ETA6, GAM1,
     &  RPF1, EPS7, ETA7, GAM2,
     &  RPF2, EPS8, ETA8, GAM3,
     &  RPF3, EPS9, ETA9, DEL1,
     &  RPF4, FMIN, FMAX, DEL2,
     &  RPF5, XDEL, XMAX, DEL3
    7 FORMAT ( /' ', 'PARAMETERS' / ' ', 10('-') /
     &' ','TOLX =',$P 10.3,4X,'EPS0 =',$P 10.3,3X,'ETA0 =',$P 10.3,4X,
     &'ALF1 =',$P 10.3/
     &' ','TOLF =',$P 10.3,4X,'EPS1 =',$P 10.3,3X,'ETA1 =',$P 10.3,4X,
     &'ALF2 =',$P 10.3/
     &' ','TOLG =',$P 10.3,4X,'EPS2 =',$P 10.3,3X,'ETA2 =',$P 10.3,4X,
     &'ALF3 =',$P 10.3/
     &' ','TOLB =',$P 10.3,4X,'EPS3 =',$P 10.3,3X,'ETA3 =',$P 10.3,4X,
     &'BET1 =',$P 10.3/
     &' ','TOLC =',$P 10.3,4X,'EPS4 =',$P 10.3,3X,'ETA4 =',$P 10.3,4X,
     &'BET2 =',$P 10.3/
     &' ','TOLA =',$P 10.3,4X,'EPS5 =',$P 10.3,3X,'ETA5 =',$P 10.3,4X,
     &'BET3 =',$P 10.3)
    8 FORMAT (
     &' ','TOLR =',$P 10.3,4X,'EPS6 =',$P 10.3,3X,'ETA6 =',$P 10.3,4X,
     &'GAM1 =',$P 10.3/
     &' ','RPF1 =',$P 10.3,4X,'EPS7 =',$P 10.3,3X,'ETA7 =',$P 10.3,4X,
     &'GAM2 =',$P 10.3/
     &' ','RPF2 =',$P 10.3,4X,'EPS8 =',$P 10.3,3X,'ETA8 =',$P 10.3,4X,
     &'GAM3 =',$P 10.3/
     &' ','RPF3 =',$P 10.3,4X,'EPS9 =',$P 10.3,3X,'ETA9 =',$P 10.3,4X,
     &'DEL1 =',$P 10.3/
     &' ','RPF4 =',$P 10.3,4X,'FMIN =',$P 10.3,3X,'FMAX =',$P 10.3,4X,
     &'DEL2 =',$P 10.3/
     &' ','RPF5 =',$P 10.3,4X,'XDEL =',$P 10.3,3X,'XMAX =',$P 10.3,4X,
     &'DEL3 =',$P 10.3/)
    9 FORMAT (' ')
      RETURN
      END

