* SUBROUTINE UO3FU5                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF OUTPUT FROM GLOBAL MINIMIZATION
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NLMIN  NUMBER OF MINIMA.
*  II  MNLMIN  MAX. NUMBER OF MINIMA.
*  RI  FSET(MNLMIN)  FUNCTION VALUES IN MINIMA.
*  RI  XSET(NF*MNLMIN)  POINTS OF MINIMA.
*  II  INDX(NLMIN)  INDEX TABLE.
*
      SUBROUTINE UO3FU5(NF,NLMIN,MNLMIN,FSET,XSET,INDX)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NLMIN,MNLMIN,INDX(NLMIN)
      $FLOAT FSET(MNLMIN),XSET(NF*MNLMIN)
      INTEGER I,J
      $FLOAT TEMP
      LOGICAL LL
      LL=KOUT.EQ.0.AND.LOUT.GT.0
      IF (ABS(MOUT).GT.0) THEN
        TEMP=FSET(INDX(1))
        DO 10 J=1,NLMIN
        IF (FSET(INDX(J)).LT.TEMP) THEN
        TEMP=FSET(INDX(J))
        ENDIF
   10   CONTINUE
        IF(KD.LE.0) THEN
          IF(MOUT.GT.0) THEN
            WRITE(ITR,16) NEXT,NIT,NFV,NLMIN,TEMP
            IF(LL) WRITE(IWR,16) NEXT,NIT,NFV,NLMIN,TEMP
          ELSE
            WRITE(ITR,26) NEXT,NIT,NFV,NLMIN,TXFU,TEMP
            IF(LL) WRITE(IWR,26) NEXT,NIT,NFV,NLMIN,TXFU,TEMP
          ENDIF
        ELSE
          IF(MOUT.GT.0) THEN
            WRITE(ITR,17) NEXT,NIT,NFV,NFG,NLMIN,TEMP
            IF(LL) WRITE(IWR,17) NEXT,NIT,NFV,NFG,NLMIN,TEMP
          ELSE
            WRITE(ITR,27) NEXT,NIT,NFV,NFG,NLMIN,TXFU,TEMP
            IF(LL) WRITE(IWR,27) NEXT,NIT,NFV,NFG,NLMIN,TXFU,TEMP
          ENDIF
        ENDIF
        DO 11 J=1,MIN(NLMIN,50)
        IF (NOUT.GT.0) THEN
          WRITE(ITR,60) J,FSET(INDX(J)),(XSET((INDX(J)-1)*NF+I),I=1,
     &                  MIN(NF,100))
          IF(LL) WRITE(IWR,60) J,FSET(INDX(J)),(XSET((INDX(J)-1)*NF+I),
     &                         I=1,MIN(NF,100))
        ENDIF
   11   CONTINUE
      ENDIF
      IF (KOUT.NE.0) THEN
        WRITE (IWR,50)
        DO 12 J=1,MIN(NLMIN,50)
          WRITE(IWR,60) J,FSET(INDX(J)),(XSET((INDX(J)-1)*NF+I),I=1,
     &                  MIN(NF,100))
   12   CONTINUE
        WRITE(IWR,70) NLMIN,NFV,NFG,NFH
      ENDIF
   16 FORMAT(' ',I3,2X,'NIT=',I6,2X,'NFV=',I6,2X,'NEX=',I4,2X,
     *           'F=',D10.3)
   26 FORMAT(' ',I3,2X,'NIT=',I6,2X,'NFV=',I6,2X,'NEX=',I4,2X,
     *           A8,2X,'F=',G17.10)
   17 FORMAT(' ',I3,2X,'NIT=',I4,2X,'NFV=',I4,2X,'NFG=',I4,2X,
     *           'NEX=',I4,2X,'F=',D10.3,2X)
   27 FORMAT(' ',I3,2X,'NIT=',I4,2X,'NFV=',I4,2X,'NFG=',I4,2X,
     *           'NEX=',I4,2X,A8,2X,'F=',G17.10,2X)
   50 FORMAT (/1X, 'FINAL RESULTS' / ' ', 13('-'))
   60 FORMAT (/1X,'EXTREM ',I3,' :' / ' ','F =', $P 18.10 /
     &  ' ','X =', 4$P 18.10:/(4X,4$P 18.10))
   70 FORMAT (/1X, 'STATISTICS' / ' ', 10('-') //
     &  ' NEXTREM =',I5,3X,'NFV =',I5,3X,'NFG =',I5,3X,'NFH =',I5)
      END

