* SUBROUTINE UOSCON                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF CONSTRAINTS.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  KBC  SPECIFICATION OF GENERAL CONSTRAINTS.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  CISLO  SERIAL NUMBER OF THE SCILAB SOURCE CODE.
*  II  STA  START INDEX OF THE CONSTRAINTS IN THE GRAPH.
*  II  STO  STOP INDEX OF THE CONSTRAINTS IN THE GRAPH.
*  II  GFMT  GRAPHIC FORMAT.
*
      SUBROUTINE UOSCON(NC,KBC,CF,CL,CU,IC,CISLO,STA,STO,GFMT)
      INTEGER NC,KBC,CISLO,IC(NC),STA,STO,GFMT
      $FLOAT CF(NC),CL(NC),CU(NC),MINIM,MAXIM
      LOGICAL LBOUND,UBOUND
C
      CALL UOSOPN(11,GFMT)
      CALL UOMVC1
     & (NC,KBC,CF,CL,CU,IC,STA,STO,'C',MINIM,MAXIM,LBOUND,UBOUND)
      CALL UOSVC2(MINIM,MAXIM,LBOUND,UBOUND,STA,STO,'C',CISLO)
      CALL UOSGRX(11,'PSCON',CISLO,GFMT)
      RETURN
      END
