* SUBROUTINE UOSVAR                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF VARIABLES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  CISLO  SERIAL NUMBER OF THE SCILAB SOURCE CODE.
*  II  STA  START INDEX OF THE VARIABLES IN THE GRAPH.
*  II  STO  STOP INDEX OF THE VARIABLES IN THE GRAPH.
*  II  GFMT  GRAPHIC FORMAT.
*
      SUBROUTINE UOSVAR(NF,KBF,X,XL,XU,IX,CISLO,STA,STO,GFMT)
      INTEGER NF,KBF,CISLO,IX(NF),STA,STO,GFMT
      $FLOAT X(NF),XL(NF),XU(NF),MINIM,MAXIM
      LOGICAL LBOUND,UBOUND
C
      CALL UOSOPN(11,GFMT)
      CALL UOMVC1
     & (NF,KBF,X,XL,XU,IX,STA,STO,'V',MINIM,MAXIM,LBOUND,UBOUND)
      CALL UOSVC2(MINIM,MAXIM,LBOUND,UBOUND,STA,STO,'V',CISLO)
      CALL UOSGRX(11,'PSVAR',CISLO,GFMT)
      RETURN
      END
