$INTERFACE UOT1C1                                             98/12/01

  CALL UOT1C1(NF,$GC,FC)
  $ADD(REAL,'\$GC($NF)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT1C1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  GC(NF)  GRADIENT OF THE CONSTRAINT FUNCTION.
*  RI  FC  VALUE OF THE CONSTRAINT FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES:
* FC,GC(NF)
*
      SUBROUTINE UOT1C1(NF,GC,FC)
      $INCLUDE('UMCOMM')
      INTEGER NF
      $FLOAT GC(NF),FC
      INTEGER I
      GOTO(1,4) KD+1
    1 WRITE(IWR,2) 'FC A =',FC
    2 FORMAT(/1X,A6,$P 18.10)
      WRITE(IWR,3) 'GC N =',(GC(I),I=1,NF)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GC A =', (GC(I),I=1,NF)
      RETURN
      END
