* SUBROUTINE UOTES1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION FOR SIMULTANEOUS TESTS.
*
* PARAMETERS:
*  CI  CLASS  CLASS OF OPTIMIZATION METHODS.
*  CI  TYPE  TYPE OF METHOD.
*  CI  DECOMP  TYPE OF DECOMPOSITION.
*  CI  NUMBER  TYPE OF DIRECTION DETERMINATION.
*  CI  UPDATE  TYPE OF UPDATE.
*
* COMMON DATA :
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  PRINT OF ITERATIONS. LOUT=0-STANDARD PAPER SAVING PRINT.
*         LOUT=1-ADDITIONAL PRINT OF VARIABLES. LOUT=2-ADDITIONAL
*         PRINT OF THE GRADIENT. LOUT=3-ADDITIONAL PRINT OF THE HESSIAN
*         MATRIX.
*
      SUBROUTINE UOTES1(CLASS,TYPE,DECOMP,NUMBER,UPDATE,MODEL,HESF,NF)
      $INCLUDE('UMCOMM')
      CHARACTER*1 TYPE,DECOMP,NUMBER,UPDATE,HESF
      CHARACTER*2 CLASS,MODEL
      INTEGER NF
      IF (KOUT.EQ.0.AND.LOUT.GT.0) THEN
      WRITE(IWR,55) CLASS,TYPE,DECOMP,NUMBER,UPDATE,MODEL,HESF,NF
      ENDIF
   55 FORMAT(' CLASS = ',A2,' - ',3A1,3X,'UPDATE = ',A1,3X,'MODEL = ',
     & A2,3X,'HESF = ',A1,5X,'NF =',I7)
      RETURN
      END
