$INTERFACE UP2MX3                                             05/12/01

  $LHELP=.FALSE.
  $IF(KDA=2) $LHELP=.TRUE.
  $IF(NUMDER=1) $LHELP=.TRUE.
  $IF(LHELP)
  $SUBST('UZASET')
  $HELP
    TYPE OF EXTREMUM:
       0 - CHEBYSHEV APPROXIMATION
      -1 - MINIMAX
       1 - MAXIMIN
  $CHECK(IEXT,0,'-1\0\1',1)
  $DEFAULT='0.0$P 0'
  $IF(IEXT<>0) $DEFAULT='-$ETA9'
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,DEFAULT,REAL,2)
  $HELP
    MAXIMUM NUMBER OF NONZERO ELEMENTS IN THE
    APPROXIMATED FUNCTION HESSIAN MATRIX
  $CHECK(MHA,100,INT,1)
  $ADD(SINID)
    $SUBST('UFSET8')
  $ENDADD
  $ADD(REAL,'\$GA($NF)\$HA($MHA)\$G($NF)\$H($M)\$AZL($NA)\$AZU($NA)')
$REM  $ADD(REAL,'\FF\FA\F')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IH($NF+1)\$JH($M)')
$REM  $ADD(INTEGER,'\NF\NA\NAL\MA\MHA\KA\M')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP2MX3(NF,NA,NAL,MA,MHA,KA,M,$GA,$HA,$IAG,$JAG,$G,$H&
,$IH,$JH,$AZL,$AZU,FF,FA)
      GO TO ($90,$10,$20,$50) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL<>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF3')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<>NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          $IF(FMODA<>'F')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
          $ENDIF
          $IF(FMODA='FGH')
            $IF(NORMA>0) $SUBST('UANRH3')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $IF(SAVA>0)
        IF(LDA.GE.1) THEN
        $SUBST('UALNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL<>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<1)
        $IF(NAL<>NA)
          $IF(GMODA='G')
            $MTYPE='G'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODA='F')
            $IF(ISNA>0)
              IF (LD.GE.0) FA=$AF(KA)
            $ENDIF
 $25  CONTINUE
            $SUBST('UA0G$(CON)3')
            GO TO ($40,$30) ISB+1
 $30  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $25
 $40  CONTINUE
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(.FALSE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(NAL<>0)
        IF(KA.LE.NAL) THEN
$REM        $SUBST('UALNH3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<2)
        $IF(NAL<>NA)
          $IF(HMODA='H')
            $MTYPE='H'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRH3')
            GO TO $00
          $ELSEIF(GMODA='G')
            $SUBST('UA1H$(CON)3')
            GO TO ($00,$60) ISB+1
 $60  CONTINUE
            $MTYPE=GMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $50
          $ELSEIF(FMODA='F')
            $IF(ISNA>0)
              IF (LD.GE.0) FA=$AF(KA)
            $ENDIF
 $65  CONTINUE
            $SUBST('UA0H$(CON)3')
            GO TO ($00,$70) ISB+1
 $70  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $65
          $ELSEIF(FMODA='FG')
            $SUBST('UA1H$(CON)3')
            GO TO ($00,$80) ISB+1
 $80  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $50
          $ELSEIF(.FALSE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(NORMA>0) $SUBST('UANRH3')
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $90  CONTINUE
      LD=KD
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INIT)
  NPXX='UP2MX3'
$ENDADD
$ELSE
  $HELP
    TYPE OF EXTREMUM:
       0 - CHEBYSHEV APPROXIMATION
      -1 - MINIMAX
       1 - MAXIMIN
  $CHECK(IEXT,0,'-1\0\1',1)
  $DEFAULT='0.0$P 0'
  $IF(IEXT<>0) $DEFAULT='-$ETA9'
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,DEFAULT,REAL,2)
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     -------------------------
*     NUMERICAL DIFFERENTIATION
*     -------------------------
*
$OPTION(CHDIR=CHPOM)
      ISNAS=ISNA
 $00  CALL UP2PF3
      GO TO ($30,$10,$20) ISB+1
 $10  CONTINUE
      IF (TSS(NS).NE.'UPXX') THEN
      LD=MIN(LD,0)
      LDA=MIN(LDA,0)
      $IF(NAL<>NA)
        $IF(GMODA<>'G')
          $IF(FMODA='F')
            LD=-1
            LDA=-1
          $ENDIF
        $ENDIF
      $ENDIF
      ENDIF
      $SUBST('UP1MX3')
      IF (TSS(NS).EQ.'UPXX') GO TO $00
 $20  CONTINUE
      $GFS=GF
      $XSS=XS
      $XS=GS
      $GF=G
      $KHLP=1
$REM      $IF(KDA<1)
$REM        $IF(KDC<1) $KHLP=0
$REM      $ENDIF
      ISNA=0
      $SUBST('UF$(KHLP)H$(CON)2')
      GO TO ($00,$10) ISB+1
 $30  CONTINUE
      ISNA=ISNAS
      $GF=GFS
      $XS=XSS
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     --------------------------------
*     END OF NUMERICAL DIFFERENTIATION
*     --------------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INIT)
  NPXX='UP1MX3'
  NFHX='UF$(KHLP)H$(CON)2'
$ENDADD
$ENDIF
$EXIT

* IMPLEMENTATION

* SUBROUTINE UP2MX3             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  IO  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IU  NAV  NUMBER OF APPROXIMATED FUNCTION VALUES COMPUTED.
*  IU  NAG  NUMBER OF APPROXIMATED FUNCTION GRADIENTS COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*  IU  NFG  NUMBER OF OBJECTIVE FUNCTION GRADIENTS COMPUTED.
*  II  IEXT  TYPE OF EXTREMUM. IEXT<0-MINIMAX. IEXT=0-CHEBYSHEV
*         APPROXIMATION, IEXT>0-MAXIMIN.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVCOP  COPYING OF A VECTOR.
*  S  UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*
      SUBROUTINE UP2MX3(NF,NA,NAL,MA,MHA,KA,M,GA,HA,IAG,JAG,G,H,
     & IH,JH,AZL,AZU,FF,FA)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NAL,MA,MHA,KA,M,IAG(NA+1),JAG(MA),IH(NF+1),JH(M)
      $FLOAT GA(NF),HA(MHA),G(NF),H(M),AZL(MA),AZU(MA),FF,FA
      INTEGER J,JP,K,L
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,4,6,8) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 20
      IF (KD.GE.1.AND.LD.LT.1) CALL UXVSET(NF,ZERO,G)
      IF (KD.GE.2.AND.LD.LT.2) CALL UXVSET(M,ZERO,H)
      KA=1
    2 IF (KA.GT.NA) GO TO 11
      IF (LD.GE.0) GO TO 5
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (IEXT.EQ.0) THEN
      IF (KA.EQ.1) FF=ABS(FA)
      FF=MAX(FF,ABS(FA))
      ELSE IF (IEXT.LT.0) THEN
      IF (KA.EQ.1) FF= FA
      FF=MAX(FF, FA)
      ELSE IF (IEXT.GT.0) THEN
      IF (KA.EQ.1) FF=-FA
      FF=MAX(FF,-FA)
      ENDIF
    5 IF (KD.LT.1) GO TO 9
      IF (LD.GE.1) GO TO 7
      CALL UYSET0(2,3)
      RETURN
    6 CONTINUE
      K=IAG(KA)
      L=IAG(KA+1)-K
      DO 3 J=1,L
      JP=ABS(JAG(K))
      IF (IEXT.EQ.0) THEN
      G(JP)=G(JP)+(AZU(KA)-AZL(KA))*GA(JP)
      ELSE IF (IEXT.LT.0) THEN
      G(JP)=G(JP)+AZU(KA)*GA(JP)
      ELSE IF (IEXT.GT.0) THEN
      G(JP)=G(JP)-AZL(KA)*GA(JP)
      ENDIF
      K=K+1
    3 CONTINUE
    7 IF (KD.LT.2) GO TO 9
      CALL UYSET0(3,4)
      RETURN
    8 CONTINUE
      IDECF=0
      IF (IEXT.EQ.0) THEN
      CALL UASSH2(NF,NA,MA,MHA,M,H,IH,JH,HA,IAG,JAG,KA,AZU(KA)-AZL(KA))
      ELSE IF (IEXT.LT.0) THEN
      CALL UASSH2(NF,NA,MA,MHA,M,H,IH,JH,HA,IAG,JAG,KA, AZU(KA))
      ELSE IF (IEXT.GT.0) THEN
      CALL UASSH2(NF,NA,MA,MHA,M,H,IH,JH,HA,IAG,JAG,KA,-AZL(KA))
      ENDIF
    9 KA=KA+1
      GO TO 2
   11 IF (NA.GT.NAL) THEN
      NFV=NAV/(NA-NAL)
      NFG=NAG/(NA-NAL)
      NFH=NAH/(NA-NAL)
      ELSE
      NFV=NFV+1
      NFG=NFG+1
      NFH=NFH+1
      ENDIF
   20 CALL UYEPI1(-1)
      RETURN
      END
