* SUBROUTINE UP2PF3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IO  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UP2PF3
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UPXX') CALL UYPRO1('UPXX',-1)
      GO TO (1,2,4) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 6
      IF (LD.GE.1) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
    3 IF (KD.LT.2) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      IDECF=0
    5 LD=KD
    6 CALL UYEPI1(-1)
      RETURN
      END
