$INTERFACE UPSET1                                             97/12/01

  CALL UPSET1(NF,NC,$S,$CZ,$CP)
  $ADD(REAL,'\$S($NF+$NC)\$CZ($NC)\$CP($NC)')
$REM  $ADD(INTEGER,'\NF\NC')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPSET1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NEW PENALTY PARAMETERS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  S(NF+NC)  DIRECTION VECTOR.
*  RI  CZ(NC)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RU  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*
      SUBROUTINE UPSET1(NF,NC,S,CZ,CP)
      INTEGER NF,NC
      $FLOAT S(NF+NC),CZ(NC),CP(NC)
      $FLOAT TEMP
      INTEGER KC
      DO 1 KC=1,NC
      TEMP=ABS(CZ(KC)+S(NF+KC))
      CP(KC)=MAX(TEMP,0.5$P 0*(CP(KC)+TEMP))
    1 CONTINUE
      RETURN
      END
