$INTERFACE UPSET2                                             97/12/01

  CALL UPSET2(NF,N,NC,$ICA,$CZ,$CP)
  $ADD(REAL,'\$CZ($NF)\$CP($NC)')
  $ADD(INTEGER,'\$ICA($NF)')
$REM  $ADD(INTEGER,'\NF\N\NC')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPSET2             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NEW PENALTY PARAMETERS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  ICA(NF)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  CZ(NF)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RI  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*
      SUBROUTINE UPSET2(NF,N,NC,ICA,CZ,CP)
      INTEGER NF,N,NC,ICA(NF)
      $FLOAT CZ(NF),CP(NC)
      $FLOAT TEMP
      INTEGER J,L,KC
      DO 1 KC=1,NC
      CP(KC)=0.5$P 0*CP(KC)
    1 CONTINUE
      DO 2 J=1,NF-N
      L=ICA(J)
      IF (L.GT.0) THEN
      TEMP=ABS(CZ(J))
      CP(L)=MAX(TEMP,CP(L)+0.5$P 0*TEMP)
      ENDIF
    2 CONTINUE
      RETURN
      END
