* SUBROUTINE UQADIF                ALL SYSTEMS                04/12/01
* PORTABILITY : ALL SYSTEMS
* 04/12/01 HA : ORIGINAL VERSION
*
* PURPOSE :
*  AUTOMATICAL DIFFERENTIATION OF FMODELX
*  FIRST DERIVATIVE -- REVERSE MODE
*
* PARAMETERS :
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*               IN THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  CI  CHX - TYPE OF A MODEL FUNCTION ('A'-APPROXIMATING,
*            'C'-CONSTRAINT, 'F'-OBJECTIVE).
*  IO  IER - ERROR INDICATOR
*
      SUBROUTINE UQADIF(FORMF,ADFORMF,LADFORMF,ADVARIA,LADVARIA,
     & PADVARIA,I)
      CHARACTER*5000 FORMF
      CHARACTER*10000 ADFORMF
      INTEGER LADFORMF
      CHARACTER*1001 ADVARIA
      INTEGER LADVARIA
      INTEGER PADVARIA(101)
      INTEGER I,J,K,L
      IF((FORMF(I:I).EQ.'0').OR.
     *   (FORMF(I:I).EQ.'1').OR.
     *   (FORMF(I:I).EQ.'2').OR.
     *   (FORMF(I:I).EQ.'3').OR.
     *   (FORMF(I:I).EQ.'4').OR.
     *   (FORMF(I:I).EQ.'5').OR.
     *   (FORMF(I:I).EQ.'6').OR.
     *   (FORMF(I:I).EQ.'7').OR.
     *   (FORMF(I:I).EQ.'8').OR.
     *   (FORMF(I:I).EQ.'9').OR.
     *   (FORMF(I:I).EQ.'-')) THEN
C     VYRAZ VLEVO JE CISLO
         J=I
   65    IF((FORMF(J:J+1).NE.'.E').AND.
     *      (FORMF(J:J+1).NE.'.N').AND.
     *      (FORMF(J:J+1).NE.'.G').AND.
     *      (FORMF(J:J+1).NE.'.L')) THEN
            J=J+1
            GOTO 65
         ENDIF
         ADFORMF(LADFORMF+1:LADFORMF+J-I)=FORMF(I:J-1)
         LADFORMF=LADFORMF+J-I
         I=J
      ELSE
C     VYRAZ VLEVO JE PROMENNA
         J=I
   66    IF((FORMF(J:J+1).NE.'.E').AND.
     *      (FORMF(J:J+1).NE.'.N').AND.
     *      (FORMF(J:J+1).NE.'.G').AND.
     *      (FORMF(J:J+1).NE.'.L').AND.
     *      (FORMF(J:J)  .NE.'(')) THEN
            J=J+1
            GOTO 66
         ENDIF
C     HLEDAME V SEZNAMU PROMENNYCH,KTERE POZMENENY
         K=1
         PADVARIA(101)=LADVARIA+1
   67    IF((PADVARIA(K).NE.-1).AND.(K.LE.100)) THEN
            IF(J-I.EQ.PADVARIA(K+1)-PADVARIA(K)) THEN
               L=0
   68          IF(L.LE.J-I-1) THEN
                  IF(ADVARIA(PADVARIA(K)+L:PADVARIA(K)+L).NE.
     *            FORMF(I+L:I+L)) GOTO 69
                  L=L+1
                  GOTO 68
               ENDIF
C     NASLI JSME PROMENNOU SE ZMENENYM JMENEM
               ADFORMF(LADFORMF+1:LADFORMF+6)='V(IAD_'
               LADFORMF=LADFORMF+6
               ADFORMF(LADFORMF+1:LADFORMF+J-I)=FORMF(I:J-1)
               LADFORMF=LADFORMF+J-I
               I=J
C     POLE??
               IF(FORMF(I:I).EQ.'(') THEN
                  ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                  LADFORMF=LADFORMF+1
                  I=I+1
                  L=1         !POCET OTEVRENYCH ZAVOREK
   72             IF(L.GT.0) THEN
                     IF(FORMF(I:I).EQ.')') L=L-1
                     IF(FORMF(I:I).EQ.'(') L=L+1
                     ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                     LADFORMF=LADFORMF+1
                     I=I+1
                     GOTO 72
                  ENDIF
               ENDIF
               ADFORMF(LADFORMF+1:LADFORMF+1)=')'
               LADFORMF=LADFORMF+1
               GO TO 70
            ENDIF
   69       K=K+1
            GOTO 67
         ENDIF
C     PROMENNA NEBYLA ZMENENA, JEN KOPIE STARE
         ADFORMF(LADFORMF+1:LADFORMF+J-I)=FORMF(I:J-1)
         LADFORMF=LADFORMF+J-I
         I=J
C     POLE
         IF(FORMF(I:I).EQ.'(') THEN
            ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
            LADFORMF=LADFORMF+1
            I=I+1
            K=1
   73       IF(K.GT.0) THEN
               IF(FORMF(I:I).EQ.')') K=K-1
               IF(FORMF(I:I).EQ.'(') K=K+1
               ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
               LADFORMF=LADFORMF+1
               I=I+1
               GOTO 73
            ENDIF
         ENDIF
      ENDIF
   70 CONTINUE
C     POROVNANI -- JEN KOPIE 4 ZNAKU (.GT., .GE, .LT., .LE., .EQ., .NE.)
      ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
      LADFORMF=LADFORMF+4
      I=I+4
C     ANALYZA VYRAZU VPRAVO:
      IF((FORMF(I:I).EQ.'0').OR.
     *   (FORMF(I:I).EQ.'1').OR.
     *   (FORMF(I:I).EQ.'2').OR.
     *   (FORMF(I:I).EQ.'3').OR.
     *   (FORMF(I:I).EQ.'4').OR.
     *   (FORMF(I:I).EQ.'5').OR.
     *   (FORMF(I:I).EQ.'6').OR.
     *   (FORMF(I:I).EQ.'7').OR.
     *   (FORMF(I:I).EQ.'8').OR.
     *   (FORMF(I:I).EQ.'9').OR.
     *   (FORMF(I:I).EQ.'-')) THEN
C     VYRAZ VPRAVO JE CISLO
         J=I
         K=1          !POCET OTEVRENYCH ZAVOREK
   75    IF(K.GT.0) THEN
            IF(FORMF(J+1:J+1).EQ.'(') K=K+1
            IF(FORMF(J+1:J+1).EQ.')') K=K-1
            J=J+1
            GOTO 75
         ENDIF
         ADFORMF(LADFORMF+1:LADFORMF+J-I)=FORMF(I:J-1)
         LADFORMF=LADFORMF+J-I
         I=J
         ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)  !PRAVA ZAVORKA
         LADFORMF=LADFORMF+1
         I=I+1
      ELSE
C     VYRAZ VPRAVO JE PROMENNA
         J=I
   76    IF((FORMF(J:J).NE.'(').AND.(FORMF(J:J).NE.')')) THEN
            J=J+1
            GOTO 76
         ENDIF
C        K=1          !POCET OTEVRENYCH ZAVOREK
C   76   IF(K.GT.0) THEN
C           IF(FORMF(J+1:J+1).EQ.'(') K=K+1
C           IF(FORMF(J+1:J+1).EQ.')') K=K-1
C           J=J+1
C           GOTO 76
C        ENDIF
C     HLEDAME V SEZNAMU PROMENNYCH,KTERE POZMENENY
         K=1
         PADVARIA(101)=LADVARIA+1
   77    IF((PADVARIA(K).NE.-1).AND.(K.LE.100)) THEN
            IF(J-I.EQ.PADVARIA(K+1)-PADVARIA(K)) THEN
               L=0
   78          IF(L.LE.J-I-1) THEN
                  IF(ADVARIA(PADVARIA(K)+L:PADVARIA(K)+L).NE.
     *            FORMF(I+L:I+L)) GOTO 79
                  L=L+1
                  GOTO 78
               ENDIF
C     NASLI JSME PROMENNOU SE ZMENENYM JMENEM
               ADFORMF(LADFORMF+1:LADFORMF+6)='V(IAD_'
               LADFORMF=LADFORMF+6
               ADFORMF(LADFORMF+1:LADFORMF+J-I)=FORMF(I:J-1)
               LADFORMF=LADFORMF+J-I
               I=J
C     POLE??
               IF(FORMF(I:I).EQ.'(') THEN
                  ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                  LADFORMF=LADFORMF+1
                  I=I+1
                  L=1         !POCET OTEVRENYCH ZAVOREK
   81             IF(L.GT.0) THEN
                     IF(FORMF(I:I).EQ.')') L=L-1
                     IF(FORMF(I:I).EQ.'(') L=L+1
                     ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                     LADFORMF=LADFORMF+1
                     I=I+1
                     GOTO 81
                  ENDIF
               ENDIF
               ADFORMF(LADFORMF+1:LADFORMF+1)=')'
               LADFORMF=LADFORMF+1
               GOTO 80
            ENDIF
   79       K=K+1
            GOTO 77
         ENDIF
C     PROMENNA NEBYLA ZMENENA, JEN KOPIE STARE
         ADFORMF(LADFORMF+1:LADFORMF+J-I)=FORMF(I:J-1)
         LADFORMF=LADFORMF+J-I
         I=J
C     POLE
         IF(FORMF(I:I).EQ.'(') THEN
            ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
            LADFORMF=LADFORMF+1
            I=I+1
            K=1
   74       IF(K.GT.0) THEN
               IF(FORMF(I:I).EQ.')') K=K-1
               IF(FORMF(I:I).EQ.'(') K=K+1
               ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
               LADFORMF=LADFORMF+1
               I=I+1
               GOTO 74
            ENDIF
         ENDIF
C     PRAVA ZAVORKA UZAVIRAJICI PODMINKU
   80    ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
         LADFORMF=LADFORMF+1
         I=I+1
      ENDIF
      END
