* SUBROUTINE UXSSMI                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE SYMMETRIC MATRIX A IS SET TO THE UNIT MATRIX WITH THE SAME
* ORDER.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  IU  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RU  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*
      SUBROUTINE UXSSMI(N,M,A,IA)
      INTEGER N,M,IA(N+1)
      $FLOAT  A(M)
      INTEGER I,K
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      DO 100 I=1,IA(N+1)-1
      A(I)=ZERO
100   CONTINUE
      DO 200 I=1,N
      K=ABS(IA(I))
      A(K)=ONE
200   CONTINUE
      RETURN
      END
