* FUNCTION UXUNOB                  ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF VECTORS IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LT.0.
*  RR  UXUNOB  VALUE OF DOT PRODUCT UXUNOB=TRANS(X)*Y.
*
      FUNCTION UXUNOB(N,X,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT X(N),UXUNOB
      DOUBLE PRECISION TEMP
      INTEGER I
      $FLOAT RLAM
      $FLOAT ZERO
      PARAMETER (ZERO = 0.0$P 0)
      TEMP = ZERO
      IF (JOB.LE.0) THEN
      DO 1 I=1,N
      TEMP=TEMP+X(I)**2
    1 CONTINUE
      ELSE
      DO 2 I=1,N
      RLAM=X(I)
      IF (IX(I).GE.0) THEN
      TEMP=TEMP+RLAM**2
      ELSE IF ((IX(I).EQ.-1.OR.IX(I).EQ.-3).AND.RLAM.GT.ZERO) THEN
      TEMP=TEMP+RLAM**2
      ELSE IF ((IX(I).EQ.-2.OR.IX(I).EQ.-4).AND.RLAM.LT.ZERO) THEN
      TEMP=TEMP+RLAM**2
      ENDIF
    2 CONTINUE
      ENDIF
      UXUNOB=SQRT(TEMP)
      RETURN
      END
