* SUBROUTINE UXVDDR                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR AUGMENTED BY THE SCALED DIFFERENCE OF TWO VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  FIRST VECTOR  IN THE DIFFERENCE OF TWO VECTORS.
*  RI  Z(N)  SECOND VECTOR IN THE DIFFERENCE OF TWO VECTORS.
*  RO  V(N)  OUTPUT VECTOR WHERE V:= X + A*(Y-Z).
*
      SUBROUTINE UXVDDR(N,X,A,Y,Z,V)
      INTEGER N
      $FLOAT  X(N), A, Y(N), Z(N), V(N)
      INTEGER I
      DO 1 I=1,N
      V(I) = X(I) + A*(Y(I) - Z(I))
    1 CONTINUE
      RETURN
      END
