* SUBROUTINE UXVINE             ALL SYSTEMS                   94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ELEMENTS OF THE INTEGER VECTOR ARE REPLACED BY THEIR ABSOLUTE VALUES.
*
* PARAMETERS :
*  II  N DIMENSION OF THE INTEGER VECTOR.
*  IU  IX(N)  INTEGER VECTOR WHICH IS UPDATED SO THAT IX(I):=ABS(IX(I))
*         FOR ALL I.
*
      SUBROUTINE UXVINE(N,IX)
      INTEGER N,IX(N)
      INTEGER I
      DO 1 I=1,N
      IX(I)=ABS(IX(I))
    1 CONTINUE
      RETURN
      END
