* SUBROUTINE UXVINT               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CHANGE OF THE INTEGER VECTOR ELEMENT FOR THE TRUST REGION BOUND
* ADDITION.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  IU  IX(N)  INTEGER VECTOR.
*  IU  JX(N)  INTEGER VECTOR.
*  II  I  INDEX OF THE CHANGED ELEMENT.
*  II  JOB  CHANGE SPECIFICATION. IX(I):=JX(I) AND JX(I):=0 IF JOB=1
*         OR JOB=2.
*
      SUBROUTINE UXVINT(N,IX,JX,I,JOB)
      INTEGER N,IX(N),JX(N),I,JOB
      IF (JOB.EQ.3.OR.JOB.EQ.0) THEN
      ELSE
      IX(I)=JX(I)
      JX(I)=0
      ENDIF
      RETURN
      END
