* SUBROUTINE UXVLIN                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LINEAR COMBINATION OF TWO VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  B  SCALING FACTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= A*X + B*Y.
*
      SUBROUTINE UXVLIN(N,A,X,B,Y,Z)
      INTEGER N
      $FLOAT  A, X(N), B, Y(N), Z(N)
      INTEGER I
      DO 1 I=1,N
      Z(I) = A*X(I) + B*Y(I)
    1 CONTINUE
      RETURN
      END
