* SUBROUTINE UXVRAS                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* A RANDOM SCALAR IS ADDED TO ALL ELEMENTS OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  RAN  RANDOM VALUE.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR SUCH THAT Y(I)=X(I)+UNRAN1 FOR ALL I.
*
      SUBROUTINE UXVRAS(N,RAN,X,Y)
      INTEGER N
      $FLOAT  RAN, X(N), Y(N), UNRAN1
      INTEGER I
      DO 1 I=1,N
      Y(I) = X(I) + UNRAN1(RAN)
    1 CONTINUE
      RETURN
      END
