* SUBROUTINE UXVSMU                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COPYING ABSOLUTE VALUES OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RU  D(N)  ELEMENTS OF THE DIAGONAL MATRIX.
*  RI  ALF  SCALAR PARAMETER OF THE UPDATE.
*  RI  X(N)  VECTOR PARAMETER OF THE UPDATE.
*
      SUBROUTINE UXVSMU(N,D,ALF,X)
      INTEGER N
      $FLOAT  D(N),ALF,X(N)
      INTEGER I
      $FLOAT TEMP
      DO 1 I=1,N
      D(I)=D(I)+ALF*X(I)*X(I)
    1 CONTINUE
      RETURN
      END
