$INTERFACE UYTRTG                                             98/12/01

  CALL UYTRTG(NF,N,$H,$GN,$GNN)
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$GN($NF)\$GNN($NF)')
$REM  $ADD(INTEGER,'\NF\N')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRTG             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENT OF THE OBJECTIVE FUNCTION IS TRANSFORMED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  H(NF*(NF+1)/2)  SCALING MATRIX.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  GN(NF)  TRANSFORMED GRADIENT OF THE OBJECTIVE FUNCTION.
*
* SUBPROGRAM USED:
*  S   UXDPGB  BACK SUBSTITUTION.
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UYTRTG(NF,N,H,G,GN)
      INTEGER NF,N
      $FLOAT H(NF*(NF+1)/2),G(NF),GN(NF)
      CALL UXVCOP(N,G,GN)
      CALL UXDPGB(N,H,GN,1)
      RETURN
      END

