$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZASET                                    01/12/97  +
$REM + LU                                                            +
$REM + PURPOSE:  INCLUDE SIMULTANEOUS COMPUTATIONS FOR 'A' MODEL     +
$REM +---------------------------------------------------------------+

$IF(NA>0)
$IF(NAL=NA)
  $SAVA=-1
  $LDA=-1
  $LAD=-1
$ELSE
  $SAVA=-1
  $IF(ISNA=1) $SAVA=0
  $IF(ISNA>1) $SAVA=1
  $IF(LDA<0)
    $LAD=-1
    $IF(KD<1)
    $ELSEIF(MODEL='SQ')
    $ELSEIF(MODEL='SP')
    $ELSE
      $IF(KDA<1)
        $IF(ISNA=0)
          $SAVA=0
          $ISNA=1
          ISNA=$ISNA
        $ENDIF
      $ENDIF
    $ENDIF
  $ELSE
    $LAD=KD
    $IF(KDA>LDA)
      $IF(LAD>LDA) $LAD=LDA
    $ELSEIF(LAD=2)
      $IF(CLASS='GN') $LAD=1
    $ENDIF
    $IF(SAVA<LAD) $SAVA=LAD
    $SUBST('UA$(LAD)F02')
    $IF(LAD>LDA)
      $IF(JACA='S')
        $IW='IW'
        $IBG='IBG'
        $JBG='JBG'
        $ADD(INTEGER,'\$IBG($NF+1)\$JBG($MA)\$COLA($NF)\$IW(6*($NF))')
        $ADD(SINID)
          $SUBST('UYCMSA')
          $SUBST('UFSET2')
        $ENDADD
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(LAD<KDA)
    $IF(KD>1)
      $IF(JACA='S')
        $HELP
          MAXIMUM NUMBER OF NONZERO ELEMENTS IN THE
          APPROXIMATED FUNCTION HESSIAN MATRIX
        $CHECK(MHA,100,INT,1)
        $ADD(SINID)
          $SUBST('UFSET8')
        $ENDADD
        $HAS=HA
        $MHAS=MHA
      $ENDIF
    $ENDIF
  $ENDIF
$ENDIF
$ENDIF
