* SUBROUTINE EFFU23                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU23(N,NA,X,F,NEXT)
      INTEGER N,NA,NEXT
      $FLOAT X(N),F
      $FLOAT FA
      INTEGER KA
      IF (NEXT.LE.22) THEN
      CALL EFFU14(N,X,F,NEXT)
      ELSE IF (NEXT.LE.44) THEN
      F=0.0$P 0
      DO 2 KA=1,NA
      CALL EAFU15(N,KA,X,FA,NEXT-22)
      F=F+FA**2
    2 CONTINUE
      F=0.5$P 0*F
      ELSE IF (NEXT.LE.74) THEN
      F=0.0$P 0
      DO 3 KA=1,NA
      CALL EAFU18(N,KA,X,FA,NEXT-44)
      F=F+FA**2
    3 CONTINUE
      F=0.5$P 0*F
      ENDIF
      RETURN
      END
