* SUBROUTINE EIUD38                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR UNCONSTRAINED MINIMIZATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IU  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RO  YA(NE)  INITIAL VALUES.
*  RO  TA  INITIAL TIME.
*  RO  TAMAX  FINAL TIME.
*  RO  HE  INITIAL STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD38(NE,YA,TA,TAMAX,HE,NEXT,IERR)
      INTEGER NE,NEXT,IERR
      REAL*8 YA(NE),TA,TAMAX,HE
      IERR=0
      HE=1.0D-6
      GOTO (10,20,30,40), NEXT
   10 NE=4
      TA=0.0D 0
      YA(1)=0.994D 0
      YA(2)=0.0D 0
      YA(3)=0.0D 0
      YA(4)=-2.00158510637908252240537862224D 0
      TAMAX= 1.70652165601579625588917206249D 1
      RETURN
   20 NE=3
      TA=0.0D 0
      YA(1)=-8.0D 0
      YA(2)= 8.0D 0
      YA(3)= 2.7D 1
      TAMAX= 5.0D 1
      RETURN
   30 NE=2
      TA=0.0D 0
      YA(1)=2.0D 0
      YA(2)=-0.66D 0
      TAMAX=2.0D 0
      RETURN
   40 NE=3
      TA=0.0D 0
      YA(1)=1.0D 0
      YA(2)=0.0D 0
      YA(3)=0.0D 0
      TAMAX=0.5D 0
      RETURN
C   50 NE=8
C      UE=0.1D 0
C      UB=6.0D 0
C      UF=0.026D 0
C      ALPHA=0.99D 0
C      BETA=1.0D-6
C      R0=1000.0D 0
C      R1=9000.0D 0
C      R2=9000.0D 0
C      R3=9000.0D 0
C      R4=9000.0D 0
C      R5=9000.0D 0
C      R6=9000.0D 0
C      R7=9000.0D 0
C      R8=9000.0D 0
C      R9=9000.0D 0
C      TA=0.0D 0
C      YA(1)=0.0D 0
C      YA(2)=UB-Y(1)*R8/R9
C      YA(3)=UB/(R6/R5+1.0D 0)
C      YA(4)=UB/(R6/R5+1.0D 0)
C      YA(5)=UB
C      YA(6)=UB/(R2/R1+1.0D 0)
C      YA(7)=UB/(R2/R1+1.0D 0)
C      YA(8)=0.0D 0
C      TAMAX=0.05D 0
C      RETURN
      END
