* SUBROUTINE UASET3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* AUGMENTATION OF THE SPARSE JACOBIAN MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NB  SAVED NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS IN THE SPARSE JACOBIAN MATRIX.
*  II  MB  SAVED NUMBER OF NONZERO ELEMENTS IN THE SPARSE JACOBIAN
*         MATRIX.
*  II  IAG(NA+2)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA+NF) COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*
      SUBROUTINE UASET3(NF,NA,NB,MA,MB,IAG,JAG)
      INTEGER NF,NA,NB,MA,MB,IAG(NA+2),JAG(*)
      INTEGER I
      MA=IAG(NA+1)-1
      DO 1 I=1,NF
      JAG(MA+I)=I
    1 CONTINUE
      IAG(NA+2)=MA+NF+1
      NB=NA
      MB=MA
      RETURN
      END
