* SUBROUTINE UASET6             ALL SYSTEMS                   06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF THE VECTOR CONTAINING TYPES OF APPROXIMATED FUNCTIONS.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF APPROXIMATED FUNCTIONS.
*  II  IEXT  TYPE OF EXTREMUM. IEXT<0-MINIMAX. IEXT=0-CHEBYSHEV
*         APPROXIMATION, IEXT>0-MAXIMIN.
*  RI  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*
      SUBROUTINE UASET6(NA,IA,IEXT,FMIN)
      INTEGER NA,IA(2*NA),IEXT
      REAL*8 FMIN
      INTEGER KA,KPOM
      KPOM=0
      DO 1 KA=1,NA
      IF (IEXT.EQ.0) THEN
      IF (IA(KA).GE.3) THEN
      IA(KA)=3
      IA(KA+NA)=4
      ELSE
      KPOM=1
      IA(KA+NA)=0
      ENDIF
      ELSE IF (IEXT.LT.0) THEN
      KPOM=1
      IA(KA)=2
      ELSE IF (IEXT.GT.0) THEN
      KPOM=1
      IA(KA)=1
      ENDIF
    1 CONTINUE
      IF (KPOM.EQ.0) FMIN=MAX(FMIN,0.0D 0)
      RETURN
      END
