* SUBROUTINE UKSGLF                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* DEFINE STATUS AND CONTROL VARIABLES.
*
* PARAMETERS :
*  RI  STFL  STABILITY FLAG.
*  RO  EPS7  DROPPING FLAG TO REMOVE SMALL ELEMENTS.
*  RO  EPS9  TOLERANCE ON ACTIVITY OF CONSTRAINTS.
*            NONDEGENERATE ONE.
*  RI  DEL1  MULTIPLIER BOUND FOR PIVOT LOOK-UP.
*  RI  DEL2  RELATIVE BOUND FOR NEGLECTING SMALL ELEMENTS WHEN
*            CONSTRUCTING INITIAL BASIS.
*  IO  MLP1  ACTUAL NUMBER OF DEGENERATE ITERATIONS AFTER THE LAST
*
      SUBROUTINE UKSGLF(STFL,DEL1,DEL2,EPS7,EPS9,MLP1)
      INTEGER MLP1
      REAL*8 STFL,DEL1,DEL2,EPS7,EPS9
C
C     DEFINE STATUS AND CONTROL VARIABLES
C
      STFL=5.0D 0
      MLP1=0
      EPS7=0.1D-9
      EPS9=1.0D-8
      DEL1=0.5D-1
      DEL2=0.1D 0
      RETURN
      END
