* SUBROUTINE UOMPAT                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB AND SCILAB GRAPHICAL VISUALIZATION OF THE PATH OF ITERATIONS - PRINTIN
*
* PARAMETERS :
*  II  NPAC  NUMBER OF VALUES FOR PLOTTING.
*  RI  YPA(3*NPAC)  VECTOR CONTAINING VALUES FOR PLOTTING.
*  II  INFO  HOW MANY AND WHAT TYPE OF GRAPHS TO PLOT [1,2,3].
*  RO  MINIM  MINIMAL VALUE AMONG THE PLOTTING VALUES.
*  RO  MAXIM  MAXIMAL VALUE AMONG THE PLOTTING VALUES.
*
      SUBROUTINE UOMPAT(NPAC,YPA,INFO,MINIM,MAXIM)
      INTEGER NPAC,INFO,I,J,K
      REAL*8 YPA(3*NPAC),WY(10),MINIM,MAXIM
      CHARACTER*250 RET
C
      MAXIM=-1D60
      MINIM= 1D60
      WRITE(RET,'(I10)')NPAC
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'x=1:', TRIM(RET), ';'
      IF (INFO/10.EQ.0) THEN
        WRITE(15,'(A)') 'f=['
      ELSE
        WRITE(15,'(A)') 'x1=['
      ENDIF
      J=0
      DO I=1,NPAC
        J=J+1
        WY(J)=YPA(I)
        MAXIM=MAX(MAXIM,YPA(I))
        MINIM=MIN(MINIM,YPA(I))
        IF (J.EQ.10) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(15,'(2A)') TRIM(RET), ' ...'
          J=0
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
        WRITE(15,'(2A)') TRIM(RET), ' ...'
      ENDIF
      WRITE(15,'(A)') '];'
C
      IF (INFO/10.GE.2) THEN
        WRITE(15,'(A)') 'x2=['
        J=0
        DO I=1,NPAC
          J=J+1
          WY(J)=YPA(NPAC+I)
          MAXIM=MAX(MAXIM,YPA(NPAC+I))
          MINIM=MIN(MINIM,YPA(NPAC+I))
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(15,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDDO
        IF (J.GT.0) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(15,'(2A)') TRIM(RET), ' ...'
        ENDIF
        WRITE(15,'(A)') '];'
      ENDIF
C
      IF (INFO/10.EQ.3) THEN
        WRITE(15,'(A)') 'x3=['
        J=0
        DO I=1,NPAC
          J=J+1
          WY(J)=YPA(2*NPAC+I)
          MAXIM=MAX(MAXIM,YPA(2*NPAC+I))
          MINIM=MIN(MINIM,YPA(2*NPAC+I))
          IF (J.EQ.10) THEN
            WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
            WRITE(15,'(2A)') TRIM(RET), ' ...'
            J=0
          ENDIF
        ENDDO
        IF (J.GT.0) THEN
          WRITE(RET,'(10D25.16)') (WY(K),K=1,J)
          WRITE(15,'(2A)') TRIM(RET), ' ...'
        ENDIF
        WRITE(15,'(A)') '];'
      ENDIF
      RETURN
      END
