* SUBROUTINE UP0SA2             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE  OF THE L1 EXACT PENALTY FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  PENALTY COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
      SUBROUTINE UP0SA2(NC,CF,RPF2,RPF3,FC,F)
      INTEGER NC
      REAL*8 CF(NC+1),RPF2,RPF3,FC,F
      INTEGER KC
      FC=0.0D 0
      DO 1 KC=1,NC
      FC=FC+RPF2*ABS(CF(KC))+0.5D 0*RPF3*CF(KC)**2
    1 CONTINUE
      F=CF(NC+1)+FC
      RETURN
      END
