* SUBROUTINE UQEMSG                ALL SYSTEMS               89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  WRITE AN ERROR MESSAGE
*
* PARAMETERS :
*  II  NMSG - NUMBER OF MESSEGES
*  TI  MSG(NMSG) - MESSEGES
*  II  OUNIT - THE OUTPUT UNIT NUMBER
*  II  OIUNIT - THE OUTPUT INTERACTIVE UNIT NUMBER
*  II  NSUB - LEVEL OF NESTING OF SUBST('FILENAME')
*  II  MNSUB - MAX. NSUB
*  II  NLINES - NUMBER OF LINE ALREADY READ FROM THE INPUT FILE
*  TI  FNAMES(MNSUB) - NAMES OF FILES
*  II  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSTRI - CONVERT AN INTEGER NUMBER TO A STRING
*
      SUBROUTINE UQEMSG(NMSG,MSG,OUNIT,OIUNIT,NSUB,MNSUB,NLINES,
     *                  FNAMES,NAME,IER)
      INTEGER NMSG,OUNIT,OIUNIT,NSUB,MNSUB,NLINES,IER
      CHARACTER*50 FNAMES(MNSUB),NAME
      CHARACTER*70 MSG(50)
      INTEGER I,J,LEN
      INTEGER*4 I4
      CHARACTER*1 STRIER(6)
      LEN=0
      I4=IER
      CALL UQSTRI(I4,STRIER,6,LEN,1,I)
      DO 2 I=1,NMSG
        DO 1 J=1,LEN
          IF(STRIER(J).NE.MSG(I)(J:J)) GOTO 2
    1   CONTINUE
        IF(MSG(I)(LEN+1:LEN+1).EQ.' ') GOTO 3
    2 CONTINUE
    3 MSG(I)=MSG(I)(LEN+1:)
      IF(NSUB.EQ.0) THEN
        NSUB=1
        FNAMES(1)='MAIN'
      ENDIF
      IF (IER.EQ.9) THEN
      WRITE(OUNIT,5) IER,FNAMES(NSUB),NLINES,MSG(I),NAME
      IF(OIUNIT.GT.0) WRITE(OIUNIT,5) IER,FNAMES(NSUB),NLINES,MSG(I),
     * NAME
      ELSE
      WRITE(OUNIT,4) IER,FNAMES(NSUB),NLINES,MSG(I)
      IF(OIUNIT.GT.0) WRITE(OIUNIT,4) IER,FNAMES(NSUB),NLINES,MSG(I)
      ENDIF
      RETURN
    4 FORMAT(' +++ FATAL ERROR: ',I5/
     *       '     FILE:  ',A50/
     *       '     LINE: ',I5/
     *       '     CAUSE:',A60/
     *       ' +++ EXECUTION ABORTED')
    5 FORMAT(' +++ FATAL ERROR: ',I5/
     *       '     FILE:  ',A50/
     *       '     LINE: ',I5/
     *       '     CAUSE:',A60/
     *       '     NAME:  ',A50/
     *       ' +++ EXECUTION ABORTED')
      END
