* SUBROUTINE UQESIF                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'ELSEIF'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  II  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  NIF1 - NUMBER OF NESTED IF-ENDIF WITH CONDIF=.TRUE.
*  II  NIF2 - NUMBER OF ALL NESTED IF-ENDIF
*  II  MNIF - MAX. NUMBER OF NESTED IF-ENDIF
*  LI  LELSE(MNIF) - WORK ARRAY
*  LU  LIFDON(MNIF) - WORK ARRAY
*  LU  CONDIF - CONDITION OF LAST IF-ENDIF
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  LF  UQLEXP - EVALUATION OF LOGICAL EXPRESSION
*
      SUBROUTINE UQESIF(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,IDIRN,NIF1,NIF2,MNIF,LELSE,
     *                  LIFDON,CONDIF,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),IDIRN,NIF1,
     *        NIF2,MNIF,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      LOGICAL LELSE(MNIF),LIFDON(MNIF),CONDIF
      LOGICAL UQLEXP
      IF(NIF1.EQ.0) GOTO 1
      IF(NIF1.NE.NIF2) RETURN
      IF(LELSE(NIF1)) GOTO 1
      IF(LIFDON(NIF1)) THEN
        CONDIF=.FALSE.
        RETURN
      ENDIF
      CONDIF=UQLEXP(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *              IPOINT,MNP,IDIRN,IER)
      IF(CONDIF) LIFDON(NIF1)=.TRUE.
      RETURN
C
C ERROR: UNEXPECTED 'ELSEIF'
C
    1 IER=37
      RETURN
      END
