* SUBROUTINE UXDSDT                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TRACE OF A DENSE SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  ALF  TRACE OF THE MATRIX A.
*
      SUBROUTINE UXDSDT(N,A,ALF)
      INTEGER N
      REAL*8  A(N*(N+1)/2), ALF
      INTEGER I,J
      ALF=0.0D 0
      J = 0
      DO  1  I = 1, N
      J = J + I
      ALF=ALF+A(J)
    1 CONTINUE
      RETURN
      END
