* SUBROUTINE UXSRO5                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIALIZE ARRAY BEG FROM BJA1.
*
*  PARAMETERS :
*  II  M  NUMBER OF ROWS OF THE MATRIX.
*  II  NN  NUMBER OF BLOCKS IN THE MATRIX.
*  II  BJA1(N)  BEGINNINGS OF THE BLOCK COLUMNS.
*  II  BEG(N) POINTER TO HIGHER INDICES.
*  IA  WN01(N) AUXILIARY VECTOR.
*
      SUBROUTINE UXSRO5(M,NN,BJA1,IBEG,BEG,WN01)
C
C   WN01 - POMOCNE POLE OBSAHUJICI INDEXY POCATKU BLOKU VE
C          VSTUP.MATICI (BJA1)
C   IBEG - PROMENNA OBSAHUJICI NEJNIZSI INDEX POCATKU BLOKU
C   BEG  - POLE OBSAHUJICI ODKAZY NA NEJBLIZSI VYSSI INDEX
C          POCATKU BLOKU
C
      INTEGER M,NN,IBEG,BEG(M),WN01(NN),BJA1(NN),I
      DO 10 I=1,NN
        WN01(I)=BJA1(I)
   10 CONTINUE
C
C  PROCEDURA SETRIDI POLE WN01 VZESTUPNE
C
      CALL UXVSRT(NN,WN01)
      IBEG=WN01(1)
      DO 20 I=1,NN-1
        IF (WN01(I).EQ.WN01(I+1)) GOTO 20
        BEG(WN01(I))=WN01(I+1)
   20 CONTINUE
      BEG(WN01(NN))=IBEG
      RETURN
      END
