* FUNCTION UXSSDL                  ALL SYSTEMS                88/12/01
C PORTABILITY : ALL SYSTEMS
C 88/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF A MINIMUM DIAGONAL ELEMENT OF A SPARSE SYMMETRIC
* MATRIX
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A
*  II  IA(N+1)  POINTER VECTOR OF THE DIAGONAL OF THE SPARSE MATRIX.
*  RI  A(MMAX) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      USUAL FORM.
*  II  MMAX  LENGTH OF THE PRINCIPAL MATRIX VECTORS (SA,A)
*  RR  UXSSDL  MINIMUM DIAGONAL ELEMENT OF THE MATRIX A
*
      FUNCTION UXSSDL(N,MMAX,A,IA,JA,INF)
      INTEGER  N,MMAX,IA(N+1),JA(MMAX),INF
      REAL*8  A(MMAX),UXSSDL
      REAL*8  CON
      PARAMETER (CON=1.0D120)
      INTEGER I,J
      INF=0
      UXSSDL = CON
      DO 100 I=1,N
      J=IA(I)
      IF (JA(J).GT.0.AND.UXSSDL.GT.A(J)) THEN
      INF=I
      UXSSDL=A(J)
      ENDIF
100   CONTINUE
      RETURN
      END
