* SUBROUTINE UXSSMS                ALL SYSTEMS                88/12/01
C PORTABILITY : ALL SYSTEMS
C 88/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF A SPARSE SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  RI  ALF  SCALING FACTOR.
*
      SUBROUTINE UXSSMS(N,M,A,ALF)
      INTEGER N,M
      REAL*8  A(M), ALF
      INTEGER I,J
      J=N
      DO 100 I=1,M
      A(I) = A(I) * ALF
100   CONTINUE
      RETURN
      END
