* SUBROUTINE UXUSET                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR DIFFERENCE IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  INITIAL VALUE.
*  RO  X(N)  OUTPUT VECTOR SUCH THAT X(I)=A FOR ALL I.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXUSET(N,A,X,IX,JOB)
      INTEGER N,IX(N),JOB
      REAL*8 A,X(N)
      INTEGER I
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      X(I)=A
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) X(I)=A
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) X(I)=A
    3 CONTINUE
      ENDIF
      RETURN
      END
