* SUBROUTINE UXVMED                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MEDIAN OF TWO VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= (X+Y)/2.
*
      SUBROUTINE UXVMED(N,X,Y,Z)
      INTEGER N
      REAL*8  X(N), Y(N), Z(N)
      INTEGER I
      REAL*8 HALF
      PARAMETER (HALF=0.5D 0)
      DO 1 I=1,N
      Z(I) = HALF*(X(I) + Y(I))
    1 CONTINUE
      RETURN
      END
