* SUBROUTINE UXVSMZ                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COPYING ABSOLUTE VALUES OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RU  D(N)  ELEMENTS OF THE DIAGONAL MATRIX.
*  RI  ALF  SCALAR PARAMETER OF THE UPDATE.
*  RI  X(N)  VECTOR PARAMETER OF THE UPDATE.
*  RI  Y(N)  VECTOR PARAMETER OF THE UPDATE.
*
      SUBROUTINE UXVSMZ(N,D,ALF,X,Y)
      INTEGER N
      REAL*8  D(N),ALF,X(N),Y(N)
      INTEGER I
      REAL*8 TEMP
      TEMP=2.0D 0*ALF
      DO 1 I=1,N
      D(I)=D(I)+TEMP*X(I)*Y(I)
    1 CONTINUE
      RETURN
      END
