* FUNCTION UYINDX                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  INDEXES AN ARRAY ARRIN OF LENGTH N, I.E. OUTPUTS THE ARRAY INDX
*  SUCH THAT ARRIN(INDX(J)) IS IN ASCENDING ORDER FOR J=1,2,...,N.
*
* PARAMETERS :
*  II  N  LENGTH OF ARRAY ARRIN.
*  RI  ARRIN(N)  ARRAY WITH VALUES.
*  IO  INDX(N)  INDEX TABLE.
*
* METHOD :
*  NUMERICAL RECEPIES (P.231-232).
*
      SUBROUTINE UYINDX(N,ARRIN,INDX)
      INTEGER N,INDX(N)
      REAL*8 ARRIN(N)
      INTEGER I,J,L,IR,INDXT
      REAL*8 Q
      DO 11 J=1,N
        INDX(J)=J
11    CONTINUE
      IF(N.LE.1) RETURN
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          INDXT=INDX(L)
          Q=ARRIN(INDXT)
        ELSE
          INDXT=INDX(IR)
          Q=ARRIN(INDXT)
          INDX(IR)=INDX(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            INDX(1)=INDXT
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1)))J=J+1
          ENDIF
          IF(Q.LT.ARRIN(INDX(J)))THEN
            INDX(I)=INDX(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        INDX(I)=INDXT
      GO TO 10
      END
