$INTERFACE UC0F02                                             97/12/01

      $ADD(REAL,'\$CF($NC)')
 $00  CALL UC0F02
      GOTO ($20,$10) ISB+1
 $10  CONTINUE
      $MTYPE=FMODC
      $SUBST('UZCMOD')
      GOTO $00
 $20  CONTINUE
      $ADD(INIT)
        NCXX='UC0F02'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UC0F02             ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SIMULTANEOUS COMPUTATION OF THE APPROXIMATED FUNCTION VALUES.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LDC  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UC0F02
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UCXX') CALL UYPRO1('UCXX',-1)
      GO TO (1,2) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 3
      IF (LDC.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      LDC=0
    3 CALL UYEPI1(-1)
      RETURN
      END
