$INTERFACE UC1F02                                             97/12/01

 $00  CONTINUE
      $ADD(INTEGER,'\LDPOM')
$REM      $LDPOM=LDC
      LDPOM=LDC
      $IF(JACC='D')
        CALL UXVSET((NC-NCL)*NF,ZERO,$CG(NCL*NF+1))
      $ENDIF
      CALL UC1F02
      GOTO ($40,$10,$20) ISB+1
 $10  CONTINUE
      $MTYPE=FMODC
      $SUBST('UZCMOD')
      $GO TO $00
 $20  CONTINUE
      $IF(GMODC='G')
        $MTYPE='G'
        $SUBST('UZCMOD')
        GOTO $00
      $ELSEIF(FMODC='F')
        $IF(JACC='S')
          $SUBST('UC0G$(CON)4')
        $ELSE
          $SUBST('UC0G$(CON)2')
        $ENDIF
        GOTO ($00,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODC
        $SUBST('UZCMOD')
        GO TO $20
      $ELSE
        $ADD(REAL,'\$CF($NC)\$CFO($NC)')
        IF (LDC.GT.LDPOM) GOTO $00
        CALL UXVCOP(NC,$CF,$CFO)
        $MTYPE=FMODC
        $SUBST('UZCMOD')
        CALL UXVCOP(NC,$CFO,$CF)
        GO TO $00
      $ENDIF
 $40  CONTINUE
      $ADD(INIT)
        NCXX='UC1F02'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UC1F02                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SIMULTANEOUS COMPUTATION OF THE APPROXIMATED FUNCTION VALUES AND
* GRADIENTS.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LDC  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UC1F02
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,2,4) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 5
      IF (LDC.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      LDC=0
    3 IF (KD.LT.1) GO TO 5
      IF (LDC.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      LDC=1
    5 CALL UYEPI1(-1)
      RETURN
      END
