$INTERFACE UCSLG2                                             97/12/01
$REM LU

*     --------------------------------
*     START OF SECOND ORDER CORRECTION
*     --------------------------------
  $XS='XS'
  $ADD(REAL,'\$B($MMAX)\$CG($MC)\$CF($NC)\$X($NF)\$XO($NF)\$GS($NF)&
  \$XS($NC)')
  $ADD(INTEGER,'\$IB($NC+1)\$JB($MMAX)\$ICG($NC+1)\$JCG($MC)&
  \$PSR($NC+1)\$PERC($NC)\$WN11($NC+1)\$WN12($NC+1)\$IX($NX)')
  $ADD(INTEGER,'\MS')
  $ADD(REAL,'\ALF\TAU')
  $ADD(INTEGER,'\L')
  $N='NF'
  $POM1='U'
  $POM2=',$$IX,KBF)'
  $ADD(REAL,'\UX$(POM1)DOT')
  CALL UYPRO1('UCXX',0)
  ITERS=0
  IPOM3=0
  IF (SNORM.GE.XMAX) GO TO $30
  R=ONE
  CALL UYSET2
  CALL UX$(POM1)DIR(NF,ONE,$S,$XO,$X$POM2
  ASSIGN $20 TO IMD
  GO TO $LMD
$20 CONTINUE
  IF (F-FO.LE.EPS1*PO) THEN
  ITERS=5
  TSXX='ARMIJO  '
  GO TO $30
  ENDIF
  $IF(IDECC=0)
    $SUBST('UCESS2')
    L=$IB(NC+1)-1
    IF (IDECC.NE.1) THEN
    CALL UXSPCT(NC,L,MS,MMAX,$B,$JB,$PSR,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $30
    ENDIF
*
*     GILL-MURRAY DECOMPOSITION
*
    ALF=ETA0
    CALL UXSPCF(NC,MMAX,$B(L+1),$PSR,$JB(L+1),$WN11,$WN12,$XS,INF,ALF&
,TAU)
    ENDIF
  $ELSE
    L=$IB(NC+1)-1
  $ENDIF
*
*     NEWTON LIKE STEP
*
  CALL UXVNEG(NC,$CF,$XS)
  CALL UXVSFP(NC,$PERC,$XS,$GS)
  CALL UXSPCB(NC,MMAX,$B(L+1),$PSR,$JB(L+1),$XS,0)
  CALL UXVSBP(NC,$PERC,$XS,$GS)
  CALL UXSCMM(NF,NC,MC,$CG,$ICG,$JCG,$XS,$GS)
  IPOM3=1
  IF (UX$(POM1)DOT(NF,$GS,$GS$POM2.GE.(SNORM/TWO)**2) THEN
  CALL UXVSET(NF,ZERO,$GS)
  IPOM3=-IPOM3
  ENDIF
$30 CONTINUE
  CALL UYEPI1(0)
*     ------------------------------
*     END OF SECOND ORDER CORRECTION
*     ------------------------------
  $EXIT
