* SUBROUTINE UESET1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL DETERMINATION OF MESH POINTS FOR INITIAL VALUE PROBLEMS.
*
* PARAMETERS :
*  II  NA  NUMBER OF MESH POINTS.
*  RI  AT(NA)  MESH POINTS.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RI  TAMAX  MAXIMUM VALUE OF THE INTEGRATION PARAMETER.
*
* COMMON DATA :
*
      SUBROUTINE UESET1(NA,AT,TA,TAMAX,HEMAX)
      INTEGER NA
      $INCLUDE ('UMCOMM')
      $FLOAT AT(NA),TA,TAMAX,HEMAX
      $FLOAT TEMP,DEL
      INTEGER KA
      TEMP=TA
      DEL=(TAMAX-TA)/$DBLE(NA-1)
      AT(1)=TEMP
      DO 1 KA=2,NA-1
      TEMP=TEMP+DEL
      AT(KA)=TEMP
    1 CONTINUE
      AT(NA)=TAMAX
      IF (HEMAX.LE.ZERO) HEMAX=TAMAX-TA
      RETURN
      END

