$INTERFACE UESVY1                                             98/12/01

  CALL UESVY1(NE,KE,$YA,FE)
  $ADD(REAL,'\$YA($MEL)')
$REM  $ADD(INTEGER,'\NE\KE')
$REM  $ADD(REAL,'\FE')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UESVY1             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SAVING INITIAL VALUE OF THE SOLUTION.
*
* PARAMETERS :
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE RIGHT HAND SIDE FUNCTION.
*  RO  YA(NE)  SOLUTION VECTOR.
*  RI  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*
      SUBROUTINE UESVY1(NE,KE,YA,FE)
      INTEGER NE,KE
      $FLOAT YA(NE),FE
      YA(KE)=FE
      RETURN
      END
