* SUBROUTINE ULMAI1                 ALL SYSTEMS                05/06/01
C PORTABILITY : ALL SYSTEMS
C 05/06/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INPUT OF THE JACOBIAN MATRIX ELEMENT AG(KA,I)
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF CONSTRAINTS.
*  RU  AG(NF*NA) JACOBIAN MATRIX VALUES.
*  IO  IER OUTPUT ERROR INFORMATION.
*  II  K  INPUT ROW INDEX.
*  II  I  INPUT COLUMN INDEX.
*  RI  VAL  INPUT NUMERICAL VALUE.
*
      SUBROUTINE ULMAI1(NF,NA,AG,IER,K,I,VAL)
      INTEGER NF,NA,IER,K,I
      $FLOAT AG(NF*NA),VAL
      IER=0
      IF (I.LE.0.OR.I.GT.NF) IER=2
      IF (K.LE.0.OR.K.GT.NA) IER=3
      IF (IER.NE.0) RETURN
      AG((K-1)*NF+I)=VAL
      RETURN
      END
