$INTERFACE UO2FG4                                             98/12/01

  $IF(PATH='YES')
    $JOB=1
    $DIM=2
  $ELSE
    $JOB=2
    $DIM=NF
  $ENDIF
  CALL UO2FG4(NF,$X,$XPA,$FPA,F,$JOB)
  $ADD(REAL,'\$X($NF)\$FPA($NPA)')
  $ADD(REAL4,'\$XPA($NPA,$DIM)')
$REM  $ADD(REAL,'\F')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UO2FG4                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL VISUALIZATION OF THE OPTIMIZATION PATH.
*
* COMMON DATA :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  IA  IVAR  AUXILIARY VARIABLE
*  IA  JVAR  AUXILIARY VARIABLE
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANS.
*
      SUBROUTINE UO2FG4(NF,X,XPA,FPA,F,JOB)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF,JOB,I,K
      $FLOAT X(NF),FPA(NPA),F
      REAL*4 XPA(NPA,*)
      IF (NIT.LT.NPA) THEN
      FPA(NIT+1)=F
      IF (JOB.EQ.1) THEN
      XPA(NIT+1,1)=X(IGR)
      XPA(NIT+1,2)=X(JGR)
      ELSE
      DO 1 I=1,NF
      XPA(NIT+1,I)=X(I)
    1 CONTINUE
      ENDIF
      ELSE
      DO 9 K=1,NPA-1
      FPA(K)=FPA(K+1)
    9 CONTINUE
      FPA(NPA)=F
      IF (JOB.EQ.1) THEN
      DO 2 K=1,NPA-1
      XPA(K,1)=XPA(K+1,1)
      XPA(K,2)=XPA(K+1,2)
    2 CONTINUE
      XPA(NPA,1)=X(IGR)
      XPA(NPA,2)=X(JGR)
      ELSE
      DO 4 K=1,NPA-1
      DO 3 I=1,NF
      XPA(K,I)=XPA(K+1,I)
    3 CONTINUE
    4 CONTINUE
      DO 5 I=1,NF
      XPA(NPA,I)=X(I)
    5 CONTINUE
      ENDIF
      ENDIF
      RETURN
      END
