* SUBROUTINE UOMGRX                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL OUTPUT - EITHER A FILE OR ONLY AN IMMEDIATE PREVIEW.
*
* PARAMETERS :
*  II  ID  ID NUMBER OF THE FILE.
*  CI  NAME  THE NAME OF THE PICTURE.
*  II  CISLO  THE NUMBER OF THE GRAPH.
*  II  GFMT  GRAPHIC FORMAT - EPS/PNG.
*
      SUBROUTINE UOMGRX(ID,NAME,CISLO,GFMT)
      $OPTION(CHEOL='#')
      INTEGER ID,CISLO,GFMT
      CHARACTER*5 NAME
C
      IF (GFMT.EQ.1) THEN
        IF (CISLO.LE.9) THEN
          WRITE(ID,'(3A,I1,A)') 'print -depsc ',NAME,'0',CISLO,';'
        ELSE
          WRITE(ID,'(2A,I2,A)') 'print -depsc ',NAME,CISLO,';'
        ENDIF
        WRITE(ID,*)
        CLOSE(ID)
      ELSEIF (GFMT.EQ.2) THEN
        IF (CISLO.LE.9) THEN
          WRITE(ID,'(3A,I1,A)') 'print -dpng ',NAME,'0',CISLO,';'
        ELSE
          WRITE(ID,'(2A,I2,A)') 'print -dpng ',NAME,CISLO,';'
        ENDIF
        WRITE(ID,*)
        CLOSE(ID)
      ELSE
        CLOSE(ID)
        CALL UOMSYS('M')
      ENDIF
      RETURN
      $OPTION(CHEOL=';')
      END
