$INTERFACE UOT2F1                                             98/12/01

  CALL UOT2F1(NF,$GF,$HF,FF)
  $ADD(REAL,'\$GF($NF)\$HF($NF*($NF+1)/2)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT2F1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  HF(NF*(NF+1)/2)  HESSIAN MATRIX OF THE OBJECTIVE FUNCTION.
*  RI  FF  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES:
* FF,GF(NF),HF(NF*(NF+1)/2)
*
      SUBROUTINE UOT2F1(NF,GF,HF,FF)
      $INCLUDE('UMCOMM')
      INTEGER NF
      $FLOAT GF(NF),HF(NF*(NF+1)/2),FF
      INTEGER I
      GOTO(1,4,5) KD+1
    1 WRITE(IWR,2) 'FF A =',FF
    2 FORMAT(/1X,A6,$P 18.10)
      WRITE(IWR,3) 'GF N =',(GF(I),I=1,NF)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GF A =', (GF(I),I=1,NF)
      WRITE(IWR,3) 'HF N =', (HF(I),I=1,NF*(NF+1)/2)
      RETURN
    5 WRITE(IWR,3) 'HF A =', (HF(I),I=1,NF*(NF+1)/2)
      RETURN
      END
