* SUBROUTINE UQINCS                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  INCLUDE A SUBSTRING FROM STRAR2 TO STRAR1
*
* PARAMETERS :
*  TU  STRAR1(MLEN1) - A STRING ARRAY BEING CHANGED
*  II  MLEN1 - MAX. LENGTH OF STRAR1
*  IU  LEN1 - ACTUAL LENGTH OF STRAR1
*  II  IPOS1 - POSITION IN STRAR1 TO INCLUDE A SUBSTRING
*  TI  STRAR2(MLEN2) - A STRING ARRAY WITH A SUBSTRING
*  II  MLEN2 - MAX. LENGTH OF STRAR2
*  II  IPOS21 - POSITION OF THE FIRST CHARACTER OF A SUBSTRING IN STRAR2
*  II  IPOS22 - POSITION OF THE LAST CHARACTER OF A SUBSTRING IN STRAR2
*  IO  IER - ERROR INDICATOR
*
      SUBROUTINE UQINCS(STRAR1,MLEN1,LEN1,IPOS1,STRAR2,
     *                  MLEN2,IPOS21,IPOS22,IER)
      INTEGER MLEN1,LEN1,IPOS1,MLEN2,IPOS21,IPOS22,IER
      CHARACTER*1 STRAR1(MLEN1),STRAR2(MLEN2)
      INTEGER I,J
      I=IPOS22-IPOS21+1
      IF(I.GT.0) THEN
        IF(LEN1+I.GT.MLEN1) GOTO 3
        J=LEN1
    1   IF(IPOS1.LE.J) THEN
          STRAR1(I+J)=STRAR1(J)
          J=J-1
          GOTO 1
        ENDIF
        LEN1=LEN1+I
        DO 2 J=0,I-1
          STRAR1(IPOS1+J)=STRAR2(IPOS21+J)
    2   CONTINUE
      ENDIF
      RETURN
C
C ERROR: MAX. LENGTH OF STRAR1 EXCEEDED
C
    3 IER=27
      RETURN
      END
