$INTERFACE UUDRD4                                             97/12/01

  $N='N'
  $ADD(REAL,'\$AG($NF*$NA)\$AGH($NF*$NA)')
$REM  $ADD(INTEGER,'\$N\NA\IPOM1')
  CALL UUDRD4($N,NA,$AG,$AGH,IPOM1)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDRD4                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COPY OF A DENSE RECTANGULAR MATRIX
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RU  AG(NF*NA)  JACOBIAN MATRIX.
*  RU  BG(NF*NA)  CORRECTION OF THE JACOBIAN MATRIX.
*  II  IPOM1  METHOD INDICATOR.
*
* COMMON DATA :
*  II  ITERS  TERMINATION INDICATOR. ITERS=0-ZERO STEP.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UUDRD4(N,NA,AG,BG,IPOM1)
      INTEGER N,NA,IPOM1
      $INCLUDE('UMCOMM')
      $FLOAT AG(N*NA),BG(N*NA)
      IF (IPOM1.NE.1) THEN
      IF (ITERS.GT.0) CALL UXVCOP(N*NA,AG,BG)
      TUXX='NEWTON  '
      ENDIF
      RETURN
      END
