* SUBROUTINE UXDRFL             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TEST ON ACTIVITY OF A GIVEN LINEAR CONSTRAINT.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  KC  INDEX OF A GIVEN CONSTRAINT.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CB(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
      SUBROUTINE UXDRFL(NC,KC,CF,IC,CB,EPS9,INEW)
      INTEGER NC,KC,IC(NC),INEW
      $FLOAT CF(NC),CB(NC),EPS9
      $FLOAT TEMP
      IF (IC(KC).LT.-10) IC(KC)=-IC(KC)-10
      IF (IC(KC).EQ.1) THEN
      TEMP=EPS9*MAX(ABS(CB(KC)),1.0$P 0)
      IF (CF(KC).GT.CB(KC)+TEMP) THEN
      ELSE IF (CF(KC).GE.CB(KC)-TEMP) THEN
      IC(KC)=11
      INEW=KC
      ELSE
      IC(KC)=-11
      ENDIF
      ELSE IF (IC(KC).EQ.2) THEN
      TEMP=EPS9*MAX(ABS(CB(KC)),1.0$P 0)
      IF (CF(KC).LT.CB(KC)-TEMP) THEN
      ELSE IF (CF(KC).LE.CB(KC)+TEMP) THEN
      IC(KC)=12
      INEW=KC
      ELSE
      IC(KC)=-12
      ENDIF
      ENDIF
      RETURN
      END
