* SUBROUTINE UXDSDM                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DIAGONAL OF A DENSE SYMMETRIC MATRIX A IS MULTIPLIED BY SQUARE OF A
* DIAGONAL MATRIX X SO THAT A:=X*A*X.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  X(N)  ELEMENTS OF THE DIAGONAL MATRIX X.
*
      SUBROUTINE UXDSDM(N,A,X)
      INTEGER N
      $FLOAT  A(N*(N+1)/2), X(N)
      INTEGER I,J
      J = 0
      DO  1  I = 1, N
      J = J + I
      A(J)=A(J)*X(I)**2
    1 CONTINUE
      RETURN
      END
