* SUBROUTINE UXERMM                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF TRANSPOSED RECTANGULAR MATRIX BY A VECTOR.
*
* PARAMETERS :
*  II  N  NUMBER OF ELEMENTS OF VECTOR  U.
*  II  M  NUMBER OF ELEMENTS OF VECTOR  V.
*  II  MM  MAXIMUM NUMBER OF COLUMNS AND ROWS OF MATRIX  XM.
*  RI  A(MM,MM)  RECTANGULAR MATRIX.
*  RI  U(N)  INPUT VECTOR  U.
*  RO  V(M)  OUTPUT VECTOR  V.
*
* SUBPROGRAMS USED :
*
      SUBROUTINE UXERMM(N,M,MM,A,U,V)
      INTEGER M,MM,N,I,J
      $FLOAT U(N),V(M),A(MM,MM), Q
C   Nasobeni transp.obdel.matice S^T(N->MM,M->MM)  vekt. U:  (S^T)*U --> V
      DO I=1,M
        Q=0.0$P 0
        DO J=1,N
          Q=Q+A(J,I)*U(J)
        END DO
        V(I)=Q
      END DO
      RETURN
      END
