* SUBROUTINE UXUMAX             ALL SYSTEMS                   99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* L-INFINITY NORM OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*  RR  UXUMAX  L-INFINITY NORM OF THE VECTOR X.
*

      FUNCTION UXUMAX(N,X,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT X(N),UXUMAX
      INTEGER I
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      UXUMAX=ZERO
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      UXUMAX=MAX(UXUMAX,ABS(X(I)))
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) UXUMAX=MAX(UXUMAX,ABS(X(I)))
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) UXUMAX=MAX(UXUMAX,ABS(X(I)))
    3 CONTINUE
      ENDIF
      RETURN
      END
