* FUNCTION UXVACC                  ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  ACCELERATION STEP FOR PATTERN SEARCH.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  ALF  ACCELERATION PARAMETER.
*  RU  X(N)  INPUT VECTOR.
*  RU  Y(N)  ACCELERATION STEP Y:=Y+ALF*(Y-X).
*  RR  UXVACC  PREVIOUS STEPSIZE.
*
      FUNCTION UXVACC(N,ALF,X,Y)
      INTEGER N
      $FLOAT ALF,X(N),Y(N),UXVACC
      INTEGER I
      $FLOAT TEMP
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P  0)
      UXVACC=ZERO
      DO 1 I=1,N
      UXVACC=MAX(UXVACC,ABS(Y(I)-X(I)))
      TEMP=X(I)
      X(I)=Y(I)
      Y(I)=Y(I)+ALF*(Y(I)-TEMP)
    1 CONTINUE
      RETURN
      END
