C SUBROUTINE  UXVETP             ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE : POSTORDERING. REVISED TU 30.11.1992.
*
*  PARAMETERS :
*  II  NN  NUMBER OF BLOCK COLUMNS OF A.
*  II  PARENT(NN)
*  IA  WN01(NN+1) AUXILIARY VECTOR.
*  IA  SON(NN)
*  IA  ISON(NN)
*  IO  PSTORD(NN)
*
      SUBROUTINE UXVETP(NN,PARENT,WN01,SON,ISON,PSTORD,IND,WN02)
      INTEGER NN,PARENT(NN),WN01(NN),I,IND,WN02(NN),L,K1,J
      INTEGER SON(NN),ISON(NN+1),DAD,PSTORD(NN)
C
      DO 190 I=1,NN
        WN01(I)=0
 190  CONTINUE
C  -----------------------------------------
C  THE NUMBER OF SONS OF INDIVIDUAL PARENTS.
C  -----------------------------------------
      DO 200 I=1,NN
        IF(PARENT(I).NE.0) THEN
          WN01(PARENT(I)) = WN01(PARENT(I)) + 1
        END IF
  200 CONTINUE
C  ---------------------------
C  FIND INDICES OF ARRAY ISON.
C  ---------------------------
      L=1
      DO 300 I=1, NN
        K1=WN01(I)
        ISON(I)=L
        WN01(I)=L
        L=L+K1
  300 CONTINUE
      ISON(NN+1)=L
      WN01(NN+1)=L
C  --------------------------
C  FIND MEMBERS OF ARRAY SON.
C  --------------------------
      DO 400 I=1, NN
        IF(PARENT(I).NE.0) THEN
          SON(WN01(PARENT(I))) = I
          WN01(PARENT(I))=WN01(PARENT(I)) + 1
        END IF
  400 CONTINUE
C  ------------------------
C  CREATE ARRAY PSTORD.
C  ------------------------
      I=0
      DO 700 J=IND,1,-1
        DAD=WN02(J)
  510   IF (ISON(DAD).EQ.ISON(DAD+1).OR.SON(ISON(DAD)).LT.0) THEN
          I=I+1
          PSTORD(I) = DAD
          DAD = PARENT(DAD)
          IF (DAD.EQ.0) GO TO 700
          IF (ISON(DAD).NE.ISON(DAD+1)) THEN
            SON(ISON(DAD)) = -SON(ISON(DAD))
            ISON(DAD) = ISON(DAD) + 1
          END IF
          GO TO 510
        END IF
        DAD = SON(ISON(DAD))
        GO TO 510
  700 CONTINUE
C  ----
C  END.
C  ----
      RETURN
      END
