* SUBROUTINE UXVSCG                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING A VECTOR WITH INCREMENTS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT  VECTOR.
*  RO  Y(N)  OUTPUT  VECTOR.
*  II  K  INCREMENT.
*
      SUBROUTINE UXVSCG(N,A,X,Y,K)
      INTEGER N,K
      $FLOAT  A,X(*),Y(*)
      INTEGER I,J
      IF (K.EQ.1) THEN
      DO 1 I=1,N
      Y(I)=A*X(I)
    1 CONTINUE
      ELSE
      I=1
      DO 2 J=1,N
      Y(I)=A*X(I)
      I=I+K
    2 CONTINUE
      ENDIF
      RETURN
      END
