* FUNCTION UYSRT1                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  SORTS AN ARRAY RA OF LENGTH N INTO ASCENDING ORDER USING
*  THE HEAPSORT ALGORITHM.
*
* PARAMETERS :
*  II  N  LENGTH OF ARRAY RA.
*  RU  RA  ARRAY WITH VALUES.
*
* METHOD :
*  HEAPSORT.
*
      SUBROUTINE UYSRT1(N,RA)
      INTEGER N
      $FLOAT RA(N)
      INTEGER I,J,L,IR
      $FLOAT RRA
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END
