$INTERFACE UYTRTS                                             98/12/01

  CALL UYTRTS(NF,N,$H,$SNN,$SN)
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$SNN($NF)\$SN($NF)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRTS                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALED DIRECTION VECTOR IS BACK TRANSFORMED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  H(NF*(NF+1)/2)  SCALING MATRIX.
*  RI  SN(NF)  TRANSFORMED DIRECTION VECTOR.
*  RO  S(NF)  DIRECTION VECTOR.
*
* SUBPROGRAMS USED :
*  S   UXDPGB  BACK SUBSTITUTION.
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UYTRTS(NF,N,H,SN,S)
      INTEGER NF,N
      $FLOAT H(NF*(NF+1)/2),SN(NF),S(NF)
      CALL UXVCOP(N,SN,S)
      CALL UXDPGB(N,H,S,-1)
      RETURN
      END
